/*
 * @file Member ID Definition of Group WAN Bonding 
 *
 * Moderator: tt_lin
 * Group ID: 0x00B200/0x80B200
 */

#ifndef _CSID_WANBONDING_H
#define _CSID_WANBONDING_H

#include "csid_gid.h"

#define _CFG_WANBONDING(x)		(CSID_GIDC_WANBONDING|(x))
#define _STA_WANBONDING(x)		(CSID_GIDS_WANBONDING|(x))

/* Extra Definitions */




#define CSID_C_WANBONDING_ENABLE		_CFG_WANBONDING(0x0001)   //T=u32,D=0,WAN Bonding enable, 0:disable, 1:enable

/* Wan Bonding interface, the max I/F is 32(0x20)*/
#define CSID_C_WANBONDING_IF_ID_LIST		_CFG_WANBONDING(0x0010)	//T=u32, D=0,index of Bonding I/F fo list
#define CSID_C_WANBONDING_IF_NAME_LIST		_CFG_WANBONDING(0x0040)	//T=str, D=0,bonding name fo list
#define CSID_C_WANBONDING_IF_REMOTE_SUBNET_LIST	_CFG_WANBONDING(0x0060)	//T=ipv4,    bonding remote Subnet fo list
#define CSID_C_WANBONDING_IF_OPMODE_LIST	_CFG_WANBONDING(0x0080)	//T=u32, D=0,binding op-mode fo list, 0: balance-rr, 1:active-backup, 2:blanace-xor, 3:broadcast																																		
#define CSID_C_WANBONDING_IF_ENCRY_MODE_LIST	_CFG_WANBONDING(0x00A0)	//T=u32, D=0,bonding encry-mode fo list, 0: AES-128, 1:None
#define CSID_C_WANBONDING_IF_ENCRY_KEY_LIST	_CFG_WANBONDING(0x00C0)	//T=str, D=0,bonding encry-key fo list, active when encry-mode=AES128.
#define CSID_C_WANBONDING_IF_KEPP_ALIVE_LIST	_CFG_WANBONDING(0x00D0)	//T=u32, D=1,bonding keep-alive fo list, 0: disable, 1: enable
#define CSID_C_WANBONDING_IF_ENABLE_LIST	_CFG_WANBONDING(0x00F0)	//T=u32, D=1,bonding enble-rule fo list, 0: disable, 1: enable

/* Bonding-slave list(pool type, pool size: 0xFF) */
#define CSID_C_WANBONDING_SLAVE_IF_ID_LIST		_CFG_WANBONDING(0x0110)	//T=u32, D=0, slave ID fo list
#define CSID_C_WANBONDING_SLAVE_IF_REFID_LIST		_CFG_WANBONDING(0x0210)	//T=u32, D=FF,Ref to which bonding-ID fo list, this slave is refed by which bonding I/F. FF: without any reference.
#define CSID_C_WANBONDING_SLAVE_IF_LOCALIF_LIST		_CFG_WANBONDING(0x0310)	//T=str,     slave interface of the local router fo list
#define CSID_C_WANBONDING_SLAVE_IF_PRIORITY_LIST	_CFG_WANBONDING(0x0410)	//T=u32, D:1, the connection priority of slave interface fo list, 0:disale, 1:H, 2:M, 3:L
#define CSID_C_WANBONDING_SLAVE_IF_REMOTEIP_LIST	_CFG_WANBONDING(0x0510)	//T=ipv4,     the remote ip for this slave interface fo list

#endif //_CSID_WANBONDING_H

