/* Wireless Client list & Wired Client list */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "csman.h"
#include "csid/csid_wlanap.h"
#include "csid/csid_wlanap2.h"
#include "csid/csid_dhcp.h"
#ifdef _HANDLE_DHCPD_LIST_ARP_DETECT_CLIENT
#include "csid/csid_local.h"
#include <netinet/in.h>

#include<sys/socket.h>    //socket 
#include<arpa/inet.h> //inet_addr 
#include <net/if.h>
#include <netinet/if_ether.h>
#include <linux/sockios.h>

int check_arp=0;
int count_r=0;
int	ioctl_sock;
int opt_d = 0;



#define ARP_FRAME_TYPE 0x0806
#define ETHER_HW_TYPE 1
#define IP_PROTO_TYPE 0x0800
#define OP_ARP_REQUEST	1
#define OP_ARP_REPLY	2
#endif
#define MAC_LEN			6
#define	ENTRY_NUM		256
int reorder[ENTRY_NUM];

unsigned char zmac[MAC_LEN]={0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
unsigned char fmac[MAC_LEN]={0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};

/* 
 * Store the wlan client mac address.
 * Because wlan client would leave from AP, but be recognized of wired client.
 */

#ifdef _HANDLE_DHCPD_LIST_ARP_DETECT_CLIENT 
void add_one_wlan_mac (int csmfd, unsigned char *mac)
{
	int i;
	unsigned char gmac[MAC_LEN];

	// Insert to our defined CSID
	for (i=0; i<ENTRY_NUM; i++) {
		if(read_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+i), gmac, sizeof(gmac), CSM_R_ZERO) < 0)
		{
       char test[150]; 
       write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+i), zmac, MAC_LEN, 0);
       sprintf(test,"echo COLIN may be ERROR i=%d gmac=%02x:%02x:%02x:%02x:%02x:%02x >>/tmp/colin",i,gmac[0],gmac[1],gmac[2],gmac[3],gmac[4],gmac[5]);
       system(test);
       memset(test,'\0',sizeof(test));
      //	break;
    }
		

		if (!memcmp(gmac, zmac, MAC_LEN)) {
			// zero mac, last one! add it!
			//printf("%s %d ---- insert[%d]: %02x:%02x:%02x:%02x:%02x:%02x\n", 
			//		__FILE__, __LINE__, i, mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
			write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+i), mac, MAC_LEN, 0);
			
			// The last record is 00-00-00-00-00-00
			write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+i+1), zmac, MAC_LEN, 0);
			break;
		} else if (!memcmp(mac, gmac, MAC_LEN)) {
			// Match! It's already in the csid, discard.
			//printf("%s %d ---- Match![%d] %02x:%02x:%02x:%02x:%02x:%02x\n", 
			//		__FILE__, __LINE__, i,gmac[0],gmac[1],gmac[2],gmac[3],gmac[4],gmac[5]);
			break;
		}
	}

	// Full!
	if (i == ENTRY_NUM) {
		// discard this one.
		return;
	}
} 
#else 
void add_one_wlan_mac (int csmfd, unsigned char *mac)
{
	int i;
	unsigned char gmac[MAC_LEN];

	// Insert to our defined CSID
	for (i=0; i<ENTRY_NUM; i++) {
		if(read_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+i), gmac, sizeof(gmac), CSM_R_ZERO) < 0)
			break;

		if (!memcmp(gmac, zmac, MAC_LEN)) {
			// zero mac, last one! add it!
			//printf("%s %d ---- insert[%d]: %02x:%02x:%02x:%02x:%02x:%02x\n", 
			//		__FILE__, __LINE__, i, mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);
			write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+i), mac, MAC_LEN, 0);
			
			// The last record is 00-00-00-00-00-00
			write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+i+1), zmac, MAC_LEN, 0);
			break;
		} else if (!memcmp(mac, gmac, MAC_LEN)) {
			// Match! It's already in the csid, discard.
			//printf("%s %d ---- Match![%d] %02x:%02x:%02x:%02x:%02x:%02x\n", 
			//		__FILE__, __LINE__, i,gmac[0],gmac[1],gmac[2],gmac[3],gmac[4],gmac[5]);
			break;
		}
	}

	// Full!
	if (i == ENTRY_NUM) {
		// discard this one.
		return;
	}
}
#endif
/* 
	Get the whole wlan client mac from CSID_S_WLANAP_CLILIST_MAC 
	and write it into CSID_S_DHCP_SVR_CLILIST_WLAN.
*/
void merge_wlan_mac (int csmfd)
{
	int j;
	unsigned char wmac[MAC_LEN];

	/* add to CSID_S_DHCP_SVR_CLILIST_WLAN */
	for(j=0; j<ENTRY_NUM; j++) {
		if(read_csman(csmfd, CSID_S_WLANAP_CLILIST_MAC+j, wmac, sizeof(wmac), CSM_R_ZERO) < 0) {
			break;
		} 
		
		// zero mac, last one!
		if (!memcmp(wmac, zmac, MAC_LEN))
			break;

		add_one_wlan_mac (csmfd, wmac);
	}
	/* For Dual Band Model */
	for(j=0; j<ENTRY_NUM; j++) {
		if(read_csman(csmfd, CSID_S_WLANAP2_CLILIST_MAC+j, wmac, sizeof(wmac), CSM_R_ZERO) < 0) {
			break;
		} 
		
		// zero mac, last one!
		if (!memcmp(wmac, zmac, MAC_LEN))
			break;

		add_one_wlan_mac (csmfd, wmac);
	}
}

/*
	Let
			MAC0 MAC1 FF:FF:FF:FF:FF:FF MAC2 MAC3
	bubble sort to
			MAC0 MAC1 MAC2 MAC3 FF:FF:FF:FF:FF:FF 00:00:00:00:00:00
									j-1					j
	delete j-1 and j items
			MAC0 MAC1 MAC2 MAC3

	i:smac
	0 1 2 3 4 5 ... ENTRY_NUM
		 i-->
		 |j-->
*/
void update_wlan_mac (int csmfd)
{
	int i, j;
	unsigned char smac[MAC_LEN], emac[MAC_LEN];

	for (i=0; i<ENTRY_NUM; i++) {
		if(read_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+i), smac, sizeof(smac), CSM_R_ZERO) >= 0) {
			if (!memcmp(smac, zmac, MAC_LEN)) {
				// zero mac, last one!
				break;
			} else if (!memcmp(smac, fmac, MAC_LEN)) {
				// FF:FF:FF:FF:FF:FF fmac, must shift the following items.
				for (j=(i+1); j<ENTRY_NUM; j++) {
					if(read_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+j), emac, sizeof(emac), CSM_R_ZERO) >= 0) {
					//printf("%s %d ----[%d] %02x:%02x:%02x:%02x:%02x:%02x\n", 
					//		__FILE__, __LINE__, j, emac[0],emac[1],emac[2],emac[3],emac[4],emac[5]);
						if (!memcmp(smac, zmac, MAC_LEN)) {
							// zero mac, last one! delete it!
							write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+j), zmac, sizeof(zmac), CSM_W_RMID);
							// FF:FF:FF:FF:FF:FF is the last two.
							write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+j-1), zmac, sizeof(zmac), CSM_W_RMID);
							break;
						}

						// move items
						write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+j-1), emac, sizeof(emac), 0);
						write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+j), fmac, sizeof(fmac), 0);
					} else {
						break;
					}
				} // for j
			}
		}
	} // for i
}

#ifdef _HANDLE_DHCPD_LIST_ARP_DETECT_CLIENT
void reorder_dhcplist(int csmfd)
{     int point=0;
      char test[100];
	    struct in_addr s_ip;
	    unsigned char clientmac[MAC_LEN];
///*
             for(point=0; point<ENTRY_NUM; point++)
              {
                if(reorder[point]>0)
                {               
                  //=== use location shift to delete csid=========//
                  read_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_IP+point), &s_ip, sizeof(s_ip), CSM_R_ZERO);
                  write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_IP+(point-reorder[point])), &s_ip, sizeof(s_ip)+1, CSM_R_ZERO);
                  //sprintf(test,"echo test CSID_S_DHCP_SVR_CLILIST_IP >>/tmp/colin");
                  //system(test);
                  //memset(test,'\0',sizeof(test));
                     
                  char hostname[30];
                  memset(hostname,'\0',sizeof(hostname));
                  read_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_HOSTNAME+point), hostname, sizeof(hostname), 0);
                  write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_HOSTNAME+(point-reorder[point])), hostname, sizeof(hostname)+1, 0);
                
                  //sprintf(test,"echo test CSID_S_DHCP_SVR_CLILIST_HOSTNAME >>/tmp/colin");
                  //system(test);
                  //memset(test,'\0',sizeof(test));
                
                  int leasetime,type;
                  read_csman(csmfd,(CSID_S_DHCP_SVR_CLILIST_LEASETIME+point),&leasetime,sizeof(leasetime),CSM_R_ZERO);
                  write_csman(csmfd,(CSID_S_DHCP_SVR_CLILIST_LEASETIME+(point-reorder[point])),&leasetime,sizeof(leasetime),CSM_R_ZERO); 
                
                  //sprintf(test,"echo test CSID_S_DHCP_SVR_CLILIST_LEASETIME >>/tmp/colin");
                  //system(test);
                  //memset(test,'\0',sizeof(test));
                
                  read_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_TYPE+point),&type,sizeof(type),CSM_R_ZERO);
                  write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_TYPE+(point-reorder[point])),&type,sizeof(type),CSM_R_ZERO); 
                
                  //sprintf(test,"echo test CSID_S_DHCP_SVR_CLILIST_TYPE >>/tmp/colin");
                  //system(test);
                 // memset(test,'\0',sizeof(test));
             
                  memset(clientmac, 0, sizeof(clientmac));
                  read_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+point), clientmac, MAC_LEN, 0);
                  write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+(point-reorder[point])), clientmac, MAC_LEN, 0);
                
                  //sprintf(test,"echo test CSID_S_DHCP_SVR_CLILIST_WLAN >>/tmp/colin");
                  //system(test);
                  //memset(test,'\0',sizeof(test));
               
                  memset(clientmac, 0, sizeof(clientmac));
                  read_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_MAC+point), clientmac, MAC_LEN, 0);
                  write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_MAC+(point-reorder[point])), clientmac, MAC_LEN, 0);
                  //sprintf(test,"echo cover point=%d by use clientmac=%02x:%02x:%02x:%02x:%02x:%02x >>/tmp/colin",point,clientmac[0],clientmac[1],clientmac[2],clientmac[3],clientmac[4],clientmac[5]);
                  //sprintf(test,"echo cover point=%d >>/tmp/colin",point);
                  //system(test);
                  //memset(test,'\0',sizeof(test));
                  if (!memcmp(clientmac, zmac, MAC_LEN)) {
			               //sprintf(test,"echo cover continue point=%d by use clientmac=%02x:%02x:%02x:%02x:%02x:%02x>>/tmp/colin",point,clientmac[0],clientmac[1],clientmac[2],clientmac[3],clientmac[4],clientmac[5]);
                     //system(test);
                    // memset(test,'\0',sizeof(test));      
			               //sprintf(test,"echo cover continue point=%d  >>/tmp/colin",point);
                     //system(test);
                     //memset(test,'\0',sizeof(test));    
                     break;
		              }
		             }
		           }
		          // */

}
 //===use arp to update dhcp client list start==============//
void use_arp_to_update_dhcp_client_list(int csmfd)
{
   ///*
	  char shellline[100]; 
	  char test[100];
	  //char ip[30];
	  FILE *shellout;
	  unsigned char clientmac[MAC_LEN];
	  //unsigned char ipaddr[4];	  
	  char DestIP[INET_ADDRSTRLEN];
	  //char temp[25];
	  
	  //memset(temp,'\0',sizeof(temp));
	  memset(test,'\0',sizeof(test));  
	  memset(clientmac, 0, sizeof(clientmac));
	  //memset(ipaddr, 0, sizeof(ipaddr));
	  char zeroip[INET_ADDRSTRLEN];
	  memset(zeroip,'\0',sizeof(zeroip));
	  strncpy(zeroip,"0.0.0.0",INET_ADDRSTRLEN);
	  //char *find;
	  //char *result = NULL;
    //char delims2[] = ":";	  
	  struct in_addr s_ip;//,t_ip
	  int jj = 0,ii=0;//,check=0,point
	
	  ///*
	  for(ii=0; ii<ENTRY_NUM; ii++)
	  {
      reorder[ii]=0;
    }
    count_r=0;
	  for(ii=0; ii<ENTRY_NUM; ii++)
	  {
	    
		  if(read_csman(csmfd, CSID_S_DHCP_SVR_CLILIST_IP+ii, &s_ip, sizeof(s_ip), CSM_R_ZERO)>=0)
			{               
         // memset(shellline,'\0',sizeof(shellline)); 
		     // sprintf(shellline,"echo create arp >>/tmp/arp_data");
		     // system(shellline);
		      //usleep(50);     
          //sprintf(test,"echo start ii=%>>/tmp/colin",ii);
          //system(test);
          //memset(test,'\0',sizeof(test));     
          memset(DestIP,'\0',sizeof(DestIP));                 
			    inet_ntop(AF_INET, &s_ip, DestIP, INET_ADDRSTRLEN); 
			    
			    
          //reorder
          //last one 
          if (!strcmp(DestIP, zeroip)) {
			         //sprintf(test,"echo break ii=%d >>/tmp/colin",ii);
              // system(test);
              // memset(test,'\0',sizeof(test));
               reorder_dhcplist(csmfd);
			       break;
		       }      
		      //memset(shellline,'\0',sizeof(shellline)); 
		     // sprintf(shellline,"echo create arp >>/tmp/arp_data");
		     // system(shellline);
		      //usleep(50);
		      FILE *shellout=NULL;
		     // shellout = fopen("/tmp/arp_data","r"); 
		    
		      memset(shellline,'\0',sizeof(shellline)); 
		      sprintf(shellline,"send_arp br0 %s &",DestIP);
		      //sprintf(test,"echo client ip is :%s ii=%d ready to check>>/tmp/colin",DestIP,ii);
          //system(test);
          //memset(test,'\0',sizeof(test));
			    system(shellline);		  
            
          shellout = fopen("/tmp/arp_data","r");  
			    //while(shellout!=NULL)
			    while(shellout==NULL)
			    {
             shellout = fopen("/tmp/arp_data","r");
             //usleep(50);
             /*
            //==below code no delete, it is a watting time action==//
             sprintf(test,"echo do open file ii=%>>/tmp/colin1",ii);
             system(test);
             memset(test,'\0',sizeof(test));
             system("rm /tmp/colin1");*/
          }
          if(shellout!=NULL)
              system("rm /tmp/arp_data");
			    //usleep(150);
			    read_csman(csmfd, CSID_S_DHCP_CHECK_ARP,&check_arp,sizeof(check_arp),CSM_R_ZERO);
          //sprintf(test,"echo client ip is :%s ii=%d check_arp=%d>>/tmp/colin",DestIP,ii,check_arp);
          //system(test);
          //memset(test,'\0',sizeof(test)); 
          
             if(check_arp==0)
             {
                reorder[ii]=-1;// record this csid was deleted
                count_r++;
                int p=ii;
                p++;//next
                while(p!=ENTRY_NUM)
                {
                   reorder[p]=count_r;//how many location which this csid must shift 
                   p++;
                }
                
                
              }
             }
             
	       }
    
	   //sprintf(test,"echo end of update client list >>/tmp/colin");
    // system(test);
    // memset(test,'\0',sizeof(test)); 

}

	//===use arp to update dhcp client list end==============//
#endif
int main (void)
{
	unsigned int i, j=0, csmfd;
	unsigned char wired[MAC_LEN], wlan[MAC_LEN];
	int num=0;// num=0: wired, num=1: wireless

	/* get the latest wlan client mac, and store them in CSID_S_WLANAP_CLILIST_MAC. */
	system("wcli_list 24G");
	/* For 2.4G wifi on Dual Band Model, store them in CSID_S_WLANAP2_CLILIST_MAC. */
	system("wcli_list 5G");

	csmfd = open_csman(NULL,0);

	/* Add WLAN mac address to CSID_S_DHCP_SVR_CLILIST_WLAN. */
	merge_wlan_mac (csmfd);

	/* Set all dhcp clients to be wired, and check the wireless later. */
	num = 0; // wired
	for(i=0; i<ENTRY_NUM; i++) {
		if( read_csman(csmfd, CSID_S_DHCP_SVR_CLILIST_MAC+i, wired, sizeof(wired), CSM_R_ZERO) >= 0) {
			write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_TYPE+i), &num, sizeof(num), 0);
		} else {
			break;
		}

		if (!memcmp(wired, zmac, MAC_LEN)) {
			//printf("%s %d ----[%d] %02x:%02x:%02x:%02x:%02x:%02x\n",
			//		__FILE__, __LINE__, i, zmac[0],zmac[1],zmac[2],zmac[3],zmac[4],zmac[5]);
			break;
		}
	}
	

	num = 1; // wireless
	for(i=0; i<ENTRY_NUM; i++) {
		if(read_csman(csmfd, CSID_S_DHCP_SVR_CLILIST_WLAN+i, wlan, sizeof(wlan), CSM_R_ZERO) < 0) {
			//printf("%s %d ---- [%d] %02x:%02x:%02x:%02x:%02x:%02x\n",
			//		__FILE__, __LINE__, i, wlan[0],wlan[1],wlan[2],wlan[3],wlan[4],wlan[5]);
			break;
		}

		// last one
		if (!memcmp(wlan, zmac, MAC_LEN)) {
			//printf("%s %d ---- [%d] last one\n", __FILE__, __LINE__, i);
			break;
		}

		//printf("%s %d ---- [%d] %02x:%02x:%02x:%02x:%02x:%02x\n", 
		//		__FILE__, __LINE__, i,wlan[0],wlan[1],wlan[2],wlan[3],wlan[4],wlan[5]);
		for (j=0; j<ENTRY_NUM; j++) {
			if(read_csman(csmfd, CSID_S_DHCP_SVR_CLILIST_MAC+j, wired, sizeof(wired), CSM_R_ZERO) < 0) {
				// Not found, means wlan client is disappear, delete it!
				// We set it to be FF:FF:FF:FF:FF:FF
				//printf("%s %d ---- delete: [%d] %02x:%02x:%02x:%02x:%02x:%02x\n", 
				//		__FILE__, __LINE__, j, wired[0],wired[1],wired[2],wired[3],wired[4],wired[5]);
				write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_WLAN+i), fmac, sizeof(fmac), 0);
				break;
			}

			// last one
			if (!memcmp(wired, zmac, MAC_LEN)) {
				//printf("%s %d ---- [%d] last one\n", __FILE__, __LINE__, j);
				break;
			}

			if ( !memcmp(wlan, wired, MAC_LEN) ) {
				// Found it, it's wireless!
				//printf("%s %d ---- wlan: [%d] %02x:%02x:%02x:%02x:%02x:%02x\n", 
				//		__FILE__, __LINE__, j, wlan[0],wlan[1],wlan[2],wlan[3],wlan[4],wlan[5]);
				write_csman(csmfd, (CSID_S_DHCP_SVR_CLILIST_TYPE+j), &num, sizeof(num), 0);
				break;
			}
		}
	}

#ifdef _HANDLE_DHCPD_LIST_ARP_DETECT_CLIENT
   use_arp_to_update_dhcp_client_list(csmfd);
#endif
	/* Update our WLAN mac address structure. */
	/* Wuming , It shouldn't be happened */
	//update_wlan_mac (csmfd);

	close_csman(csmfd);
	return 0;
}

