#include "sync_list.h"

int read_cs_list(void)
{
	int csman_fd;
	int clr_cnt=0;
	unsigned int cur_cli_cnt=0, max_cli_cnt=0;
	unsigned char macaddr[16],zero_mac[16];
	unsigned int ipaddr;
	unsigned int i;
	
	csman_fd=open_csman(NULL, 0);
	if( csman_fd <0 )
	{
		perror("could not open Csman");
		return 0;	
	}

	read_csman(csman_fd, CSID_C_DHCP_SVR_MAXLEASE, &max_cli_cnt, sizeof(unsigned int), CSM_R_ZERO);

	//LOG(LOG_INFO,"max_cli=%d\n",max_cli_cnt);
	
	for(i=0;i<max_cli_cnt;i++)
	{
		read_csman(csman_fd, CSID_S_DHCP_SVR_CLILIST_IP+i, &ipaddr,sizeof(ipaddr), CSM_R_ZERO);
		if(ipaddr!=0)
		{
			cur_cli_cnt++;
		}
	}

	memset(zero_mac, 0x00, sizeof(zero_mac));
	for(i=0;i<cur_cli_cnt;i++)
	{
		//initial variable
		memset(macaddr, 0x00, sizeof(macaddr));
		read_csman(csman_fd, CSID_S_DHCP_SVR_CLILIST_MAC+i, macaddr, 6, 0);
		ipaddr = 0;
		read_csman(csman_fd, CSID_S_DHCP_SVR_CLILIST_IP+i,  &ipaddr, 4, 0);
	
		if((memcmp(zero_mac, macaddr, sizeof(zero_mac)) == 0)&&(ipaddr!=0)) 
		{
			clear_lease(macaddr,ipaddr);
			clr_cnt++;
			//LOG(LOG_INFO,"release ip=%x\n",ipaddr);
		}
	}


	close_csman(csman_fd);
	return clr_cnt;
}


int sync_list(void)
{
	int clr_cnt;
	
	clr_cnt=read_cs_list();

	//LOG(LOG_INFO,"clr_cnt=%d\n",clr_cnt);
	return 0;
}
