/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "dfgroup.h"
#include "csman.h"

static unsigned char dfindex;

/* 
 * dfgroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

#ifdef SNMP_CUSTOMER_ID //netcom
    //#error 11
    oid dfgroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,9 };   
#else                    //amit
    //#error 00
    oid dfgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,9 };    
#endif

//oid dfgroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,9 };
//oid dfgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,9 };


/* 
 * variable4 dfgroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the dfgroup mib section 
 */


struct variable4 dfgroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { DOMAINFILTERSWITCH  , ASN_INTEGER   , RWRITE, var_dfgroup, 1, { 1 } },
  { LOGDNSSWITCH        , ASN_INTEGER   , RWRITE, var_dfgroup, 1, { 2 } },
  { PRIVILEGEDIPSTART   , ASN_INTEGER   , RWRITE, var_dfgroup, 1, { 3 } },
  { PRIVILEGEDIPEND     , ASN_INTEGER   , RWRITE, var_dfgroup, 1, { 4 } },
  { DFDOMAIN            , ASN_OCTET_STR , RWRITE, var_dFTable, 3, { 5,1,1 } },
  { DFDROPSWITCH        , ASN_INTEGER   , RWRITE, var_dFTable, 3, { 5,1,2 } },
  { DFLOGSWITCH         , ASN_INTEGER   , RWRITE, var_dFTable, 3, { 5,1,3 } },
  { DFRULESWITCH        , ASN_INTEGER   , RWRITE, var_dFTable, 3, { 5,1,4 } },
  { DFINDEX             , ASN_INTEGER   , RWRITE, var_dFTable, 3, { 5,1,5 } },
  { DFRULE10DROPSWITCH  , ASN_INTEGER   , RWRITE, var_dfgroup, 1, { 6 } },
  { DFRULE10LOGSWITCH   , ASN_INTEGER   , RWRITE, var_dfgroup, 1, { 7 } },
};
/*    (L = length of the oidsuffix) */


/*
 * init_dfgroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_dfgroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("gateway/dfgroup", dfgroup_variables, variable4,
               dfgroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_dfgroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_dfgroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case DFRULE10LOGSWITCH:
		{
			*write_method = write_dFRule10LogSwitch;
			long_ret = 0;
			return (unsigned char *) &long_ret;
		}

    case DFRULE10DROPSWITCH:
		{
			*write_method = write_dFRule10DropSwitch;
			long_ret = 0;
			return (unsigned char *) &long_ret;
		}

    case PRIVILEGEDIPEND:
		{
			*write_method = write_privilegedIPend;
			int ret = 0;
			int fd=0;
			unsigned char ip_end;
			ret = read_csman(fd,0x000f0004,&ip_end,sizeof(unsigned char),TYPE_U32);
			long_ret = ip_end;
			return (unsigned char *) &long_ret;
		}
			
    case PRIVILEGEDIPSTART:
		{
			*write_method = write_privilegedIPstart;
			int ret = 0;
			int fd=0;
			unsigned char ip_start;
			ret = read_csman(fd,0x000f0003,&ip_start,sizeof(unsigned char),TYPE_U32);
			long_ret = ip_start;
			return (unsigned char *) &long_ret;
		}

    case LOGDNSSWITCH:
		{
			*write_method = write_logDNSSwitch;
			int ret = 0;
			int fd=0;
			unsigned char logdnsswitch;
			ret = read_csman(fd,0x000f0002,&logdnsswitch,sizeof(unsigned char),TYPE_U32);
			long_ret = logdnsswitch;
			return (unsigned char *) &long_ret;
		}

    case DOMAINFILTERSWITCH:
		{
			*write_method = write_domainFilterSwitch;
			int ret = 0;
			int fd=0;
			unsigned char dfswitch;
			ret = read_csman(fd,0x000f0001,&dfswitch,sizeof(unsigned char),TYPE_U32);
			long_ret = dfswitch;
			return (unsigned char *) &long_ret;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}


/*
 * var_dFTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_dfgroup above.
 */
unsigned char *
var_dFTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
  if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case DFINDEX:
		{
			*write_method = write_dFindex;
			long_ret = dfindex;
			return (unsigned char *) &long_ret;
		}

    case DFRULESWITCH:
		{
			*write_method = write_dFRuleSwitch;
			int ret = 0;
			int fd=0;
			unsigned char rule_switch;
			ret = read_csman(fd,0x000f4000+dfindex,&rule_switch,sizeof(unsigned char),TYPE_U32);
			long_ret = rule_switch;
			return (unsigned char *) &long_ret;
		}

    case DFLOGSWITCH:
		{
			*write_method = write_dFLogSwitch;
			int ret = 0;
			int fd=0;
			unsigned char log_switch;
			ret = read_csman(fd,0x000f3000+dfindex,&log_switch,sizeof(unsigned char),TYPE_U32);
			long_ret = log_switch;
			return (unsigned char *) &long_ret;
		}

    case DFDROPSWITCH:
		{
			*write_method = write_dFDropSwitch;
			int ret = 0;
			int fd=0;
			unsigned char drop_switch;
			ret = read_csman(fd,0x000f2000+dfindex,&drop_switch,sizeof(unsigned char),TYPE_U32);
			long_ret = drop_switch;
			return (unsigned char *) &long_ret;
		}

    case DFDOMAIN:
		{
			*write_method = write_dFDomain;
			int ret = 0;
			int fd=0;
			unsigned char dfdomain[512];
			
			memset(dfdomain,0,sizeof(dfdomain));
			ret = read_csman(fd,0x000f1000+dfindex,dfdomain,sizeof(dfdomain),TYPE_STR);
	
			strcpy(string,dfdomain);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}




int
write_dFRule10LogSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dFRule10LogSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dFRule10LogSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_dFRule10DropSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dFRule10DropSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dFRule10DropSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_dFindex(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dFindex not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dFindex: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  dfindex = long_ret;
			  printf("dfindex = %d\n",dfindex);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dFRuleSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dFRuleSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dFRuleSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000f4000+dfindex,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dFLogSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dFLogSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dFLogSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000f3000+dfindex,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dFDropSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dFDropSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dFDropSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000f2000+dfindex,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dFDomain(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to dFDomain not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to dFDomain: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val );


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x000f1000+dfindex,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_privilegedIPend(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to privilegedIPend not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to privilegedIPend: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000f0004,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_privilegedIPstart(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to privilegedIPstart not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to privilegedIPstart: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000f0003,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_logDNSSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to logDNSSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to logDNSSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000f0002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_domainFilterSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to domainFilterSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to domainFilterSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x000f0001,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}






