/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "dmzgroup.h"
#include "csman.h"


/* 
 * dmzgroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

#ifdef SNMP_CUSTOMER_ID //netcom
    //#error 11
    oid dmzgroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,14 };   
#else                    //amit
    //#error 00
    oid dmzgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,14 };       
#endif

//oid dmzgroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,14 };
//oid dmzgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,14 };


/* 
 * variable2 dmzgroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the dmzgroup mib section 
 */


struct variable2 dmzgroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { DMZIP               , ASN_IPADDRESS   , RWRITE, var_dmzgroup, 1, { 1 } },
  { DMZFUNCTIONSWITCH   , ASN_INTEGER   , RWRITE, var_dmzgroup, 1, { 2 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_dmzgroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_dmzgroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("gateway/dmzgroup", dmzgroup_variables, variable2,
               dmzgroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_dmzgroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_dmzgroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case DMZFUNCTIONSWITCH:
		{
			*write_method = write_dMZFunctionSwitch;
			int ret = 0;
			int fd=0;
			unsigned char dmz_switch;
			ret = read_csman(fd,0x00150008,&dmz_switch,sizeof(unsigned char),TYPE_U32);
			printf("dmz_switch = %u\n",dmz_switch);
			long_ret = dmz_switch;
			return (unsigned char *) &long_ret;
		}

    case DMZIP:
		{
			*write_method = write_dMZip;
			int ret = 0;
			int fd=0;
			unsigned char dmzip[4];
			memset(dmzip,0,sizeof(dmzip));
			ret = read_csman(fd,0x00150009,dmzip,sizeof(dmzip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=dmzip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			//        *string = 0;
			*var_len = strlen(string);
			return (unsigned char *) string;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}





int
write_dMZFunctionSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dMZFunctionSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dMZFunctionSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  int altered=1;			  
			  ret=write_csman(fd,0x00150008,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  ret = write_csman(fd, 0x00150002, &altered, sizeof(int) ,TYPE_U32); 
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dMZip(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to dMZip not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to dMZip: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          //string = (char *) var_val;
		  strcpy(string,(char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  int altered=1;
			  ret=write_csman(fd,0x00150009,string,strlen(string) ,TYPE_IPV4);
			  ret = write_csman(fd, 0x00150002, &altered, sizeof(int) ,TYPE_U32); 
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}






