/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */

#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>

#endif /* !IN_UCD_SNMP_SOURCE */


#include "langroup.h"
#include "csman.h"


/* 
 * langroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

#ifdef SNMP_CUSTOMER_ID //netcom
   // #error 11
    oid langroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,3 };   
#else                    //amit
   // #error 00
    oid langroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,3 };   
#endif

//oid langroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,3 };

//oid langroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,3 };


/* 
 * variable2 langroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the langroup mib section 
 */


struct variable2 langroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { LANIPADDRESS        , ASN_IPADDRESS , RWRITE, var_langroup, 1, { 1 } },
  { LANNMADDRESS        , ASN_IPADDRESS   , RWRITE, var_langroup, 1, { 2 } },
  { LANDHCPFUNCTIONSWITCH, ASN_INTEGER   , RWRITE, var_langroup, 1, { 3 } },
  { DHCPPOOLSTART       , ASN_IPADDRESS   , RWRITE, var_langroup, 1, { 4 } },
  { DHCPPOOLEND         , ASN_IPADDRESS   , RWRITE, var_langroup, 1, { 5 } },
  { DOMAINSUFFIX        , ASN_OCTET_STR , RWRITE, var_langroup, 1, { 6 } },
  { PRIMDNS             , ASN_IPADDRESS , RWRITE, var_langroup, 1, { 7 } },
  { SECDNS              , ASN_IPADDRESS , RWRITE, var_langroup, 1, { 8 } },
  { PRIMWINS            , ASN_IPADDRESS , RWRITE, var_langroup, 1, { 9 } },
  { SECWINS             , ASN_IPADDRESS , RWRITE, var_langroup, 1, { 10 } },
  { DHCPLEASETIME       , ASN_INTEGER   , RWRITE, var_langroup, 1, { 11 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_langroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_langroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("gateway/langroup", langroup_variables, variable2,
               langroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_langroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_langroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case DHCPLEASETIME:
		{
			*write_method = write_dHCPLeaseTime;
			int ret = 0;
			int fd=0;
			unsigned int wireless_enable;
			ret = read_csman(fd,0x00030002,&wireless_enable,sizeof(unsigned int),TYPE_U32);
			long_ret = wireless_enable;
	        return (unsigned int *) &long_ret;  
		}

    case SECWINS:
		{
			*write_method = write_secWINS;
			int ret = 0;
			int fd=0;
			unsigned char radiussvrip[4];
			memset(radiussvrip,0,sizeof(radiussvrip));
			ret = read_csman(fd,0x00030009,radiussvrip,sizeof(radiussvrip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=radiussvrip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case PRIMWINS:
		{
			*write_method = write_primWINS;
			int ret = 0;
			int fd=0;
			unsigned char radiussvrip[4];
			memset(radiussvrip,0,sizeof(radiussvrip));
			ret = read_csman(fd,0x00030008,radiussvrip,sizeof(radiussvrip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=radiussvrip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case SECDNS:
		{
			*write_method = write_secDNS;
			int ret = 0;
			int fd=0;
			unsigned char radiussvrip[4];
			memset(radiussvrip,0,sizeof(radiussvrip));
			ret = read_csman(fd,0x00030007,radiussvrip,sizeof(radiussvrip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=radiussvrip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case PRIMDNS:
		{
			*write_method = write_primDNS;
			int ret = 0;
			int fd=0;
			unsigned char radiussvrip[4];
			memset(radiussvrip,0,sizeof(radiussvrip));
			ret = read_csman(fd,0x00030006,radiussvrip,sizeof(radiussvrip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=radiussvrip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case DOMAINSUFFIX:
		{
			*write_method = write_domainsuffix;
			int ret = 0;
			int fd=0;
			unsigned char wlanssid[512];
			
			memset(wlanssid,0,sizeof(wlanssid));
			ret = read_csman(fd,0x00030005,wlanssid,sizeof(wlanssid),TYPE_STR);
	
			strcpy(string,wlanssid);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case DHCPPOOLEND:
		{
			*write_method = write_dHCPPoolEnd;
			int ret = 0;
			int fd=0;
			unsigned char poolend[4];
			memset(poolend,0,sizeof(poolend));
			ret = read_csman(fd,0x00030004,poolend,sizeof(poolend),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=poolend[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case DHCPPOOLSTART:
		{    
			*write_method = write_dHCPPoolStart;
			int ret = 0;
			int fd=0;
			unsigned char poolstart[4];
			memset(poolstart,0,sizeof(poolstart));
			ret = read_csman(fd,0x00030003,poolstart,sizeof(poolstart),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=poolstart[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			//        *string = 0;
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case LANDHCPFUNCTIONSWITCH:
		{
			*write_method = write_lANDHCPFunctionSwitch;
			int ret = 0;
			int fd=0;
			unsigned char wireless_enable;
			ret = read_csman(fd,0x00030001,&wireless_enable,sizeof(unsigned char),TYPE_U32);
			long_ret = wireless_enable;
			return (unsigned char *) &long_ret;
		}

    case LANNMADDRESS:
		{
			*write_method = write_lANNMAddress;
			int ret = 0;
			int fd=0;
			unsigned char lanip[4];
			memset(lanip,0,sizeof(lanip));
			ret = read_csman(fd,0x00010005,lanip,sizeof(lanip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=lanip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case LANIPADDRESS:
		{
			*write_method = write_lANIPAddress;
			int ret = 0;
			int fd=0;
			unsigned char lanip[4];
			memset(lanip,0,sizeof(lanip));
			ret = read_csman(fd,0x00010004,lanip,sizeof(lanip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=lanip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			//        *string = 0;
			*var_len = strlen(string);
			return (unsigned char *) string;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}





int
write_dHCPLeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dHCPLeaseTime not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dHCPLeaseTime: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00030002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_secWINS(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to secWINS not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to secWINS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x00193000,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_primWINS(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to primWINS not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to primWINS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x00030008,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_secDNS(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to secDNS not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to secDNS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x00030007,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_primDNS(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to primDNS not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to primDNS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x00030006,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_domainsuffix(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to domainsuffix not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to domainsuffix: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          //string = (char *) var_val;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x00030005,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dHCPPoolEnd(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to dHCPPoolEnd not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to dHCPPoolEnd: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x00030004,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dHCPPoolStart(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to dHCPPoolStart not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to dHCPPoolStart: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x00030003,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_lANDHCPFunctionSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to lANDHCPFunctionSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to lANDHCPFunctionSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00030001,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_lANNMAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to lANNMAddress not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to lANNMAddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x00010005,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_lANIPAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to lANIPAddress not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to lANIPAddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x00010004,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}






