/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>

#endif /* !IN_UCD_SNMP_SOURCE */


#include "sysloggroup.h"
#include "csman.h"


/* 
 * sysloggroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
#ifdef SNMP_CUSTOMER_ID //netcom
    //#error 11
	oid sysloggroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,17 };	   
#else                    //amit
    //#error 00
	oid sysloggroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,17 };	   
#endif

//oid sysloggroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,17 };

//oid sysloggroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,17 };


/* 
 * variable2 sysloggroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the sysloggroup mib section 
 */


struct variable2 sysloggroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { SLIP                , ASN_IPADDRESS   , RWRITE, var_sysloggroup, 1, { 1 } },
  { SLSWITCH            , ASN_INTEGER   , RWRITE, var_sysloggroup, 1, { 2 } },
  { SLEMAILALERTSWITCH  , ASN_INTEGER   , RWRITE, var_sysloggroup, 1, { 3 } },
  { SLSENDEMAILNOWSWITCH, ASN_INTEGER   , RWRITE, var_sysloggroup, 1, { 4 } },
  { SLSMTPSERVERIP      , ASN_OCTET_STR , RWRITE, var_sysloggroup, 1, { 5 } },
  { SLSMTPSERVERPORT    , ASN_INTEGER   , RWRITE, var_sysloggroup, 1, { 6 } },
  { SLTARGETEMAILADDRESS, ASN_OCTET_STR , RWRITE, var_sysloggroup, 1, { 7 } },
  { SLTARGETEMAILSUBJECT, ASN_OCTET_STR , RWRITE, var_sysloggroup, 1, { 8 } },
  { SLTARGETEMAILUSERNAME, ASN_OCTET_STR , RWRITE, var_sysloggroup, 1, { 9 } },
  { SLTARGETEMAILUSERPASSWORD, ASN_OCTET_STR , RWRITE, var_sysloggroup, 1, { 10 } },
  { SLLOGSYSACTIVESWITCH, ASN_INTEGER   , RWRITE, var_sysloggroup, 1, { 11 } },
  { SLLOGDEBUGINFOSWITCH, ASN_INTEGER   , RWRITE, var_sysloggroup, 1, { 12 } },
  { SLLOGATTACKSSWITCH  , ASN_INTEGER   , RWRITE, var_sysloggroup, 1, { 13 } },
  { SLLOGDROPPEDSWITCH  , ASN_INTEGER   , RWRITE, var_sysloggroup, 1, { 14 } },
  { SLLOGNOTICESWITCH   , ASN_INTEGER   , RWRITE, var_sysloggroup, 1, { 15 } },
};
/*    (L = length of the oidsuffix) */


/*
 * init_sysloggroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_sysloggroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("gateway/sysloggroup", sysloggroup_variables, variable2,
               sysloggroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_sysloggroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_sysloggroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;

  memset(string,0,sizeof(string));


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case SLLOGNOTICESWITCH:
        *write_method = write_sLLogNoticeSwitch;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case SLLOGDROPPEDSWITCH:
        *write_method = write_sLLogDroppedSwitch;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case SLLOGATTACKSSWITCH:
        *write_method = write_sLLogAttacksSwitch;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case SLLOGDEBUGINFOSWITCH:
        *write_method = write_sLLogDebugInfoSwitch;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case SLLOGSYSACTIVESWITCH:
        *write_method = write_sLLogSysActiveSwitch;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case SLTARGETEMAILUSERPASSWORD:
		{
			*write_method = write_sLTargetEmailUserPassword;
			int ret = 0;
			int fd=0;
			unsigned char server_ip[512];
			
			memset(server_ip,0,sizeof(server_ip));
			ret = read_csman(fd,0x00080007,server_ip,sizeof(server_ip),TYPE_STR);
	
			strcpy(string,server_ip);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case SLTARGETEMAILUSERNAME:
		{
			*write_method = write_sLTargetEmailUserName;
			int ret = 0;
			int fd=0;
			unsigned char server_ip[512];
			
			memset(server_ip,0,sizeof(server_ip));
			ret = read_csman(fd,0x00080006,server_ip,sizeof(server_ip),TYPE_STR);
	
			strcpy(string,server_ip);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case SLTARGETEMAILSUBJECT:
		{
			*write_method = write_sLTargetEmailSubject;
			int ret = 0;
			int fd=0;
			unsigned char server_ip[512];
			
			memset(server_ip,0,sizeof(server_ip));
			ret = read_csman(fd,0x00080005,server_ip,sizeof(server_ip),TYPE_STR);
	
			strcpy(string,server_ip);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case SLTARGETEMAILADDRESS:
		{
			*write_method = write_sLTargetEmailAddress;
			int ret = 0;
			int fd=0;
			unsigned char server_ip[512];
			
			memset(server_ip,0,sizeof(server_ip));
			ret = read_csman(fd,0x00080004,server_ip,sizeof(server_ip),TYPE_STR);
	
			strcpy(string,server_ip);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case SLSMTPSERVERPORT:
		{
			*write_method = write_sLSMTPServerPort;
			int ret = 0;
			int fd=0;
			unsigned char slswitch;
			ret = read_csman(fd,0x00080002,&slswitch,sizeof(unsigned char),TYPE_U32);
			long_ret = slswitch;
			return (unsigned char *) &long_ret;
		}

    case SLSMTPSERVERIP:
		{
			*write_method = write_sLSMTPServerIP;
			int ret = 0;
			int fd=0;
			unsigned char server_ip[512];
			
			memset(server_ip,0,sizeof(server_ip));
			ret = read_csman(fd,0x00080003,server_ip,sizeof(server_ip),TYPE_STR);
	
			strcpy(string,server_ip);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case SLSENDEMAILNOWSWITCH:
        *write_method = write_sLSendEmailNowSwitch;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case SLEMAILALERTSWITCH:
		{
			*write_method = write_sLEmailAlertSwitch;
			int ret = 0;
			int fd=0;
			unsigned char sleml_switch;
			ret = read_csman(fd,0x00080001,&sleml_switch,sizeof(unsigned char),TYPE_U32);
			long_ret = sleml_switch;
			return (unsigned char *) &long_ret;
		}

    case SLSWITCH:
		{
			*write_method = write_sLSwitch;
			int ret = 0;
			int fd=0;
			unsigned char slswitch;
			ret = read_csman(fd,0x00150020,&slswitch,sizeof(unsigned char),TYPE_U32);
			long_ret = slswitch;
			return (unsigned char *) &long_ret;
		}

    case SLIP:
		{
			*write_method = write_sLIP;
			int ret = 0;
			int fd=0;
			unsigned char slip[4];
			memset(slip,0,sizeof(slip));
			ret = read_csman(fd,0x00150021,slip,sizeof(slip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=slip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			//        *string = 0;
			*var_len = strlen(string);
			return (unsigned char *) string;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}





int
write_sLLogNoticeSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sLLogNoticeSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sLLogNoticeSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLLogDroppedSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sLLogDroppedSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sLLogDroppedSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLLogAttacksSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sLLogAttacksSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sLLogAttacksSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLLogDebugInfoSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sLLogDebugInfoSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sLLogDebugInfoSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLLogSysActiveSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sLLogSysActiveSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sLLogSysActiveSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLTargetEmailUserPassword(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sLTargetEmailUserPassword not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sLTargetEmailUserPassword: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
			  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00080007,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLTargetEmailUserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sLTargetEmailUserName not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sLTargetEmailUserName: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
			  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00080006,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLTargetEmailSubject(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sLTargetEmailSubject not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sLTargetEmailSubject: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
			  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00080005,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLTargetEmailAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sLTargetEmailAddress not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sLTargetEmailAddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  printf("(char *) var_val= %s\n",(char *) var_val);
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00080004,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLSMTPServerPort(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sLSMTPServerPort not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sLSMTPServerPort: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00080002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLSMTPServerIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sLSMTPServerIP not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sLSMTPServerIP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00080003,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLSendEmailNowSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sLSendEmailNowSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sLSendEmailNowSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLEmailAlertSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sLEmailAlertSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sLEmailAlertSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00080001,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sLSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sLSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00150020,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sLIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to sLIP not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sLIP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  strcpy(string,(char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x00150021,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}






