/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "DHCPServer.h"
#include "csman.h"

int w_index=0;

/* 
 * DHCPServer_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

#ifdef SNMP_CUSTOMER_ID //netcom
oid DHCPServer_variables_oid[] = { 1,3,6,1,4,1,851,2,3,9,2,4,1 };
#else
oid DHCPServer_variables_oid[] = { 1,3,6,1,4,1,12823,2,3,9,2,4,1 };
#endif

/* 
 * variable7 DHCPServer_variables:
 *   this variable defines function callbacks and type return information 
 *   for the DHCPServer mib section 
 */

struct variable7 DHCPServer_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
{DHCPSERVERENABLE,  ASN_INTEGER,  RWRITE,  var_DHCPServer, 1,  { 1 }},
{DHCPPOOLSTART,  ASN_IPADDRESS,  RWRITE,  var_DHCPServer, 1,  { 2 }},
{DHCPPOOLEND,  ASN_IPADDRESS,  RWRITE,  var_DHCPServer, 1,  { 3 }},
{DHCPLEASETIME,  ASN_INTEGER,  RWRITE,  var_DHCPServer, 1,  { 4 }},
{DHCPDOMAINNAME,  ASN_OCTET_STR,  RWRITE,  var_DHCPServer, 1,  { 5 }},
{DHCPRELAYENABLE,  ASN_INTEGER,  RWRITE,  var_DHCPServer, 1,  { 6 }},
{DHCPSERVERIP,  ASN_IPADDRESS,  RWRITE,  var_DHCPServer, 1,  { 7 }},
{CLINDEX,  ASN_INTEGER,  RONLY,   var_ClientListTable, 3,  { 8, 1, 1 }},
{CLIPADDR,  ASN_IPADDRESS,  RONLY,   var_ClientListTable, 3,  { 8, 1, 2 }},
{CLHOSTNAME,  ASN_OCTET_STR,  RONLY,   var_ClientListTable, 3,  { 8, 1, 3 }},
{CLMACADDR,  ASN_OCTET_STR,  RONLY,   var_ClientListTable, 3,  { 8, 1, 4 }},
{CLTYPE,  ASN_INTEGER,  RONLY,   var_ClientListTable, 3,  { 8, 1, 5 }},
{CLLEASETIME,  ASN_INTEGER,  RONLY,   var_ClientListTable, 3,  { 8, 1, 6 }},
{CLSELECT,  ASN_INTEGER,  RONLY,   var_ClientListTable, 3,  { 8, 1, 7 }},
{FMIDINDEX,  ASN_INTEGER,  RONLY,   var_FixedMappingTable, 3,  { 9, 1, 1 }},
{FMMACADDR,  ASN_OCTET_STR,  RWRITE,   var_FixedMappingTable, 3,  { 9, 1, 2 }},
{FMIPADDR,  ASN_IPADDRESS,  RWRITE,   var_FixedMappingTable, 3,  { 9, 1, 3 }},
{FMENABLE,  ASN_INTEGER,  RWRITE,  var_FixedMappingTable, 3,  { 9, 1, 4 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the DHCPServer module */
void
init_DHCPServer(void)
{

    DEBUGMSGTL(("DHCPServer", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("DHCPServer", DHCPServer_variables, variable7,
               DHCPServer_variables_oid);

    /* place any other initialization junk you need here */
}

static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	#define IFENTRY_NAME_LENGTH     16
	/* in this case, oid len is 16*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}

/*
 * var_DHCPServer():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_DHCPServer(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;


    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case DHCPSERVERENABLE:
			*write_method = write_DhcpServerEnable;
			read_csman(fd,0x00030001,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned char *) &long_ret;

    case DHCPPOOLSTART:
			*write_method = write_DhcpPoolStart;
			memset(string,0,sizeof(string));
			read_csman(fd,0x00030003,string,sizeof(string),TYPE_IPV4);
			*var_len = 4;
			return (unsigned char *) string;

    case DHCPPOOLEND:
			*write_method = write_DhcpPoolEnd;
			memset(string,0,sizeof(string));
			read_csman(fd,0x00030004,string,sizeof(string),TYPE_IPV4);
			*var_len = 4;
			return (unsigned char *) string;

    case DHCPLEASETIME:
			*write_method = write_DhcpLeaseTime;
			read_csman(fd,0x00030002,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned int *) &long_ret;

    case DHCPDOMAINNAME:
			*write_method = write_DhcpDomainName;
			memset(string,0,sizeof(string));
			read_csman(fd,0x00030005,string,sizeof(string),TYPE_STR);
			*var_len = strlen(string)-1;
			return (unsigned char *) string;

    case DHCPRELAYENABLE:
			*write_method = write_DhcpRelayEnable;
			read_csman(fd,0x000351e0,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned char *) &long_ret;

    case DHCPSERVERIP:
			*write_method = write_DhcpServerIP;
			memset(string,0,sizeof(string));
			read_csman(fd,0x000351e1,string,sizeof(string),TYPE_IPV4);
			*var_len = 4;
			return (unsigned char *) string;

    default:
      ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_ClientListTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_DHCPServer above.
 */
unsigned char *
var_ClientListTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    static unsigned int dev_num;
    int fd=0;

    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
    //if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
    //                                            == MATCH_FAILED )
    //return NULL;


    /* get total device num */
    dev_num = 10; //frank test

    if (dev_num <= 0)
        dev_num = 1;

    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,dev_num);
    //w_index=index;

    if ( index == MATCH_FAILED )
        return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case CLINDEX:
        long_ret = index;
        return (unsigned int *) &long_ret;

    case CLIPADDR:
			memset(string,0,sizeof(string));
			read_csman(fd,0x80030100+index-1,string,sizeof(string),TYPE_IPV4);
			*var_len = 4;
			return (unsigned char *) string;

    case CLHOSTNAME:
			memset(string,0,sizeof(string));
			read_csman(fd,0x80030200+index-1,string,sizeof(string),TYPE_STR);
			*var_len = strlen(string)-1;
			return (unsigned char *) string;

    case CLMACADDR:
			memset(string,0,sizeof(string));
			read_csman(fd,0x80030300+index-1,string,sizeof(string),TYPE_MAC);
			*var_len = 6;
			return (unsigned char *) string;

    case CLTYPE:
			read_csman(fd,0x80030500+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
			return (unsigned char *) &long_ret;

    case CLLEASETIME:
			read_csman(fd,0x80030400+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned int *) &long_ret;

    case CLSELECT:
        long_ret = 0;
        return (u_char*) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_FixedMappingTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_DHCPServer above.
 */
unsigned char *
var_FixedMappingTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    static unsigned int dev_num;
    int fd=0;

    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
    //if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
    //                                            == MATCH_FAILED )
    //return NULL;


    /* get total device num */
    dev_num = 10; //frank test

    if (dev_num <= 0)
        dev_num = 1;

    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,dev_num);
    w_index=index;

    if ( index == MATCH_FAILED )
        return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case FMIDINDEX:
        long_ret = index;
        return (unsigned int *) &long_ret;

    case FMMACADDR:
			*write_method = write_fmMacAddr;
			memset(string,0,sizeof(string));
			read_csman(fd,0x00031200+index-1,string,sizeof(string),TYPE_MAC);
			*var_len = 6;
			return (unsigned char *) string;

    case FMIPADDR:
			*write_method = write_fmIPAddr;
			memset(string,0,sizeof(string));
			read_csman(fd,0x00031400+index-1,string,sizeof(string),TYPE_IPV4);
			*var_len = 4;
			return (unsigned char *) string;

    case FMENABLE:
			*write_method = write_fmEnable;
			read_csman(fd,0x00031000+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned char *) &long_ret;

    default:
      ERROR_MSG("");
    }
    return NULL;
}



int
write_DhcpServerEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to DHCPServer not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to DHCPServer: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
              write_csman(fd,0x00030001,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_DhcpPoolStart(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to DHCPServer not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to DHCPServer: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for IPv4 data type
			  memset(string,0,sizeof(string));
			  memcpy(string , (char *) var_val, 4);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
		  {
			  int fd;
			  write_csman(fd,0x00030003,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}


int
write_DhcpPoolEnd(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to DHCPServer not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to DHCPServer: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for IPv4 data type
			  memset(string,0,sizeof(string));
			  memcpy(string , (char *) var_val, 4);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
		  {
			  int fd;
			  write_csman(fd,0x00030004,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}


int
write_DhcpLeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to DHCPServer not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to DHCPServer: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
              int fd=0;
              write_csman(fd,0x00030002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
          break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_DhcpDomainName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to DHCPServer not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to DHCPServer: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for STR/MAC data type
			  memset(string,0,sizeof(string));
			  strncpy(string , (char *) var_val, var_val_len);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
             int fd;
             write_csman(fd,0x00030005,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}


int
write_DhcpRelayEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to DHCPServer not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to DHCPServer: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
              write_csman(fd,0x000351e0,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_DhcpServerIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to DHCPServer not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to DHCPServer: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for IPv4 data type
			  memset(string,0,sizeof(string));
			  memcpy(string , (char *) var_val, 4);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
		  {
			  int fd;
			  write_csman(fd,0x000351e1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}

int
write_fmMacAddr(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to fmMacAddr not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to fmMacAddr: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for STR/MAC data type
			  memset(string,0,sizeof(string));
			  strncpy(string , (char *) var_val, var_val_len);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
		  {
			  int fd;
			  write_csman(fd,0x00031200+w_index-1,string,strlen(string) ,TYPE_MAC);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}

int
write_fmIPAddr(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to fmIPAddr not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to fmIPAddr: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for IPv4 data type
			  memset(string,0,sizeof(string));
			  memcpy(string , (char *) var_val, 4);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
		  {
			  int fd;
			  write_csman(fd,0x00031400+w_index-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}

int
write_fmEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to fmEnable not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to fmEnable: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
              write_csman(fd,0x00031000+w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
