/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "MobileApplication.h"
#include "csman.h"

/* 
 * MobileApplication_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
#ifdef SNMP_CUSTOMER_ID //netcom
oid MobileApplication_variables_oid[] = { 1,3,6,1,4,1,851,2,3,9,4,1 };
//     #error 11
        
#else                    //amit
oid MobileApplication_variables_oid[] = { 1,3,6,1,4,1,12823,2,3,9,4,1 };
  //          #error 00
               
#endif

/* 
 * variable7 MobileApplication_variables:
 *   this variable defines function callbacks and type return information 
 *   for the MobileApplication mib section 
 */

struct variable7 MobileApplication_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
{USSDMESSAGE,  ASN_OCTET_STR,  RWRITE,  var_MobileApplication, 2,  { 1,1 }},
{USSDSEND,  ASN_INTEGER,  RWRITE,  var_MobileApplication, 2,  { 1,2 }},
{USSDRETURN,  ASN_OCTET_STR,  RONLY ,  var_MobileApplication, 2,  { 1,3 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the MobileApplication module */
void
init_MobileApplication(void)
{

    DEBUGMSGTL(("MobileApplication", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("MobileApplication", MobileApplication_variables, variable7,
               MobileApplication_variables_oid);

    /* place any other initialization junk you need here */
}

/*
 * var_MobileApplication():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_MobileApplication(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case USSDMESSAGE:
			*write_method = write_USSDMessage;
			memset(string,0,sizeof(string));
			read_csman(fd,0x001e0019,string,sizeof(string),TYPE_STR);
			*var_len = strlen(string)-1;
			return (unsigned char *) string;

    case USSDSEND:
        *write_method = write_USSDSend;
        long_ret = 0;
        return NULL;

    case USSDRETURN:
			memset(string,0,sizeof(string));
			read_csman(fd,0x001e0018,string,sizeof(string),TYPE_STR);
			*var_len = strlen(string)-1;
			return (unsigned char *) string;

    default:
      ERROR_MSG("");
    }
    return NULL;
}


int
write_USSDMessage(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to MobileApplication not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to MobileApplication: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for STR/MAC data type
			  memset(string,0,sizeof(string));
			  strncpy(string , (char *) var_val, var_val_len);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
             int fd;
             write_csman(fd,0x001e0019,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}


int
write_USSDSend(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to MobileApplication not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to MobileApplication: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = 0;  //initial value
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          
             if(long_ret == 1)
                 system("ex_ussd");
          
          break;
    }
    return SNMP_ERR_NOERROR;
}

