/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "WlanStatus.h"
#include "csman.h"

/* 
 * WlanStatus_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
#ifdef SNMP_CUSTOMER_ID //netcom
//     #error 11
oid WlanStatus_variables_oid[] = { 1,3,6,1,4,1,851,2,3,9,1,2,1 };
        
#else                    //amit
//            #error 00
oid WlanStatus_variables_oid[] = { 1,3,6,1,4,1,12823,2,3,9,1,2,1 };
               
#endif

/* 
 * variable7 WlanStatus_variables:
 *   this variable defines function callbacks and type return information 
 *   for the WlanStatus mib section 
 */

struct variable7 WlanStatus_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
{STATSSIDINDEX,  ASN_INTEGER,  RONLY,   var_WlanStatusTable, 3,  { 1, 1, 1 }},
{STATWIRELESSENABLE,  ASN_INTEGER,  RONLY,   var_WlanStatusTable, 3,  { 1, 1, 2 }},
{STATWIRELESSMODE,  ASN_INTEGER,  RONLY,   var_WlanStatusTable, 3,  { 1, 1, 3 }},
{STATWLANSSID,  ASN_OCTET_STR,  RONLY,   var_WlanStatusTable, 3,  { 1, 1, 4 }},
{STATWLANCHANNEL,  ASN_INTEGER,  RONLY,   var_WlanStatusTable, 3,  { 1, 1, 5 }},
{STATAUTHENTICATION,  ASN_INTEGER,  RONLY,   var_WlanStatusTable, 3,  { 1, 1, 6 }},
{STATENCRYPTION,  ASN_INTEGER,  RONLY,   var_WlanStatusTable, 3,  { 1, 1, 7 }},
{STATWLANMAC,  ASN_OCTET_STR  ,  RONLY,   var_WlanStatusTable, 3,  { 1, 1, 8 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the WlanStatus module */
void
init_WlanStatus(void)
{

    DEBUGMSGTL(("WlanStatus", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("WlanStatus", WlanStatus_variables, variable7,
               WlanStatus_variables_oid);

    /* place any other initialization junk you need here */
}


static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	#define IFENTRY_NAME_LENGTH     16
	/* in this case, oid len is 16*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}



/*
 * var_WlanStatus():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_WlanStatus(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    default:
      ERROR_MSG("");
    }
    return NULL;
}

#define MSSID_NUM 4 //support 4 SSID

/*
 * var_WlanStatusTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_WlanStatus above.
 */
unsigned char *
var_WlanStatusTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
    //if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
    //                                            == MATCH_FAILED )
    //return NULL;

    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,MSSID_NUM);

    if ( index == MATCH_FAILED )
        return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case STATSSIDINDEX:
        long_ret = index;
        return (unsigned int *) &long_ret;

    case STATWIRELESSENABLE:
			read_csman(fd,0x00190100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned char *) &long_ret;

    case STATWIRELESSMODE:
			read_csman(fd,0x00190c00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned char *) &long_ret;

    case STATWLANSSID:
			memset(string,0,sizeof(string));
			read_csman(fd,0x00190400+index-1,string,sizeof(string),TYPE_STR);
			*var_len = strlen(string)-1;
			return (unsigned char *) string;

    case STATWLANCHANNEL:
			read_csman(fd,0x00190200+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned char *) &long_ret;

    case STATAUTHENTICATION:
			read_csman(fd,0x00191300+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned char *) &long_ret;

    case STATENCRYPTION:
			read_csman(fd,0x00191400+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned char *) &long_ret;

    case STATWLANMAC:
			memset(string,0,sizeof(string));
			system("apinfo24");
			read_csman(fd,0x80198000+index-1,string,sizeof(string),TYPE_MAC);
			*var_len = 6;
			return (unsigned char *) string;

    default:
      ERROR_MSG("");
    }
    return NULL;
}


