/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "BasicLANNetworkSetting.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>


/* 
 * BasicLANNetworkSetting_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


#ifdef SNMP_CUSTOMER_SMARTLINK
oid BasicLANNetworkSetting_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,2,2,1 };
#else
oid BasicLANNetworkSetting_variables_oid[] = { 1,3,6,1,4,1,12823,3,3,9,2,2,1 };
#endif
/* 
 * variable4 BasicLANNetworkSetting_variables:
 *   this variable defines function callbacks and type return information 
 *   for the BasicLANNetworkSetting mib section 
 */

struct variable7 BasicLANNetworkSetting_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{BASICLANIPADDRESS,  ASN_IPADDRESS,  RWRITE,var_BasicLANNetworkSetting, 1,  { 1 }},
{BASICSUBNETMASK,  ASN_IPADDRESS,  RWRITE,var_BasicLANNetworkSetting, 1,  { 2 }},
{BASICAPMODECNTTYPE,  ASN_INTEGER,  RWRITE,var_BasicLANNetworkSetting, 1,  { 3 }},
{BASICAPMODEGATEWAY,  ASN_IPADDRESS,  RWRITE,var_BasicLANNetworkSetting, 1,  { 4 }},
{BASICAPMODEPRIDNS,  ASN_IPADDRESS,  RWRITE,var_BasicLANNetworkSetting, 1,  { 5 }},
{BASICAPMODESECDNS,  ASN_IPADDRESS,  RWRITE,var_BasicLANNetworkSetting, 1,  { 6 }},
{BASICAPMODELANIPADDRESS,  ASN_IPADDRESS,  RWRITE,var_BasicLANNetworkSetting, 1,  { 7 }},
{BASICAPMODESUBNETMASK,  ASN_IPADDRESS,  RWRITE,var_BasicLANNetworkSetting, 1,  { 8 }},
{BASICAPMODALERTED,  ASN_INTEGER,  RWRITE,var_BasicLANNetworkSetting, 1,  { 9 }}

};
/*    (L = length of the oidsuffix) */


/** Initializes the BasicLANNetworkSetting module */
void
init_BasicLANNetworkSetting(void)
{

    DEBUGMSGTL(("BasicLANNetworkSetting", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("BasicLANNetworkSetting", BasicLANNetworkSetting_variables, variable7,
               BasicLANNetworkSetting_variables_oid);

    /* place any other initialization junk you need here */
}

/*
 * var_BasicLANNetworkSetting():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_BasicLANNetworkSetting(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICLANIPADDRESS:
    	{
      		*write_method = write_BasicLanIpAddress;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00010004,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
	}
    case BASICSUBNETMASK:
    	{
        	*write_method = write_BasicSubnetMask;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00010005,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
      }
    case BASICAPMODECNTTYPE:
    	{
        	*write_method = write_BasicAPModeCNTType;
		read_csman(fd,0x00010035,&long_ret,sizeof(unsigned int),TYPE_U32);
	      	return (unsigned char *) &long_ret;
      }
    case BASICAPMODEGATEWAY:
    	{
        	*write_method = write_BasicAPModeGateway;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00110013,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
      }
    case BASICAPMODEPRIDNS:
    	{
       	 *write_method = write_BasicAPModePriDNS;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00110014 ,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
      }
    case BASICAPMODESECDNS:
    	{
        	*write_method = write_BasicAPModeSecDNS;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00110015,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
      }
    case BASICAPMODELANIPADDRESS:
    	{
      		*write_method = write_BasicAPModeLanIpAddress;
		memset(string,0,sizeof(string));
		read_csman(fd, 0x00110011,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
	}
    case BASICAPMODESUBNETMASK:
    	{
        	*write_method = write_BasicAPModeSubnetMask;
		memset(string,0,sizeof(string));
		read_csman(fd, 0x00110012,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
      }
	case BASICAPMODALERTED:
	{
		*write_method = write_BasicAPModeAlerted;
		long_ret=0;
		return (unsigned char *) &long_ret;
	}
	
    default:
      ERROR_MSG("");
    }
    return NULL;
}





int
write_BasicLanIpAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to BasicLANNetworkSetting not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(in_addr_t)) {
              fprintf(stderr,"write to BasicLANNetworkSetting: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
		//for IPv4 data type
		memset(string,0,sizeof(string));
		memcpy(string , (char *) var_val, 4);
		break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
            {
             		int fd;
			write_csman(fd,0x00010004,string,strlen(string) ,TYPE_IPV4);
			break;
	     }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicSubnetMask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to BasicLANNetworkSetting not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(in_addr_t)) {
              fprintf(stderr,"write to BasicLANNetworkSetting: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
		//for IPv4 data type
		memset(string,0,sizeof(string));
		memcpy(string , (char *) var_val, 4);
		break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
            {
             		int fd;
			write_csman(fd,0x00010005,string,strlen(string) ,TYPE_IPV4);
			break;
	     }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicAPModeCNTType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to BasicLANNetworkSetting not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long)) {
              fprintf(stderr,"write to BasicLANNetworkSetting: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
              write_csman(fd,0x00010035,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicAPModeGateway(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to BasicLANNetworkSetting not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(in_addr_t)) {
              fprintf(stderr,"write to BasicLANNetworkSetting: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
		//for IPv4 data type
		memset(string,0,sizeof(string));
		memcpy(string , (char *) var_val, 4);
		break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
            {
             		int fd;
			write_csman(fd,0x00110013,string,strlen(string) ,TYPE_IPV4);
			break;
	     }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicAPModePriDNS(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
    
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to BasicLANNetworkSetting not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(in_addr_t)) {
              fprintf(stderr,"write to BasicLANNetworkSetting: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
		//for IPv4 data type
		memset(string,0,sizeof(string));
		memcpy(string , (char *) var_val, 4);
		break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
            {
             		int fd;
			write_csman(fd,0x00110014,string,strlen(string) ,TYPE_IPV4);
			break;
	     }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicAPModeSecDNS(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to BasicLANNetworkSetting not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(in_addr_t)) {
              fprintf(stderr,"write to BasicLANNetworkSetting: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
		//for IPv4 data type
		memset(string,0,sizeof(string));
		memcpy(string , (char *) var_val, 4);
		break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
            {
             		int fd;
			write_csman(fd,0x00110015,string,strlen(string) ,TYPE_IPV4);
			break;
	     }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicAPModeLanIpAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to BasicLANNetworkSetting not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(in_addr_t)) {
              fprintf(stderr,"write to BasicLANNetworkSetting: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
		//for IPv4 data type
		memset(string,0,sizeof(string));
		memcpy(string , (char *) var_val, 4);
		break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
            {
             		int fd;
			write_csman(fd,0x00110011,string,strlen(string) ,TYPE_IPV4);
			write_csman(fd,0x00010004,string,strlen(string) ,TYPE_IPV4);
			write_csman(fd,0x0011000a,string,strlen(string) ,TYPE_IPV4);
			break;
	     }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicAPModeSubnetMask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to BasicLANNetworkSetting not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(in_addr_t)) {
              fprintf(stderr,"write to BasicLANNetworkSetting: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
		//for IPv4 data type
		memset(string,0,sizeof(string));
		memcpy(string , (char *) var_val, 4);
		break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
            {
             		int fd;
			write_csman(fd,0x00110012,string,strlen(string) ,TYPE_IPV4);
			break;
	     }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicAPModeAlerted(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to NATUI not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
		write_csman(fd,0x80010056 ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		write_csman(fd,0x8001000a ,&long_ret,sizeof(unsigned int) ,TYPE_U32);	
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
