/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "BasicNATUI.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#define VS_NUM	20
#define VC_NUM	8
#define SP_NUM	8
int nw_index;


/* 
 * BasicNATUI_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


#ifdef SNMP_CUSTOMER_SMARTLINK
oid BasicNATUI_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,2,5 };
#else
oid BasicNATUI_variables_oid[] = { 1,3,6,1,4,1,12823,3,3,9,2,5 };
#endif

/* 
 * variable4 BasicNATUI_variables:
 *   this variable defines function callbacks and type return information 
 *   for the BasicNATUI mib section 
 */

struct variable4 BasicNATUI_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

//Virtual Server
{BASICVSIDINDEX,  ASN_INTEGER,  RONLY,var_BasicVirtualServerTable, 4,  { 1,1 , 1, 1 }},
{BASICVSSERVICEPORTS,  ASN_OCTET_STR,  RWRITE,var_BasicVirtualServerTable, 4,  { 1,1 , 1, 2 }},
{BASICVSPRIVATEPORT,  ASN_OCTET_STR,  RWRITE,var_BasicVirtualServerTable, 4,  { 1,1 , 1, 3 }},
{BASICVSSERVERIP,  ASN_IPADDRESS,  RWRITE,var_BasicVirtualServerTable, 4,  { 1,1 , 1, 4 }},
{BASICVSENABLE,  ASN_INTEGER,  RWRITE,var_BasicVirtualServerTable, 4,  { 1,1 , 1, 5 }},
{BASICVSRULENUMBER,  ASN_INTEGER,  RWRITE,var_BasicVirtualServerTable, 4,  { 1,1 , 1, 6 }},
//Virtual Computer
{BASICVCIDINDEX,  ASN_INTEGER,  RONLY,var_BasicVirtualComputersTable, 4,  { 2,1 , 1, 1 }},
{BASICVCGLOBALIP,  ASN_IPADDRESS,  RWRITE,var_BasicVirtualComputersTable, 4,  { 2,1 , 1, 2 }},
{BASICVCLOCALIP,  ASN_IPADDRESS,  RWRITE,var_BasicVirtualComputersTable, 4,  { 2,1 , 1, 3 }},
{BASICVCENABLE,  ASN_INTEGER,  RWRITE,var_BasicVirtualComputersTable, 4,  { 2,1 , 1, 4 }},
//Special AP
{BASICSAIDINDEX,  ASN_INTEGER,  RONLY,var_BasicSpecialAPTable, 4,  { 3,1 , 1, 1 }},
{BASICSATRIGGER,  ASN_OCTET_STR,  RWRITE,var_BasicSpecialAPTable, 4,  { 3,1 , 1, 2 }},
{BASICSAINCOMINGPORTS,  ASN_OCTET_STR,  RWRITE,var_BasicSpecialAPTable, 4,  { 3,1 , 1, 3 }},
{BASICSAENABLE,  ASN_INTEGER,  RWRITE,var_BasicSpecialAPTable, 4,  { 3,1 , 1, 4 }},
//Loopback
{BASICNATLOOPBACKENABLE,  ASN_INTEGER,  RWRITE,var_BasicNATUI, 2,  { 4,1 }},
{BASICDMZIPADDRHOST,  ASN_IPADDRESS,  RWRITE,var_BasicNATUI, 2,  { 5,1 }},
//DMZ
{BASICDMZENABLE,  ASN_INTEGER,  RWRITE,var_BasicNATUI, 2,  { 5,2 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the BasicNATUI module */
void
init_BasicNATUI(void)
{

    DEBUGMSGTL(("BasicNATUI", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("BasicNATUI", BasicNATUI_variables, variable4,
               BasicNATUI_variables_oid);

    /* place any other initialization junk you need here */
}


static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	#ifdef SNMP_CUSTOMER_SMARTLINK
	#define IFENTRY_NAME_LENGTH     17
	#else
	#define IFENTRY_NAME_LENGTH     16
	#endif
	/* in this case, oid len is 16*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}


/*
 * var_BasicNATUI():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_BasicNATUI(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0,flag=0;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICNATLOOPBACKENABLE:
        	*write_method = write_BasicNATLoopbackEnable;
		read_csman(fd,0x00150013,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICDMZIPADDRHOST:
	{
		*write_method = write_BasicDmzIPAddrHost;
		read_csman(fd,0x001500a1,&flag,sizeof(unsigned int),TYPE_U32);
		memset(string,0,sizeof(string));

		if(flag == 0)
			read_csman(fd,0x00150009,string,sizeof(string),TYPE_IPV4);
		else
			read_csman(fd,0x001500c0,string,sizeof(string),TYPE_IPV4);

		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    	}
    case BASICDMZENABLE:
	{
        	*write_method = write_BasicDmzEnable;
		read_csman(fd,0x001500a1,&flag,sizeof(unsigned int),TYPE_U32);

		if(flag==0)
			read_csman(fd,0x00150008 ,&long_ret,sizeof(unsigned int),TYPE_U32);
		else
			read_csman(fd,0x001500b0 ,&long_ret,sizeof(unsigned int),TYPE_U32);
			
	        return (unsigned char *) &long_ret;
    	}
    default:
      ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_BasicVirtualServerTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_BasicNATUI above.
 */
unsigned char *
var_BasicVirtualServerTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
    //if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
    //                                             == MATCH_FAILED )
    //return NULL;


    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,VS_NUM);
    nw_index=index;

    if ( index == MATCH_FAILED )
        return NULL;	

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICVSIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case BASICVSSERVICEPORTS:
        	*write_method = write_BasicvsServicePorts;
		memset(string,0,sizeof(string));
		read_csman(fd,0x000c3000+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case BASICVSPRIVATEPORT:
       	*write_method = write_BasicvsPrivatePort;
		memset(string,0,sizeof(string));
		read_csman(fd,0x000c5000+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case BASICVSSERVERIP:
        	*write_method = write_BasicvsServerIP;
		memset(string,0,sizeof(string));
		read_csman(fd,0x000c2000+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case BASICVSENABLE:
       	*write_method = write_BasicvsEnable;
		read_csman(fd,0x000c1000+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVSRULENUMBER:
        	*write_method = write_BasicvsRuleNumber;
		read_csman(fd,0x000c4000+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_BasicVirtualComputersTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_BasicNATUI above.
 */
unsigned char *
var_BasicVirtualComputersTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
    //if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
    //                                             == MATCH_FAILED )
    // return NULL;

    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,VC_NUM);
    nw_index=index;

    if ( index == MATCH_FAILED )
        return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICVCIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case BASICVCGLOBALIP:
		*write_method = write_BasicvcGlobalIP;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00142000+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case BASICVCLOCALIP:
       	 *write_method = write_BasicvcLocalIP;
		 memset(string,0,sizeof(string));
		 read_csman(fd,0x00143000+index-1,string,sizeof(string),TYPE_IPV4);
		 *var_len = 4; //IP address length = 4
		 return (unsigned char *) string;
    case BASICVCENABLE:
        	*write_method = write_BasicvcEnable;
		read_csman(fd,0x00141000+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	        return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_BasicSpecialAPTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_BasicNATUI above.
 */
unsigned char *
var_BasicSpecialAPTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
    //if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
    //                                           == MATCH_FAILED )
    //return NULL;


    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,SP_NUM);
    nw_index=index;

    if ( index == MATCH_FAILED )
        return NULL;	

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICSAIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case BASICSATRIGGER:
        	*write_method = write_BasicsaTrigger;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00170011+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case BASICSAINCOMINGPORTS:
       	 *write_method = write_BasicsaIncomingPorts;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00170021+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case BASICSAENABLE:
       	 *write_method = write_BasicsaEnable;
		read_csman(fd,0x00170001+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}



int
write_BasicNATLoopbackEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to NATUI not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
              write_csman(fd,0x00150013,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicDmzIPAddrHost(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to NATUI not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
		//for IPv4 data type
		memset(string,0,sizeof(string));
		memcpy(string , (char *) var_val, 4);
		break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
		  {
			  int fd,flag=0;

			  read_csman(fd,0x001500a1,&flag,sizeof(unsigned int),TYPE_U32);

			  if(flag==0)
			  	write_csman(fd,0x00150009,string,strlen(string) ,TYPE_IPV4);
			  else
				write_csman(fd,0x001500c0,string,strlen(string) ,TYPE_IPV4);
			  
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicDmzEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to NATUI not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0,flag=0;
		read_csman(fd,0x001500a1,&flag,sizeof(unsigned int),TYPE_U32);

		if(flag==0)
			write_csman(fd,0x00150008 ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		else
			write_csman(fd,0x001500b0 ,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  
              
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicvsServicePorts(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to NATUI not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for STR/MAC data type
			  memset(string,0,sizeof(string));
			  strncpy(string , (char *) var_val, var_val_len);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
             int fd;
             write_csman(fd,0x000c3000+nw_index-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicvsPrivatePort(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to NATUI not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for STR/MAC data type
			  memset(string,0,sizeof(string));
			  strncpy(string , (char *) var_val, var_val_len);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
             int fd;
             write_csman(fd,0x000c5000+nw_index-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicvsServerIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to NATUI not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for IPv4 data type
			  memset(string,0,sizeof(string));
			  memcpy(string , (char *) var_val, 4);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
		  {
			  int fd;
			  write_csman(fd,0x000c2000+nw_index-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicvsEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to NATUI not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
              write_csman(fd,0x000c1000+nw_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicvsRuleNumber(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to NATUI not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
              write_csman(fd,0x000c4000+nw_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicvcGlobalIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to NATUI not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for IPv4 data type
			  memset(string,0,sizeof(string));
			  memcpy(string , (char *) var_val, 4);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
		  {
			  int fd;
			  write_csman(fd,0x00142000+nw_index-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicvcLocalIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to NATUI not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for IPv4 data type
			  memset(string,0,sizeof(string));
			  memcpy(string , (char *) var_val, 4);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
		  {
			  int fd;
			  write_csman(fd,0x00143000+nw_index-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicvcEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to NATUI not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
              write_csman(fd,0x00141000+nw_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicsaTrigger(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to NATUI not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for STR/MAC data type
			  memset(string,0,sizeof(string));
			  strncpy(string , (char *) var_val, var_val_len);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
             int fd;
             write_csman(fd,0x00170011+nw_index-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicsaIncomingPorts(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to NATUI not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  //for STR/MAC data type
			  memset(string,0,sizeof(string));
			  strncpy(string , (char *) var_val, var_val_len);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
             int fd;
             write_csman(fd,0x00170021+nw_index-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicsaEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to NATUI not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to NATUI: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
              int fd=0;
              write_csman(fd,0x00170001+nw_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

