/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "csman.h"
#include "StatusStatisticsInformation.h"
#include <stdio.h>
#include <string.h>

/* 
 * StatusStatisticsInformation_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

#ifdef SNMP_CUSTOMER_SMARTLINK
oid StatusStatisticsInformation_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,1,1,3 };
#else
oid StatusStatisticsInformation_variables_oid[] = { 1,3,6,1,4,1,12823,3,3,9,1,1,3 };
#endif

/* 
 * variable4 StatusStatisticsInformation_variables:
 *   this variable defines function callbacks and type return information 
 *   for the StatusStatisticsInformation mib section 
 */

struct variable7 StatusStatisticsInformation_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{WANTRANSMITPACKETS,  ASN_COUNTER,  RONLY,var_StatusStatisticsInformation, 1,  { 1 }},
{WANRECEIVEPACKETS,  ASN_COUNTER,  RONLY,var_StatusStatisticsInformation, 1,  { 2 }},
{LANTRANSMITPACKETS,  ASN_COUNTER,  RONLY,var_StatusStatisticsInformation, 1,  { 3 }},
{LANRECEIVEPACKETS,  ASN_COUNTER,  RONLY,var_StatusStatisticsInformation, 1,  { 4 }},
{WLANTRANSMITPACKETS,  ASN_COUNTER,  RONLY,var_StatusStatisticsInformation, 1,  { 5 }},
{WLANRECEIVEPACKETS,  ASN_COUNTER,  RONLY,var_StatusStatisticsInformation, 1,  { 6 }},

};
/*    (L = length of the oidsuffix) */

struct statistic_mib
{
	unsigned long	Wan1Transmit,Wan2Transmit;
	unsigned long	Wan1Receive,Wan2Receive;
	unsigned long	m3g1Transmit,m3g2Transmit;
	unsigned long	m3g1Receive,m3g2Receive;
	unsigned long	LanTransmit,LanReceive;
	unsigned long	WlanTransmit,WlanReceive;
	unsigned long	TrashData;
};


/** Initializes the StatusStatisticsInformation module */
void
init_StatusStatisticsInformation(void)
{

    DEBUGMSGTL(("StatusStatisticsInformation", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("StatusStatisticsInformation", StatusStatisticsInformation_variables, variable7,
               StatusStatisticsInformation_variables_oid);

    /* place any other initialization junk you need here */
}

static void
linux_read_statistic (struct statistic_mib *statistic)
{
  char line [2048];

  system("traffic_stat > /tmp/snmp_multiwan_statistic");
  FILE *in = fopen ("/tmp/snmp_multiwan_statistic", "r");

  memset ((char *) statistic,(0), sizeof (*statistic));

  if (! in)
    return;

  while(line == fgets (line, sizeof(line), in))
  {
  	if (10 == sscanf (line, "WAN %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu\n",
		&statistic->TrashData,&statistic->Wan1Transmit,&statistic->TrashData, 
		&statistic->TrashData,&statistic->TrashData,&statistic->TrashData,
		&statistic->Wan1Receive,&statistic->TrashData,&statistic->TrashData,
		&statistic->TrashData))
	break;
  }
  #if 0
  while(line == fgets (line, sizeof(line), in))
  {
	if (10 == sscanf (line, "WAN2 %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu\n",
		  &statistic->TrashData,&statistic->Wan2Transmit,&statistic->TrashData, 
		  &statistic->TrashData,&statistic->TrashData,&statistic->TrashData,
		  &statistic->Wan2Receive,&statistic->TrashData,&statistic->TrashData,
		  &statistic->TrashData))
	break;
  }
  #endif
  while (line == fgets (line, sizeof(line), in))
  {
	 if (10 == sscanf (line, "LAN %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu\n",
		  &statistic->TrashData,&statistic->LanTransmit,&statistic->TrashData, 
		  &statistic->TrashData,&statistic->TrashData,&statistic->TrashData,
		  &statistic->LanReceive,&statistic->TrashData,&statistic->TrashData,
		  &statistic->TrashData))
	break;
  }

  while (line == fgets (line, sizeof(line), in))
  {
	if (10 == sscanf (line, "WLAN %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu\n",
		   &statistic->TrashData,&statistic->WlanTransmit,&statistic->TrashData, 
		   &statistic->TrashData,&statistic->TrashData,&statistic->TrashData,
		   &statistic->WlanReceive,&statistic->TrashData,&statistic->TrashData,
		   &statistic->TrashData))
	break;
  }
  #if 0
  while(line == fgets (line, sizeof(line), in))
  {
	if (10 == sscanf (line, "3G1 %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu\n",
			 &statistic->TrashData,&statistic->m3g1Transmit,&statistic->TrashData, 
			 &statistic->TrashData,&statistic->TrashData,&statistic->TrashData,
			 &statistic->m3g1Receive,&statistic->TrashData,&statistic->TrashData,
			 &statistic->TrashData))
	break;
  }	

  while(line == fgets (line, sizeof(line), in))
  {
	if (10 == sscanf (line, "3G2 %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu\n",
			 &statistic->TrashData,&statistic->m3g2Transmit,&statistic->TrashData, 
			 &statistic->TrashData,&statistic->TrashData,&statistic->TrashData,
			 &statistic->m3g2Receive,&statistic->TrashData,&statistic->TrashData,
			 &statistic->TrashData))
	break;
  }	
  #endif

  fclose (in);
}



/*
 * var_StatusStatisticsInformation():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_StatusStatisticsInformation(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    static struct statistic_mib statistic; // for get statistic data

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

     linux_read_statistic(&statistic); //get statistic data	

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case WANTRANSMITPACKETS:
			long_ret = statistic.Wan1Transmit;
	        return (unsigned char *) &long_ret;
    case WANRECEIVEPACKETS:
			long_ret = statistic.Wan1Receive;
	        return (unsigned char *) &long_ret;
    case LANTRANSMITPACKETS:
			long_ret = statistic.LanTransmit;
	        return (unsigned char *) &long_ret;
    case LANRECEIVEPACKETS:
			long_ret = statistic.LanReceive;
	        return (unsigned char *) &long_ret;
    case WLANTRANSMITPACKETS:
			long_ret = statistic.WlanTransmit;
	        return (unsigned char *) &long_ret;
    case WLANRECEIVEPACKETS:
			long_ret = statistic.WlanReceive;
	        return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}

