/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "csman.h"
#include "SysSystemInformation.h"
#include <stdio.h>
#include <string.h>


/* 
 * SysSystemInformation_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


#ifdef SNMP_CUSTOMER_SMARTLINK
oid SysSystemInformation_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,5,1 };
#else
oid SysSystemInformation_variables_oid[] = { 1,3,6,1,4,1,12823,3,3,9,5,1 };
#endif

/* 
 * variable4 SysSystemInformation_variables:
 *   this variable defines function callbacks and type return information 
 *   for the SysSystemInformation mib section 
 */

struct variable7 SysSystemInformation_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{SYSINFOWANTYPE,  ASN_INTEGER,  RONLY,var_SysSystemInformation, 2,  { 1,1 }},
{SYSINFODISPLAYTIME,  ASN_OCTET_STR,  RONLY,var_SysSystemInformation, 2,  { 1,2 }},

};
/*    (L = length of the oidsuffix) */


/** Initializes the SysSystemInformation module */
void
init_SysSystemInformation(void)
{

    DEBUGMSGTL(("SysSystemInformation", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("SysSystemInformation", SysSystemInformation_variables, variable7,
               SysSystemInformation_variables_oid);

    /* place any other initialization junk you need here */
}

/*
 * var_SysSystemInformation():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_SysSystemInformation(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSINFOWANTYPE:
		{
			unsigned int wan_type;
			read_csman(fd,0x00010003,&wan_type,sizeof(unsigned int),TYPE_U32);

			if(wan_type == LOCAL_WANTYPE_DHCP) //dynamic
				long_ret = 0;
			else if(wan_type == LOCAL_WANTYPE_FIXED) //static
				long_ret = 1;
			else if(wan_type == LOCAL_WANTYPE_PPPOE) //PPPoE
				long_ret = 2;
			else if(wan_type == LOCAL_WANTYPE_PPTP) //pptp
				long_ret = 3;
			else if(wan_type == LOCAL_WANTYPE_L2TP) //l2tp
				long_ret = 4;
			else if(wan_type == LOCAL_WANTYPE_3G) //3G
				long_ret = 5;
			else if(wan_type == LOCAL_WANTYPE_IBURST) //iBurst
				long_ret = 6;

			//long_ret = wan_type;
	        return (unsigned char *) &long_ret;
		}
    case SYSINFODISPLAYTIME:
		{
			unsigned char info_time[128];
			memset(info_time,0,sizeof(info_time));
			system("date -R > /tmp/snmp_ui_time");

			FILE *fp;
			char buf[128];
			if((fp = fopen("/tmp/snmp_ui_time","r")) != NULL){
				fgets(info_time, sizeof(info_time), fp);
			}
			fclose(fp);

			*var_len = strlen(info_time)-1;
			return (unsigned char *) info_time;

		}
    default:
      ERROR_MSG("");
    }
    return NULL;
}




