#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "csman.h"
#include "SysUserMgntAddUserList.h"
#include <stdio.h>
#include <string.h>

#ifdef SNMP_CUSTOMER_SMARTLINK
oid SysUserMgntAddUserList_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,5,11,2 };
#else
oid SysUserMgntAddUserList_variables_oid[] = { 1,3,6,1,4,1,12823,3,3,9,5,11,2 };
#endif

struct variable7 SysUserMgntAddUserList_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{SYSUSERMGNTADDUSERALTER,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 1,1 }},
{SYSUSERMGNTADDUSER1USERNAME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 2,1 }},
{SYSUSERMGNTADDUSER1PASSWORD,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 2,2 }},
{SYSUSERMGNTADDUSER1USERLEVEL,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 2,3 }},
{SYSUSERMGNTADDUSER1LEASETIME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 2,4 }},
{SYSUSERMGNTADDUSER1IDLETIMEOUT,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 2,5 }},
{SYSUSERMGNTADDUSER1GROUPTO,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 2,6 }},
{SYSUSERMGNTADDUSER1PROFILE,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 2,7 }},
{SYSUSERMGNTADDUSER2USERNAME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 3,1 }},
{SYSUSERMGNTADDUSER2PASSWORD,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 3,2 }},
{SYSUSERMGNTADDUSER2USERLEVEL,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 3,3 }},
{SYSUSERMGNTADDUSER2LEASETIME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 3,4 }},
{SYSUSERMGNTADDUSER2IDLETIMEOUT,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 3,5 }},
{SYSUSERMGNTADDUSER2GROUPTO,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 3,6 }},
{SYSUSERMGNTADDUSER2PROFILE,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 3,7 }},
{SYSUSERMGNTADDUSER3USERNAME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 4,1 }},
{SYSUSERMGNTADDUSER3PASSWORD,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 4,2 }},
{SYSUSERMGNTADDUSER3USERLEVEL,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 4,3 }},
{SYSUSERMGNTADDUSER3LEASETIME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 4,4 }},
{SYSUSERMGNTADDUSER3IDLETIMEOUT,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 4,5 }},
{SYSUSERMGNTADDUSER3GROUPTO,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 4,6 }},
{SYSUSERMGNTADDUSER3PROFILE,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 4,7 }},
{SYSUSERMGNTADDUSER4USERNAME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 5,1 }},
{SYSUSERMGNTADDUSER4PASSWORD,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 5,2 }},
{SYSUSERMGNTADDUSER4USERLEVEL,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 5,3 }},
{SYSUSERMGNTADDUSER4LEASETIME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 5,4 }},
{SYSUSERMGNTADDUSER4IDLETIMEOUT,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 5,5 }},
{SYSUSERMGNTADDUSER4GROUPTO,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 5,6 }},
{SYSUSERMGNTADDUSER4PROFILE,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 5,7 }},
{SYSUSERMGNTADDUSER5USERNAME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 6,1 }},
{SYSUSERMGNTADDUSER5PASSWORD,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 6,2 }},
{SYSUSERMGNTADDUSER5USERLEVEL,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 6,3 }},
{SYSUSERMGNTADDUSER5LEASETIME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 6,4 }},
{SYSUSERMGNTADDUSER5IDLETIMEOUT,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 6,5 }},
{SYSUSERMGNTADDUSER5GROUPTO,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 6,6 }},
{SYSUSERMGNTADDUSER5PROFILE,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 6,7 }},
{SYSUSERMGNTADDUSER6USERNAME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 7,1 }},
{SYSUSERMGNTADDUSER6PASSWORD,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 7,2 }},
{SYSUSERMGNTADDUSER6USERLEVEL,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 7,3 }},
{SYSUSERMGNTADDUSER6LEASETIME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 7,4 }},
{SYSUSERMGNTADDUSER6IDLETIMEOUT,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 7,5 }},
{SYSUSERMGNTADDUSER6GROUPTO,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 7,6 }},
{SYSUSERMGNTADDUSER6PROFILE,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 7,7 }},
{SYSUSERMGNTADDUSER7USERNAME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 8,1 }},
{SYSUSERMGNTADDUSER7PASSWORD,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 8,2 }},
{SYSUSERMGNTADDUSER7USERLEVEL,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 8,3 }},
{SYSUSERMGNTADDUSER7LEASETIME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 8,4 }},
{SYSUSERMGNTADDUSER7IDLETIMEOUT,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 8,5 }},
{SYSUSERMGNTADDUSER7GROUPTO,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 8,6 }},
{SYSUSERMGNTADDUSER7PROFILE,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 8,7 }},
{SYSUSERMGNTADDUSER8USERNAME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 9,1 }},
{SYSUSERMGNTADDUSER8PASSWORD,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 9,2 }},
{SYSUSERMGNTADDUSER8USERLEVEL,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 9,3 }},
{SYSUSERMGNTADDUSER8LEASETIME,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 9,4 }},
{SYSUSERMGNTADDUSER8IDLETIMEOUT,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 9,5 }},
{SYSUSERMGNTADDUSER8GROUPTO,ASN_OCTET_STR,RWRITE,var_SysUserMgntAddUserList, 2,  { 9,6 }},
{SYSUSERMGNTADDUSER8PROFILE,ASN_INTEGER,RWRITE,var_SysUserMgntAddUserList, 2,  { 9,7 }},

};

void
init_SysUserMgntAddUserList(void)
{
    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("SysUserMgntAddUserList", SysUserMgntAddUserList_variables, variable7,
               SysUserMgntAddUserList_variables_oid);
}

unsigned char *
var_SysUserMgntAddUserList(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSUSERMGNTADDUSERALTER:
        *write_method = write_SysUserMgntAddUserAlter;
        read_csman(fd,0x80990101,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER1USERNAME:
        *write_method = write_SysUserMgntAddUser1UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991000,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER1PASSWORD:
        *write_method = write_SysUserMgntAddUser1Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991001,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER1USERLEVEL:
        *write_method = write_SysUserMgntAddUser1UserLevel;
        read_csman(fd,0x00991002,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER1LEASETIME:
        *write_method = write_SysUserMgntAddUser1LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991003,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER1IDLETIMEOUT:
        *write_method = write_SysUserMgntAddUser1IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991004,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER1GROUPTO:
        *write_method = write_SysUserMgntAddUser1Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991005,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER1PROFILE:
        *write_method = write_SysUserMgntAddUser1Profile;
        read_csman(fd,0x00991006,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER2USERNAME:
        *write_method = write_SysUserMgntAddUser2UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991100,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER2PASSWORD:
        *write_method = write_SysUserMgntAddUser2Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991101,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER2USERLEVEL:
        *write_method = write_SysUserMgntAddUser2UserLevel;
        read_csman(fd,0x00991102,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER2LEASETIME:
        *write_method = write_SysUserMgntAddUser2LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991103,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER2IDLETIMEOUT:
        *write_method = write_SysUserMgntAddUser2IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991104,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER2GROUPTO:
        *write_method = write_SysUserMgntAddUser2Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991105,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER2PROFILE:
        *write_method = write_SysUserMgntAddUser2Profile;
        read_csman(fd,0x00991106,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER3USERNAME:
        *write_method = write_SysUserMgntAddUser3UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991200,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER3PASSWORD:
        *write_method = write_SysUserMgntAddUser3Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991201,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER3USERLEVEL:
        *write_method = write_SysUserMgntAddUser3UserLevel;
        read_csman(fd,0x00991202,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER3LEASETIME:
        *write_method = write_SysUserMgntAddUser3LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991203,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER3IDLETIMEOUT:
        *write_method = write_SysUserMgntAddUser3IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991204,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER3GROUPTO:
        *write_method = write_SysUserMgntAddUser3Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991205,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER3PROFILE:
        *write_method = write_SysUserMgntAddUser3Profile;
        read_csman(fd,0x00991206,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER4USERNAME:
        *write_method = write_SysUserMgntAddUser4UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991300,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER4PASSWORD:
        *write_method = write_SysUserMgntAddUser4Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991301,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER4USERLEVEL:
        *write_method = write_SysUserMgntAddUser4UserLevel;
        read_csman(fd,0x00991302,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER4LEASETIME:
        *write_method = write_SysUserMgntAddUser4LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991303,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER4IDLETIMEOUT:
        *write_method = write_SysUserMgntAddUser4IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991304,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER4GROUPTO:
        *write_method = write_SysUserMgntAddUser4Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991305,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER4PROFILE:
        *write_method = write_SysUserMgntAddUser4Profile;
        read_csman(fd,0x00991306,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER5USERNAME:
        *write_method = write_SysUserMgntAddUser5UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991400,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER5PASSWORD:
        *write_method = write_SysUserMgntAddUser5Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991401,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER5USERLEVEL:
        *write_method = write_SysUserMgntAddUser5UserLevel;
        read_csman(fd,0x00991402,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER5LEASETIME:
        *write_method = write_SysUserMgntAddUser5LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991403,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER5IDLETIMEOUT:
        *write_method = write_SysUserMgntAddUser5IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991404,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER5GROUPTO:
        *write_method = write_SysUserMgntAddUser5Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991405,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER5PROFILE:
        *write_method = write_SysUserMgntAddUser5Profile;
        read_csman(fd,0x00991406,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER6USERNAME:
        *write_method = write_SysUserMgntAddUser6UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991500,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER6PASSWORD:
        *write_method = write_SysUserMgntAddUser6Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991501,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER6USERLEVEL:
        *write_method = write_SysUserMgntAddUser6UserLevel;
        read_csman(fd,0x00991502,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER6LEASETIME:
        *write_method = write_SysUserMgntAddUser6LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991503,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER6IDLETIMEOUT:
        *write_method = write_SysUserMgntAddUser6IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991504,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER6GROUPTO:
        *write_method = write_SysUserMgntAddUser6Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991505,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER6PROFILE:
        *write_method = write_SysUserMgntAddUser6Profile;
        read_csman(fd,0x00991506,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER7USERNAME:
        *write_method = write_SysUserMgntAddUser7UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991600,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER7PASSWORD:
        *write_method = write_SysUserMgntAddUser7Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991601,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER7USERLEVEL:
        *write_method = write_SysUserMgntAddUser7UserLevel;
        read_csman(fd,0x00991602,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER7LEASETIME:
        *write_method = write_SysUserMgntAddUser7LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991603,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER7IDLETIMEOUT:
        *write_method = write_SysUserMgntAddUser7IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991604,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER7GROUPTO:
        *write_method = write_SysUserMgntAddUser7Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991605,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER7PROFILE:
        *write_method = write_SysUserMgntAddUser7Profile;
        read_csman(fd,0x00991606,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER8USERNAME:
        *write_method = write_SysUserMgntAddUser8UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991700,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER8PASSWORD:
        *write_method = write_SysUserMgntAddUser8Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991701,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER8USERLEVEL:
        *write_method = write_SysUserMgntAddUser8UserLevel;
        read_csman(fd,0x00991702,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSUSERMGNTADDUSER8LEASETIME:
        *write_method = write_SysUserMgntAddUser8LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991703,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER8IDLETIMEOUT:
        *write_method = write_SysUserMgntAddUser8IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991704,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER8GROUPTO:
        *write_method = write_SysUserMgntAddUser8Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991705,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSUSERMGNTADDUSER8PROFILE:
        *write_method = write_SysUserMgntAddUser8Profile;
        read_csman(fd,0x00991706,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}


int
write_SysUserMgntAddUserAlter(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x80990101,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			write_csman(fd,0x80990100,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}                 
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser1UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991000,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser1Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991001,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser1UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser1LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991003,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser1IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991004,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser1Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991005,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser1Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991006,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser2UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991100,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser2Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991101,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser2UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991102,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser2LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991103,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser2IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991104,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser2Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991105,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser2Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991106,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser3UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991200,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser3Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991201,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser3UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991202,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser3LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991203,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser3IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991204,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser3Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991205,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser3Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991206,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser4UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991300,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser4Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991301,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser4UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991302,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser4LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991303,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser4IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991304,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser4Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991305,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser4Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991306,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser5UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991400,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser5Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991401,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser5UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991402,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser5LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991403,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser5IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991404,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser5Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991405,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser5Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991406,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser6UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991500,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser6Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991501,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser6UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991502,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser6LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991503,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser6IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;
			
        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991504,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser6Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991505,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser6Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991506,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser7UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;
			
        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991600,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser7Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991601,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser7UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991602,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser7LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991603,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser7IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991604,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser7Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991605,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser7Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991606,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser8UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991700,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser8Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991701,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser8UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991702,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser8LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991703,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser8IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991704,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser8Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
		 	int fd=0;
         	write_csman(fd,0x00991705,string,strlen(string)+1,TYPE_STR);
			break;
         }    
    }
    return SNMP_ERR_NOERROR;
}


int
write_SysUserMgntAddUser8Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991706,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}

