/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "ddnsgroup.h"
#include "csman.h"


/* 
 * ddnsgroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
#ifdef SNMP_CUSTOMER_ID //netcom
    //#error 11
	oid ddnsgroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,18 };	   
#else                    //amit
    //#error 00
	oid ddnsgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,18 };	   
#endif

//oid ddnsgroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,18 };

//oid ddnsgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,18 };


/* 
 * variable2 ddnsgroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the ddnsgroup mib section 
 */


struct variable2 ddnsgroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { DDNSSWITCH          , ASN_INTEGER   , RWRITE, var_ddnsgroup, 1, { 1 } },
  { DDNSPROVIDER        , ASN_INTEGER   , RWRITE, var_ddnsgroup, 1, { 2 } },
  { DDNSHOSTNAME        , ASN_OCTET_STR , RWRITE, var_ddnsgroup, 1, { 3 } },
  { DDNSEMAILORUSER     , ASN_OCTET_STR , RWRITE, var_ddnsgroup, 1, { 4 } },
  { DDNSPASSWORDORKEY   , ASN_OCTET_STR , RWRITE, var_ddnsgroup, 1, { 5 } },
};
/*    (L = length of the oidsuffix) */


/*
 * init_ddnsgroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_ddnsgroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("gateway/ddnsgroup", ddnsgroup_variables, variable2,
               ddnsgroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_ddnsgroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_ddnsgroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case DDNSPASSWORDORKEY:
		{
			*write_method = write_dDNSPasswordORKey;
			int ret = 0;
			int fd=0;
			unsigned char ddns_password[512];
			
			memset(ddns_password,0,sizeof(ddns_password));
			ret = read_csman(fd,0x00090005,ddns_password,sizeof(ddns_password),TYPE_STR);
	
			strcpy(string,ddns_password);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case DDNSEMAILORUSER:
		{ 
			*write_method = write_dDNSEmailORUser;
			int ret = 0;
			int fd=0;
			unsigned char ddns_user[512];
			
			memset(ddns_user,0,sizeof(ddns_user));
			ret = read_csman(fd,0x00090004,ddns_user,sizeof(ddns_user),TYPE_STR);
	
			strcpy(string,ddns_user);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case DDNSHOSTNAME:
		{
			*write_method = write_dDNSHostName;
			int ret = 0;
			int fd=0;
			unsigned char ddns_hostname[512];
			
			memset(ddns_hostname,0,sizeof(ddns_hostname));
			ret = read_csman(fd,0x00090003,ddns_hostname,sizeof(ddns_hostname),TYPE_STR);
	
			strcpy(string,ddns_hostname);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case DDNSPROVIDER:
		{
			*write_method = write_dDNSProvider;
			int ret = 0;
			int fd=0;
			unsigned char ddns_provider;
			ret = read_csman(fd,0x00090002,&ddns_provider,sizeof(unsigned char),TYPE_U32);
			long_ret = ddns_provider;
			return (unsigned char *) &long_ret;
		}

    case DDNSSWITCH:
		{
			*write_method = write_dDNSSwitch;
			int ret = 0;
			int fd=0;
			unsigned char ddns_switch;
			ret = read_csman(fd,0x00090001,&ddns_switch,sizeof(unsigned char),TYPE_U32);
			long_ret = ddns_switch;
			return (unsigned char *) &long_ret;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}





int
write_dDNSPasswordORKey(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to dDNSPasswordORKey not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to dDNSPasswordORKey: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
			  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00090005,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dDNSEmailORUser(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to dDNSEmailORUser not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to dDNSEmailORUser: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00090004,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dDNSHostName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to dDNSHostName not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to dDNSHostName: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00090003,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dDNSProvider(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dDNSProvider not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dDNSProvider: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00090002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dDNSSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dDNSSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dDNSSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00090001,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}






