/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "snmpgroup.h"
#include "csman.h"


/* 
 * snmpgroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

#ifdef SNMP_CUSTOMER_ID //netcom
    //#error 11
    oid snmpgroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,19 };   
#else                    //amit
    //#error 00
    oid snmpgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,19 };   
#endif

//oid snmpgroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,19 };
//oid snmpgroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,19 };


/* 
 * variable2 snmpgroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the snmpgroup mib section 
 */


struct variable2 snmpgroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { SNMPLOCALSWITCH     , ASN_INTEGER   , RWRITE, var_snmpgroup, 1, { 1 } },
  { SNMPREMOTESWITCH    , ASN_INTEGER   , RWRITE, var_snmpgroup, 1, { 2 } },
  { SNMPGETCOMMUNITY    , ASN_OCTET_STR , RWRITE, var_snmpgroup, 1, { 3 } },
  { SNMPSETCOMMUNITY    , ASN_OCTET_STR , RWRITE, var_snmpgroup, 1, { 4 } },
  { SNMPSERVERIP1       , ASN_OCTET_STR , RWRITE, var_snmpgroup, 1, { 5 } },
  { SNMPSERVERIP2       , ASN_OCTET_STR , RWRITE, var_snmpgroup, 1, { 6 } },
  { SNMPSERVERIP3       , ASN_OCTET_STR , RWRITE, var_snmpgroup, 1, { 7 } },
  { SNMPSERVERIP4       , ASN_OCTET_STR , RWRITE, var_snmpgroup, 1, { 8 } },
  { SNMPVERSIONSWITCH   , ASN_INTEGER   , RWRITE, var_snmpgroup, 1, { 9 } },
  { ROUTINGSTATICSWITCH , ASN_INTEGER   , RWRITE, var_snmpgroup, 1, { 10 } },
  { ROUTINGDYNAMICMODE  , ASN_INTEGER   , RWRITE, var_snmpgroup, 1, { 11 } },
  { SNMPWANACCESSIP     , ASN_OCTET_STR , RWRITE, var_snmpgroup, 1, { 12 } },
};
/*    (L = length of the oidsuffix) */


/*
 * init_snmpgroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_snmpgroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("snmpgroup", snmpgroup_variables, variable2,
               snmpgroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_snmpgroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_snmpgroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  long long_ret;
static  unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;
  memset(string,0,sizeof(string));


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {

	case SNMPWANACCESSIP:
		{
			*write_method = write_sNMPWANAccessIP;
			int ret = 0;
			int fd=0;
			unsigned char wan_accessip[512];
			
			memset(wan_accessip,0,sizeof(wan_accessip));
			ret = read_csman(fd,0x0016000d,wan_accessip,sizeof(wan_accessip),TYPE_STR);
	
			strcpy(string,wan_accessip);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case ROUTINGDYNAMICMODE:
		{
			*write_method = write_rOUTINGdynamicmode;
			int ret = 0;
			int fd=0;
			unsigned char wireless_enable;
			ret = read_csman(fd,0x00030001,&wireless_enable,sizeof(unsigned char),TYPE_U32);
			long_ret = wireless_enable;
			return (unsigned char *) &long_ret;
		}

    case ROUTINGSTATICSWITCH:
		{
			*write_method = write_rOUTINGstaticswitch;
			int ret = 0;
			int fd=0;
			unsigned char wireless_enable;
			ret = read_csman(fd,0x00030001,&wireless_enable,sizeof(unsigned char),TYPE_U32);
			long_ret = wireless_enable;
			return (unsigned char *) &long_ret;
		}

    case SNMPVERSIONSWITCH:
		{
			*write_method = write_sNMPVersionSwitch;
			int ret = 0;
			int fd=0;
			unsigned char version_switch;
			ret = read_csman(fd,0x00160009,&version_switch,sizeof(unsigned char),TYPE_U32);
			long_ret = version_switch;
			return (unsigned char *) &long_ret;
		}

    case SNMPSERVERIP4:
		{
			*write_method = write_sNMPServerIP4;
			int ret = 0;
			int fd=0;
			unsigned char server_IP4[512];
			
			memset(server_IP4,0,sizeof(server_IP4));
			ret = read_csman(fd,0x00160008,server_IP4,sizeof(server_IP4),TYPE_STR);
	
			strcpy(string,server_IP4);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}
			
    case SNMPSERVERIP3:
		{
			*write_method = write_sNMPServerIP3;
			int ret = 0;
			int fd=0;
			unsigned char server_IP3[512];
			
			memset(server_IP3,0,sizeof(server_IP3));
			ret = read_csman(fd,0x00160007,server_IP3,sizeof(server_IP3),TYPE_STR);
	
			strcpy(string,server_IP3);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case SNMPSERVERIP2:
		{
			*write_method = write_sNMPServerIP2;
			int ret = 0;
			int fd=0;
			unsigned char server_IP2[512];
			
			memset(server_IP2,0,sizeof(server_IP2));
			ret = read_csman(fd,0x00160006,server_IP2,sizeof(server_IP2),TYPE_STR);
	
			strcpy(string,server_IP2);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case SNMPSERVERIP1:
		{
			*write_method = write_sNMPServerIP1;
			int ret = 0;
			int fd=0;
			unsigned char server_IP1[512];
			
			memset(server_IP1,0,sizeof(server_IP1));
			ret = read_csman(fd,0x00160005,server_IP1,sizeof(server_IP1),TYPE_STR);
	
			strcpy(string,server_IP1);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case SNMPSETCOMMUNITY:
		{
	        *write_method = write_sNMPSetCommunity;
			int ret = 0;
			int fd=0;
			unsigned char set_community[512];
			
			memset(set_community,0,sizeof(set_community));
			ret = read_csman(fd,0x00160004,set_community,sizeof(set_community),TYPE_STR);
	
			strcpy(string,set_community);
	        *var_len = strlen(string);
	        return (unsigned char *) string;
		}

    case SNMPGETCOMMUNITY:
		{
	        *write_method = write_sNMPGetCommunity;
			int ret = 0;
			int fd=0;
			unsigned char get_community[512];
			
			memset(get_community,0,sizeof(get_community));
			ret = read_csman(fd,0x00160003,get_community,sizeof(get_community),TYPE_STR);
	
			strcpy(string,get_community);
	        *var_len = strlen(string);
	        return (unsigned char *) string;
		}

    case SNMPREMOTESWITCH:
		{
	        *write_method = write_sNMPRemoteSwitch;
			int ret = 0;
			int fd=0;
			unsigned char remote_switch;
			ret = read_csman(fd,0x00160002,&remote_switch,sizeof(unsigned char),TYPE_U32);
			long_ret = remote_switch;
	        return (unsigned char *) &long_ret;
		}

    case SNMPLOCALSWITCH:
		{
	        *write_method = write_sNMPLocalSwitch;
			int ret = 0;
			int fd=0;
			unsigned char local_switch;
			ret = read_csman(fd,0x00160001,&local_switch,sizeof(unsigned char),TYPE_U32);
			long_ret = local_switch;
    	    return (unsigned char *) &long_ret;
		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}



int
write_sNMPWANAccessIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sNMPServerIP4 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sNMPServerIP4: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
		  printf("access_ip = %s\n",(char *) var_val);
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x0016000d,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}


int
write_rOUTINGdynamicmode(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to rOUTINGdynamicmode not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to rOUTINGdynamicmode: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_rOUTINGstaticswitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to rOUTINGstaticswitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to rOUTINGstaticswitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_sNMPVersionSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sNMPVersionSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sNMPVersionSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00160009,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sNMPServerIP4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sNMPServerIP4 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sNMPServerIP4: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00160008,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sNMPServerIP3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sNMPServerIP3 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sNMPServerIP3: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00160007,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sNMPServerIP2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sNMPServerIP2 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sNMPServerIP2: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00160006,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sNMPServerIP1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sNMPServerIP1 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sNMPServerIP1: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00160005,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sNMPSetCommunity(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sNMPSetCommunity not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sNMPSetCommunity: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00160004,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sNMPGetCommunity(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to sNMPGetCommunity not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to sNMPGetCommunity: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy( string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00160003,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sNMPRemoteSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sNMPRemoteSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sNMPRemoteSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00160002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_sNMPLocalSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sNMPLocalSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sNMPLocalSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00160001,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}






