/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "wangroup.h"
#include "csman.h"


/* 
 * wangroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

#ifdef SNMP_CUSTOMER_ID //netcom
    //#error 11
    oid wangroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,2 };   
#else                    //amit
    //#error 00
    oid wangroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,2 };   
#endif

//oid wangroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,2 };
//oid wangroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,2 };


/* 
 * variable4 wangroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the wangroup mib section 
 */


struct variable4 wangroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { GATEWAYWANTYPE      , ASN_INTEGER   , RWRITE, var_wangroup, 1, { 1 } },
  { WANIPADDRESS        , ASN_IPADDRESS , RWRITE, var_wangroup, 1, { 2 } },
  { WANNMADDRESS        , ASN_IPADDRESS , RWRITE, var_wangroup, 1, { 3 } },
  { WANGWADDRESS        , ASN_IPADDRESS , RWRITE, var_wangroup, 1, { 4 } },
  { WANPDNSADDRESS      , ASN_IPADDRESS , RWRITE, var_wangroup, 1, { 5 } },
  { WANSDNSADDRESS      , ASN_IPADDRESS , RWRITE, var_wangroup, 1, { 6 } },
  { WANNATSWITCH        , ASN_INTEGER   , RWRITE, var_wangroup, 1, { 7 } },
  { WANHOSTNAME         , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 8 } },
  { WANMACADDRESS       , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 9 } },
  { WANCLONEMACSWITCH   , ASN_INTEGER   , RWRITE, var_wangroup, 1, { 10 } },
  { WANRENEWIPSWITCH    , ASN_INTEGER   , RWRITE, var_wangroup, 1, { 11 } },
  { WANRRSMACCOUNT      , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 12 } },
  { WANRRSMPASSWORD     , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 13 } },
  { WANRRSMSERVERIPORNAME, ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 14 } },
  { GLOBALIP            , ASN_IPADDRESS , RWRITE, var_vComputerTable, 3, { 15,1,1 } },
  { LOCALIP             , ASN_INTEGER   , RWRITE, var_vComputerTable, 3, { 15,1,2 } },
  { ENABLEVC            , ASN_INTEGER   , RWRITE, var_vComputerTable, 3, { 15,1,3 } },
  { VCINDEX             , ASN_INTEGER   , RWRITE, var_vComputerTable, 3, { 15,1,4 } },
  { WANPPPOEACCOUNT     , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 16 } },
  { WANPPPOEPASSWORD    , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 17 } },
  { PPPOECONNETIONCONTROL, ASN_INTEGER   , RWRITE, var_wangroup, 1, { 18 } },
  { MAXIDLETIME         , ASN_INTEGER   , RWRITE, var_wangroup, 1, { 19 } },
  { MTUSIZE             , ASN_INTEGER   , RWRITE, var_wangroup, 1, { 20 } },
  { PPPOESERVICENAME    , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 21 } },
  { PPPOEASSIGNIP       , ASN_IPADDRESS , RWRITE, var_wangroup, 1, { 22 } },
  { WANPPTPSERVERIPORNAME, ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 23 } },
  { WANPPPTPACCOUNT     , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 24 } },
  { WANPPPTPPASSWORD    , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 25 } },
  { IPMODE              , ASN_INTEGER   , RWRITE, var_wangroup, 1, { 26 } },
  { WANL2TPSERVERIPORNAME, ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 27 } },
  { WANL2PTPACCOUNT     , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 28 } },
  { WANL2PTPPASSWORD    , ASN_OCTET_STR , RWRITE, var_wangroup, 1, { 29 } },
  { WANPPPOECONNECTIONTIME , ASN_INTEGER   , RONLY, var_wangroup, 1, { 30 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_wangroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_wangroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("gateway/wangroup", wangroup_variables, variable4,
               wangroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_wangroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_wangroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;
  memset(string,0,sizeof(string));
  printf("start string = %s\n",string);


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case IPMODE:
        *write_method = write_iPMode;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case WANPPPTPPASSWORD:
		{
			*write_method = write_wANPPPTPPassword;
			int ret = 0;
			int fd=0;
			unsigned char pptp_pwd[256];
			memset(pptp_pwd,0,sizeof(pptp_pwd));
			ret = read_csman(fd,0x00050200,pptp_pwd,sizeof(pptp_pwd),TYPE_STR);
	
			strcpy(string,pptp_pwd);
			printf("string = %s\n",string);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WANPPPTPACCOUNT:
		{
			*write_method = write_wANPPPTPAccount;
			int ret = 0;
			int fd=0;
			unsigned char pptp_account[256];
			memset(pptp_account,0,sizeof(pptp_account));
			ret = read_csman(fd,0x00050100,pptp_account,sizeof(pptp_account),TYPE_STR);
	
			strcpy(string,pptp_account);
			printf("string = %s\n",string);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WANPPTPSERVERIPORNAME:
		{
			*write_method = write_wANPPTPServerIPorNAME;
			int ret = 0;
			int fd=0;
			unsigned char pptp_svip[256];
			memset(pptp_svip,0,sizeof(pptp_svip));
			ret = read_csman(fd,0x00050600,pptp_svip,sizeof(pptp_svip),TYPE_STR);
	
			strcpy(string,pptp_svip);
			printf("string = %s\n",string);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case PPPOEASSIGNIP:
		{
			*write_method = write_pPPoEAssignIP;
			int ret = 0;
			int fd=0;
			unsigned char assign_ip[4];
			memset(assign_ip,0,sizeof(assign_ip));
			ret = read_csman(fd,0x00040300,assign_ip,sizeof(assign_ip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=assign_ip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			//        *string = 0;
			*var_len = strlen(string);
			printf("var_len = %d\n",*var_len);
			return (unsigned char *) string;
		}

    case PPPOESERVICENAME:
		{	
			*write_method = write_pPPoEServiceNAME;			
			int ret = 0;
			int fd=0;
			unsigned char service_name[256];
			memset(service_name,0,sizeof(service_name));
			ret = read_csman(fd,0x00040600,service_name,sizeof(service_name),TYPE_STR);
	
			strcpy(string,service_name);
			printf("string = %s\n",string);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case MTUSIZE:
		{
			*write_method = write_mTUSize;
			int ret = 0;
			int fd=0;
			unsigned int mtu_size = 0;
			unsigned char wan_type;
			
			ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			if(wan_type == LOCAL_WANTYPE_DHCP)
				ret = read_csman(fd,0x00035009,&mtu_size,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_3G)
				ret = read_csman(fd,0x001e000b,&mtu_size,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				ret = read_csman(fd,0x00340a00,&mtu_size,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				ret = read_csman(fd,0x00060a00,&mtu_size,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				ret = read_csman(fd,0x00050a00,&mtu_size,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				ret = read_csman(fd,0x00040a00,&mtu_size,sizeof(unsigned int),TYPE_U32);
			printf("mtu_size = %d\n",mtu_size);
			long_ret = mtu_size;
			return (unsigned char *) &long_ret;
		}

    case MAXIDLETIME:
		{ 
			*write_method = write_maxIdletime;
			int ret = 0;
			int fd=0;
			unsigned int max_idletime = 0;
			unsigned char wan_type;
			
			ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			if(wan_type == LOCAL_WANTYPE_DHCP)
				ret = read_csman(fd,0x001e000c,&max_idletime,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_3G)
				ret = read_csman(fd,0x001e000c,&max_idletime,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				ret = read_csman(fd,0x00340b00,&max_idletime,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				ret = read_csman(fd,0x00060b00,&max_idletime,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				ret = read_csman(fd,0x00050b00,&max_idletime,sizeof(unsigned int),TYPE_U32);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				ret = read_csman(fd,0x00040b00,&max_idletime,sizeof(unsigned int),TYPE_U32);
			printf("max_idletime = %d\n",max_idletime);
			long_ret = max_idletime;
			return (unsigned char *) &long_ret;
		}

    case PPPOECONNETIONCONTROL:
		{
			*write_method = write_pPPOEConnetionControl;
			int ret = 0;
			int fd=0;
			unsigned char pppoe_cnt_ctl;
			ret = read_csman(fd,0x0003500A,&pppoe_cnt_ctl,sizeof(unsigned char),TYPE_U32);
			printf("pppoe_cnt_ctl = %u\n",pppoe_cnt_ctl);
			long_ret = pppoe_cnt_ctl;
			return (unsigned char *) &long_ret;
		}

    case WANPPPOEPASSWORD:
		{
			*write_method = write_wANPPPOEPassword;
			int ret = 0;
			int fd=0;
			unsigned char pppoe_password[256];
			memset(pppoe_password,0,sizeof(pppoe_password));
			ret = read_csman(fd,0x00040200,pppoe_password,sizeof(pppoe_password),TYPE_STR);
			strcpy(string,pppoe_password);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WANPPPOEACCOUNT:
		{
			*write_method = write_wANPPPOEAccount;
			
			int ret = 0;
			int fd=0;
			unsigned char pppoe_account[256];
			memset(pppoe_account,0,sizeof(pppoe_account));
			ret = read_csman(fd,0x00040100,pppoe_account,sizeof(pppoe_account),TYPE_STR);
			strcpy(string,pppoe_account);
			printf("string = %s\n",string);

			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WANRRSMSERVERIPORNAME:
        *write_method = write_wANRRSMServerIPorNAME;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case WANRRSMPASSWORD:
        *write_method = write_wANRRSMPassword;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case WANRRSMACCOUNT:
        *write_method = write_wANRRSMAccount;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case WANRENEWIPSWITCH:
		{
			*write_method = write_wANRenewIPSwitch;
			int ret = 0;
			int fd=0;
			unsigned char renew_switch;
			ret = read_csman(fd,0x80035007,&renew_switch,sizeof(unsigned char),TYPE_U32);
			printf("renew_switch = %u\n",renew_switch);
			long_ret = renew_switch;
			return (unsigned char *) &long_ret;
		}

    case WANCLONEMACSWITCH:
		{
			*write_method = write_wANCloneMACSwitch;
			int ret = 0;
			int fd=0;
			unsigned char macclone_switch;
			ret = read_csman(fd,0x00030001,&macclone_switch,sizeof(unsigned char),TYPE_U32);
			printf("macclone_switch = %u\n",macclone_switch);
			return (unsigned char *) &long_ret;
		}

    case WANMACADDRESS:
        *write_method = write_wANMACaddress;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case WANHOSTNAME:
		{
			*write_method = write_wANHostName;
			int ret = 0;
			int fd=0;
			unsigned char hostname[32];
			
			memset(hostname,0,sizeof(hostname));
			ret = read_csman(fd,0x00035002,hostname,sizeof(hostname),TYPE_STR);
	
			strcpy(string,hostname);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WANNATSWITCH:
		{
			*write_method = write_wANNATSwitch;
			int ret = 0;
			int fd=0;
			unsigned char nat_switch;
			ret = read_csman(fd,0x0011000f,&nat_switch,sizeof(unsigned char),TYPE_U32);
			printf("nat_switch = %u\n",nat_switch);
			long_ret = nat_switch;
			long_ret = 0;
			return (unsigned char *) &long_ret;
		}

    case WANSDNSADDRESS:
		{
			*write_method = write_wANSDNSAddress;
			int ret = 0;
			int fd=0;
			unsigned char wan_sdns[4];
			unsigned char wan_type;

			memset(wan_sdns,0,sizeof(wan_sdns));
			ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			
			if(wan_type == LOCAL_WANTYPE_DHCP)
				ret = read_csman(fd,0x80035006,wan_sdns,sizeof(wan_sdns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_FIXED)
				ret = read_csman(fd,0x00110005,wan_sdns,sizeof(wan_sdns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_3G)
				ret = read_csman(fd,0x801e0600,wan_sdns,sizeof(wan_sdns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				ret = read_csman(fd,0x80340800,wan_sdns,sizeof(wan_sdns),TYPE_IPV4);
			/*
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				ret = read_csman(fd,0x00060500,wan_sdns,sizeof(wan_sdns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				ret = read_csman(fd,0x00050500,wan_sdns,sizeof(wan_sdns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				ret = read_csman(fd,0x80040400,wan_sdns,sizeof(wan_sdns),TYPE_IPV4);
			*/
			
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=wan_sdns[i];
			}

			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WANPDNSADDRESS:
		{
			*write_method = write_wANPDNSAddress;
			int ret = 0;
			int fd=0;
			unsigned char wan_pdns[4];
			unsigned char wan_type;

			memset(wan_pdns,0,sizeof(wan_pdns));
			ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			
			if(wan_type == LOCAL_WANTYPE_DHCP)
				ret = read_csman(fd,0x80035005,wan_pdns,sizeof(wan_pdns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_FIXED)
				ret = read_csman(fd,0x00110004,wan_pdns,sizeof(wan_pdns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_3G)
				ret = read_csman(fd,0x801e0500,wan_pdns,sizeof(wan_pdns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				ret = read_csman(fd,0x80340700,wan_pdns,sizeof(wan_pdns),TYPE_IPV4);
			/*
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				ret = read_csman(fd,0x00060500,wan_pdns,sizeof(wan_pdns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				ret = read_csman(fd,0x00050500,wan_pdns,sizeof(wan_pdns),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				ret = read_csman(fd,0x80040400,wan_pdns,sizeof(wan_pdns),TYPE_IPV4);
			 */
			
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=wan_pdns[i];
			}

			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WANGWADDRESS:
		{
			*write_method = write_wANGWAddress;
			int ret = 0;
			int fd=0;
			unsigned char wan_gateway[4];
			unsigned char wan_type;

			memset(wan_gateway,0,sizeof(wan_gateway));
			ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			
			if(wan_type == LOCAL_WANTYPE_DHCP)
				ret = read_csman(fd,0x80035004,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_FIXED)
				ret = read_csman(fd,0x00110003,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_3G)
				ret = read_csman(fd,0x801e2100,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				ret = read_csman(fd,0x80340400,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				ret = read_csman(fd,0x00060500,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				ret = read_csman(fd,0x00050500,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				ret = read_csman(fd,0x80040400,wan_gateway,sizeof(wan_gateway),TYPE_IPV4);
			
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=wan_gateway[i];
			}

			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WANNMADDRESS:
		{
			*write_method = write_wANNMAddress;
			int ret = 0;
			int fd=0;
			unsigned char wan_subnet[4];
			unsigned char wan_type;

			memset(wan_subnet,0,sizeof(wan_subnet));
			ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			
			if(wan_type == LOCAL_WANTYPE_DHCP)
				ret = read_csman(fd,0x80035003,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_FIXED)
				ret = read_csman(fd,0x00110002,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_3G)
				ret = read_csman(fd,0x801e0300,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				ret = read_csman(fd,0x80340300,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				ret = read_csman(fd,0x80060300,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				ret = read_csman(fd,0x80050300,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				ret = read_csman(fd,0x80040300,wan_subnet,sizeof(wan_subnet),TYPE_IPV4);
			
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=wan_subnet[i];
			}

			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WANIPADDRESS:
		{
			*write_method = write_wANIPAddress;
			int ret = 0;
			int fd=0;
			unsigned char wan_ip[4];
			unsigned char wan_type;
			*string = 0;

			memset(wan_ip,0,sizeof(wan_ip));
			
			ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
		
			if(wan_type == LOCAL_WANTYPE_3G)
				ret = read_csman(fd,0x801e0006,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_IBURST)
				ret = read_csman(fd,0x80340200,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_L2TP)
				ret = read_csman(fd,0x80060200,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPTP)
				ret = read_csman(fd,0x80050200,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_PPPOE)
				ret = read_csman(fd,0x00040300,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_FIXED)
				ret = read_csman(fd,0x00110001,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			else if(wan_type == LOCAL_WANTYPE_DHCP)
				ret = read_csman(fd,0x80035002,wan_ip,sizeof(wan_ip),TYPE_IPV4);
			
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=wan_ip[i];
			}

			printf("%s,%d\n",__FUNCTION__,__LINE__);
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case GATEWAYWANTYPE:
		{
			*write_method = write_gatewayWANtype;
			int ret = 0;
			int fd=0;
			unsigned char wan_type;
			ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			long_ret = wan_type;
			return (unsigned char *) &long_ret;
		}
	case WANL2TPSERVERIPORNAME:
		{
			*write_method = write_wANL2TPServerIPorNAME;
			int ret = 0;
			int fd=0;
			unsigned char pptp_svip[256];
			memset(pptp_svip,0,sizeof(pptp_svip));
			ret = read_csman(fd,0x00060600,pptp_svip,sizeof(pptp_svip),TYPE_STR);
	
			strcpy(string,pptp_svip);
			printf("string = %s\n",string);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}
	case WANL2PTPACCOUNT:
		{
			*write_method = write_wANL2TPAccount;
			
			int ret = 0;
			int fd=0;
			unsigned char pppoe_account[256];
			memset(pppoe_account,0,sizeof(pppoe_account));
			ret = read_csman(fd,0x00060100,pppoe_account,sizeof(pppoe_account),TYPE_STR);
			strcpy(string,pppoe_account);
			printf("string = %s\n",string);

			*var_len = strlen(string);
			return (unsigned char *) string;
		}
	case WANL2PTPPASSWORD:
		{
			*write_method = write_wANL2TPPassword;
			int ret = 0;
			int fd=0;
			unsigned char pppoe_password[256];
			memset(pppoe_password,0,sizeof(pppoe_password));
			ret = read_csman(fd,0x00060200,pppoe_password,sizeof(pppoe_password),TYPE_STR);
			strcpy(string,pppoe_password);
			*var_len = strlen(string);
			return (unsigned char *) string;
			
		}
	case WANPPPOECONNECTIONTIME:
		{
		//	*write_method = write_wANPPPoEConnectionTime; 
			int ret = 0;
			int fd=0;
			unsigned int cnt_time = 0;
			
			ret = read_csman(fd,0x80040100,&cnt_time,sizeof(unsigned int),TYPE_U32);
			printf("cnt_time = %d\n",cnt_time);
			return (unsigned char *) &long_ret;

		}


    default:
      ERROR_MSG("");
  }
  return NULL;
}


/*
 * var_vComputerTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_wangroup above.
 */
unsigned char *
var_vComputerTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;

  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
  if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case VCINDEX:
        *write_method = write_vcindex;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case ENABLEVC:
        *write_method = write_enableVC;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case LOCALIP:
        *write_method = write_localIP;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case GLOBALIP:
        *write_method = write_globalIP;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;


    default:
      ERROR_MSG("");
  }
  return NULL;
}




int
write_iPMode(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to iPMode not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to iPMode: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANPPPTPPassword(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANPPPTPPassword not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANPPPTPPassword: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x00050200,string,strlen(string)+1,TYPE_STR);
//			ret = write_csman(fd,0x80051001,&altered,sizeof(int),TYPE_U32);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANPPPTPAccount(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANPPPTPAccount not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANPPPTPAccount: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x00050100,string,strlen(string)+1,TYPE_STR);
//			ret = write_csman(fd,0x80051001,&altered,sizeof(int),TYPE_U32);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANPPTPServerIPorNAME(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANPPTPServerIPorNAME not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANPPTPServerIPorNAME: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x00050600,string,strlen(string)+1,TYPE_STR);
//			ret = write_csman(fd,0x80051001,&altered,sizeof(int),TYPE_U32);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_pPPoEAssignIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to pPPoEAssignIP not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to pPPoEAssignIP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  int altered=1;
			  ret=write_csman(fd,0x00040300,string,strlen(string) ,TYPE_IPV4);
			  ret = write_csman(fd,0x80040a00,&altered,sizeof(int),TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_pPPoEServiceNAME(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to pPPoEServiceNAME not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to pPPoEServiceNAME: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x00040600,string,strlen(string)+1,TYPE_STR);
			ret = write_csman(fd,0x80040a00,&altered,sizeof(int),TYPE_U32); //altered
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_mTUSize(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to mTUSize not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to mTUSize: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;

          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  int altered=1;
			  unsigned char wan_type;
			  ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			  
			  if(wan_type == LOCAL_WANTYPE_DHCP)
			  {
				ret = write_csman(fd,0x0003500d,&long_ret,sizeof(unsigned int),TYPE_U32);
//				ret = write_csman(fd, 0x80030002, &altered, sizeof(int) ,TYPE_U32);
			  }
			  else if(wan_type == LOCAL_WANTYPE_3G)
			  {
				  ret = write_csman(fd,0x001e000c,&long_ret,sizeof(unsigned int),TYPE_U32);
//				  ret = write_csman(fd, 0x801e0c00, &altered,sizeof(int) ,TYPE_U32);
			  }
			  else if(wan_type == LOCAL_WANTYPE_IBURST)
			  {
				  ret = write_csman(fd,0x00340b00,&long_ret,sizeof(unsigned int),TYPE_U32);
///				  ret = write_csman(fd, 0x80340a00, &altered, sizeof(int) ,TYPE_U32);
			  }
			  else if(wan_type == LOCAL_WANTYPE_L2TP)
			  {
				  ret = write_csman(fd,0x00060b00,&long_ret,sizeof(unsigned int),TYPE_U32);
//				  ret = write_csman(fd, 0x80061001, &altered, sizeof(int) ,TYPE_U32);
			  }
			  else if(wan_type == LOCAL_WANTYPE_PPTP)
			  {
				  ret = write_csman(fd,0x00050b00,&long_ret,sizeof(unsigned int),TYPE_U32);
//				  ret = write_csman(fd, 0x80051001, &altered, sizeof(int) ,TYPE_U32);
			  }
			  else if(wan_type == LOCAL_WANTYPE_PPPOE)
			  {
				  ret = write_csman(fd,0x00040b00,&long_ret,sizeof(unsigned int),TYPE_U32);
//				  ret = write_csman(fd, 0x80040a00, &altered, sizeof(int) ,TYPE_U32);
			  }
			  ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32);
			  break;				  
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_maxIdletime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to maxIdletime not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to maxIdletime: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  int altered=1;
			  unsigned char wan_type;
			  ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			  if(wan_type == LOCAL_WANTYPE_DHCP)
			  {
				  ret = write_csman(fd,0x0003500d,&long_ret,sizeof(unsigned int),TYPE_U32);
//				  ret = write_csman(fd, 0x80030002, &altered, sizeof(int) ,TYPE_U32);
			  }
			  else if(wan_type == LOCAL_WANTYPE_3G)
			  {
				  ret = write_csman(fd,0x001e000c,&long_ret,sizeof(unsigned int),TYPE_U32);
//				  ret = write_csman(fd, 0x801e0c00, &altered,sizeof(int) ,TYPE_U32);
			  }
			  else if(wan_type == LOCAL_WANTYPE_IBURST)
			  {
				  ret = write_csman(fd,0x00340b00,&long_ret,sizeof(unsigned int),TYPE_U32);
//				  ret = write_csman(fd, 0x80340a00, &altered, sizeof(int) ,TYPE_U32);
			  }
			  else if(wan_type == LOCAL_WANTYPE_L2TP)
			  {
				  ret = write_csman(fd,0x00060b00,&long_ret,sizeof(unsigned int),TYPE_U32);
//				  ret = write_csman(fd, 0x80061001, &altered, sizeof(int) ,TYPE_U32);
			  }
			  else if(wan_type == LOCAL_WANTYPE_PPTP)
			  {
				  ret = write_csman(fd,0x00050b00,&long_ret,sizeof(unsigned int),TYPE_U32);
//				  ret = write_csman(fd, 0x80051001, &altered, sizeof(int) ,TYPE_U32);
			  }
			  else if(wan_type == LOCAL_WANTYPE_PPPOE)
			  {
				  ret = read_csman(fd,0x00040b00,&long_ret,sizeof(unsigned int),TYPE_U32);
//				  ret = write_csman(fd, 0x80040a00, &altered, sizeof(int) ,TYPE_U32);
			  }
			  ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32);
          break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_pPPOEConnetionControl(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to pPPOEConnetionControl not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to pPPOEConnetionControl: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  int altered=1;
			  ret=write_csman(fd,0x0003500A,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  ret = write_csman(fd, 0x80040a00, &altered, sizeof(int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANPPPOEPassword(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANPPPOEPassword not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANPPPOEPassword: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  printf("string = %s,var_val = %s\n",string,(char *) var_val);
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }

        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x00040200,string,strlen(string)+1,TYPE_STR);
//			ret = write_csman(fd, 0x80040a00, &altered, sizeof(int) ,TYPE_U32);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANPPPOEAccount(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANPPPOEAccount not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANPPPOEAccount: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  //string = (char *) var_val;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);         
			  break;
		  }


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x00040100,string,strlen(string)+1,TYPE_STR);
//			ret = write_csman(fd, 0x80040a00, &altered, sizeof(int) ,TYPE_U32);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_vcindex(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to vcindex not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to vcindex: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_enableVC(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to enableVC not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to enableVC: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_localIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to localIP not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to localIP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_globalIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to globalIP not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to globalIP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANRRSMServerIPorNAME(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANRRSMServerIPorNAME not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANRRSMServerIPorNAME: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANRRSMPassword(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANRRSMPassword not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANRRSMPassword: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANRRSMAccount(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANRRSMAccount not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANRRSMAccount: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANRenewIPSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wANRenewIPSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wANRenewIPSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  int altered=1;
			  ret=write_csman(fd,0x80035007,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  ret = write_csman(fd, 0x80030002, &altered, sizeof(int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANCloneMACSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wANCloneMACSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wANCloneMACSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00030001,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANMACaddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANMACaddress not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANMACaddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANHostName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANHostName not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANHostName: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }

          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x00035002,string,strlen(string)+1,TYPE_STR);
			ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANNATSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wANNATSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wANNATSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  int altered=1;
			  ret=write_csman(fd,0x0011000f,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32); 
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANSDNSAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to wANSDNSAddress not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANSDNSAddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int  fd;
			  unsigned char wan_type;
			  int ret;
			  int altered=1;
			  
			  ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char) ,TYPE_U32);
			  
			  if(wan_type == LOCAL_WANTYPE_DHCP)
				  ret = write_csman(fd,0x80035006,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_FIXED)
				  ret = write_csman(fd,0x00110005,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_3G)
				  ret = write_csman(fd,0x801e0600,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_IBURST)
				  ret = write_csman(fd,0x80340600,string,strlen(string),TYPE_IPV4);

			  ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32); 
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANPDNSAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to wANPDNSAddress not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANPDNSAddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int  fd;
			  unsigned char wan_type;
			  int ret;
			  int altered=1;
			  
			  ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			  
			  if(wan_type == LOCAL_WANTYPE_DHCP)
				  ret = write_csman(fd,0x80035005,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_FIXED)
				  ret = write_csman(fd,0x00110004,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_3G)
				  ret = write_csman(fd,0x801e0500,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_IBURST)
				  ret = write_csman(fd,0x80340500,string,strlen(string),TYPE_IPV4);
			  /*
			  else if(wan_type == LOCAL_WANTYPE_L2TP)
				  ret = read_csman(fd,0x00060500,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_PPTP)
				  ret = read_csman(fd,0x00050500,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_PPPOE)				
				  ret = read_csman(fd,0x80040400,string,strlen(string),TYPE_IPV4);
			   */
			  ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32); 
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANGWAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to wANGWAddress not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANGWAddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int  fd;
			  unsigned char wan_type;
			  int ret;
			  int altered=1;
			  
			  ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			  
			  if(wan_type == LOCAL_WANTYPE_DHCP)
				  ret = write_csman(fd,0x80035004,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_FIXED)
				  ret = write_csman(fd,0x00110003,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_3G)
				  ret = write_csman(fd,0x801e2100,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_IBURST)
				  ret = write_csman(fd,0x80340400,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_L2TP)
				  ret = write_csman(fd,0x00060500,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_PPTP)
				  ret = write_csman(fd,0x00050500,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_PPPOE)				
				  ret = write_csman(fd,0x80040400,string,strlen(string),TYPE_IPV4);
			  ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32); 
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANNMAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to wANNMAddress not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANNMAddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int  fd;
			  unsigned char wan_type;
			  int ret;
			  int altered=1;
			  
			  ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			  
			  if(wan_type == LOCAL_WANTYPE_DHCP)
				  ret = write_csman(fd,0x80035003,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_FIXED)
				  ret = write_csman(fd,0x00110002,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_3G)
				  ret = write_csman(fd,0x801e0300,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_IBURST)
				  ret = write_csman(fd,0x80340300,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_L2TP)
				  ret = write_csman(fd,0x80060300,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_PPTP)
				  ret = write_csman(fd,0x00050300,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_PPPOE)				
				  ret = write_csman(fd,0x80040300,string,strlen(string),TYPE_IPV4);
			  ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32); 
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wANIPAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to wANIPAddress not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANIPAddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          strcpy(string , (char *) var_val);
          //string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int  fd;
			  unsigned char wan_type;
			  int ret;
			  int altered=1;
			  
			  ret = read_csman(fd,0x00010003,&wan_type,sizeof(unsigned char),TYPE_U32);
			  
			  if(wan_type == LOCAL_WANTYPE_3G)
				  ret = write_csman(fd,0x001e0006,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_IBURST)
				  ret = write_csman(fd,0x80340200,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_L2TP)
				  ret = write_csman(fd,0x80060200,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_PPTP)
				  ret = write_csman(fd,0x80050200,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_PPPOE)				
				  ret = write_csman(fd,0x00040300,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_FIXED)
				  ret = write_csman(fd,0x00110001,string,strlen(string),TYPE_IPV4);
			  else if(wan_type == LOCAL_WANTYPE_DHCP)
				  ret = write_csman(fd,0x80035002,string,strlen(string),TYPE_IPV4);
			  ret = write_csman(fd, 0x80010008, &altered, sizeof(int) ,TYPE_U32); 
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_gatewayWANtype(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to gatewayWANtype not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to gatewayWANtype: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;
		  printf("long_ret = %u\n",long_ret);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  int altered=1;
			  ret=write_csman(fd,0x00010003,&long_ret,sizeof(unsigned int) ,TYPE_U32); //way_type
			  ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32); 
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}

int
write_wANL2TPServerIPorNAME(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANPPTPServerIPorNAME not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANPPTPServerIPorNAME: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x00060600,string,strlen(string)+1,TYPE_STR);
//			  ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32); 
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}





int
write_wANL2TPAccount(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANPPPTPAccount not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANPPPTPAccount: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;						
			ret = write_csman(fd,0x00060100,string,strlen(string)+1,TYPE_STR);
//			ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32); 
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}

int
write_wANL2TPPassword(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
static  unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANPPPTPPassword not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANPPPTPPassword: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
						
			ret = write_csman(fd,0x00060200,string,strlen(string)+1,TYPE_STR);
		//	ret = write_csman(fd, 0x80010009, &altered, sizeof(int) ,TYPE_U32); 
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}
