/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "wlangroup.h"
#include "csman.h"


/* 
 * wlangroup_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
#ifdef SNMP_CUSTOMER_ID //netcom
   // #error 11
	oid wlangroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,4 };	   
#else                    //amit
    //#error 00
	oid wlangroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,4 };	   
#endif

//oid wlangroup_variables_oid[] = { 1,3,6,1,4,1,851,1,3,9,4 };

//oid wlangroup_variables_oid[] = { 1,3,6,1,4,1,12823,1,3,9,4 };


/* 
 * variable2 wlangroup_variables:
 *   this variable defines function callbacks and type return information 
 *   for the wlangroup mib section 
 */


struct variable2 wlangroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
  { WLANFUNCTIONSWITCH  , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 1 } },
  { WLANESSID           , ASN_OCTET_STR , RWRITE, var_wlangroup, 1, { 2 } },
  { WIRELESSCHANNEL     , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 3 } },
  { WEPMODE             , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 4 } },
  { WEPKEYTYPE          , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 5 } },
  { WLANKEY1            , ASN_OCTET_STR , RWRITE, var_wlangroup, 1, { 6 } },
  { WLANKEY2            , ASN_OCTET_STR , RWRITE, var_wlangroup, 1, { 7 } },
  { WLANKEY3            , ASN_OCTET_STR , RWRITE, var_wlangroup, 1, { 8 } },
  { WLANKEY4            , ASN_OCTET_STR , RWRITE, var_wlangroup, 1, { 9 } },
  { ENABLEKEYNUMBER     , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 10 } },
  { BEACONINTERVAL      , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 11 } },
  { RTSTHRESHOLD        , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 12 } },
  { FRAGMENTATIONTHRESHOLD, ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 13 } },
  { DTIMINTERVAL        , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 14 } },
  { WIRELESSMODE        , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 15 } },
  { TXRATE              , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 16 } },
  { PREAMBLETYPE        , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 17 } },
  { AUTHENTICATIONTYPE  , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 18 } },
  { SSIDBROADCAST       , ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 19 } },
  { ANTENNATRANSMITPOWER, ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 20 } },
  { WLANKEYTYPE1            , ASN_INTEGER , RWRITE, var_wlangroup, 1, { 21 } },
  { WLANKEYTYPE2            , ASN_INTEGER , RWRITE, var_wlangroup, 1, { 22 } },
  { WLANKEYTYPE3            , ASN_INTEGER , RWRITE, var_wlangroup, 1, { 23 } },
  { WLANKEYTYPE4            , ASN_INTEGER , RWRITE, var_wlangroup, 1, { 24 } },
  { PRESHAREKEY         , ASN_OCTET_STR , RWRITE, var_wlangroup, 1, { 25 } },
  { RADIUSSVRIP     	, ASN_IPADDRESS , RWRITE, var_wlangroup, 1, { 26 } },
  { RADIUSSVRPORT		, ASN_INTEGER   , RWRITE, var_wlangroup, 1, { 27 } },
  { RADIUSPRESHAREKEY   , ASN_OCTET_STR , RWRITE, var_wlangroup, 1, { 28 } },
};
/*    (L = length of the oidsuffix) */


/*
 * init_wlangroup():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_wlangroup(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("gateway/wlangroup", wlangroup_variables, variable2,
               wlangroup_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_wlangroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_wlangroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;

  memset(string,0,sizeof(string));


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case ANTENNATRANSMITPOWER:
        *write_method = write_antennaTransmitPower;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case SSIDBROADCAST:
		{
			*write_method = write_sSIDbroadcast;
			int ret = 0;
			int fd=0;
			unsigned char ssidbroadcast;
			ret = read_csman(fd,0x00190e00,&ssidbroadcast,sizeof(unsigned char),TYPE_U32);
			printf("ssidbroadcast = %u\n",ssidbroadcast);
			long_ret = ssidbroadcast;
			return (unsigned char *) &long_ret;
		}

    case AUTHENTICATIONTYPE:
		{
			*write_method = write_authenticationtype;
			int ret = 0;
			int fd=0;
			unsigned char auth_type;
			ret = read_csman(fd,0x00191300,&auth_type,sizeof(unsigned char),TYPE_U32);
			printf("auth_type = %u\n",auth_type);
			long_ret = auth_type;
			return (unsigned char *) &long_ret;
		}

    case PREAMBLETYPE:
        *write_method = write_preambletype;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case TXRATE:
        *write_method = write_txRate;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case WIRELESSMODE:
		{
			*write_method = write_wirelessMode;
			int ret = 0;
			int fd=0;
			unsigned char wireless_mode;
			ret = read_csman(fd,0x00190c00,&wireless_mode,sizeof(unsigned char),TYPE_U32);
			printf("wireless_mode = %u\n",wireless_mode);
			long_ret = wireless_mode;
			return (unsigned char *) &long_ret;
		}

    case DTIMINTERVAL:
		{
			*write_method = write_dTIMinterval;
			int ret = 0;
			int fd=0;
			unsigned char dtiminterval;
			ret = read_csman(fd,0x00190a00,&dtiminterval,sizeof(unsigned char),TYPE_U32);
			printf(" dtiminterval= %u\n",dtiminterval);
			long_ret = dtiminterval;
			return (unsigned char *) &long_ret;
		}

    case FRAGMENTATIONTHRESHOLD:
		{
			*write_method = write_fragmentationthreshold;
			int ret = 0;
			int fd=0;
			unsigned char fragmentationthreshold;
			ret = read_csman(fd,0x00190700,&fragmentationthreshold,sizeof(unsigned char),TYPE_U32);
			printf("fragmentationthreshold = %u\n",fragmentationthreshold);
			long_ret = fragmentationthreshold;
			return (unsigned char *) &long_ret;
		}

    case RTSTHRESHOLD:
		{
			*write_method = write_rTSthreshold;
			int ret = 0;
			int fd=0;
			unsigned char rtsthreshold;
			ret = read_csman(fd,0x00190800,&rtsthreshold,sizeof(unsigned char),TYPE_U32);
			printf("rtsthreshold = %u\n",rtsthreshold);
			long_ret = rtsthreshold;
			return (unsigned char *) &long_ret;
		}

    case BEACONINTERVAL:
		{
			*write_method = write_beaconInterval;
			int ret = 0;
			int fd=0;
			unsigned char beaconinterval;
			ret = read_csman(fd,0x00190900,&beaconinterval,sizeof(unsigned char),TYPE_U32);
			printf("beaconinterval = %u\n",beaconinterval);
			long_ret = beaconinterval;
			return (unsigned char *) &long_ret;
		}

    case ENABLEKEYNUMBER:
		{
			*write_method = write_enableKeynumber;
			int ret = 0;
			int fd=0;
			unsigned char enable_keynm;
			ret = read_csman(fd,0x00191600,&enable_keynm,sizeof(unsigned char),TYPE_U32);
			printf("enable_keynm = %u\n",enable_keynm);
			return (unsigned char *) &long_ret;
		}

    case WLANKEY4:
		{
			*write_method = write_wLANKey4;
			int ret = 0;
			int fd=0;
			unsigned char wlankey4[512];
			
			memset(wlankey4,0,sizeof(wlankey4));
			ret = read_csman(fd,0x00191e00,wlankey4,sizeof(wlankey4),TYPE_STR);
	
			strcpy(string,wlankey4);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WLANKEY3:
		{
			*write_method = write_wLANKey3;
			int ret = 0;
			int fd=0;
			unsigned char wlankey3[512];
			
			memset(wlankey3,0,sizeof(wlankey3));
			ret = read_csman(fd,0x00191c00,wlankey3,sizeof(wlankey3),TYPE_STR);
	
			strcpy(string,wlankey3);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WLANKEY2:
		{
			*write_method = write_wLANKey2;
			int ret = 0;
			int fd=0;
			unsigned char wlankey2[512];
			
			memset(wlankey2,0,sizeof(wlankey2));
			ret = read_csman(fd,0x00191a00,wlankey2,sizeof(wlankey2),TYPE_STR);
	
			strcpy(string,wlankey2);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}
    case WLANKEY1:
		{
			*write_method = write_wLANKey1;
			int ret = 0;
			int fd=0;
			unsigned char wlankey1[512];
			
			memset(wlankey1,0,sizeof(wlankey1));
			ret = read_csman(fd,0x00191800,wlankey1,sizeof(wlankey1),TYPE_STR);
	
			strcpy(string,wlankey1);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WEPKEYTYPE:
        *write_method = write_wEPKeytype;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case WEPMODE:
		{
			*write_method = write_wEPMode;
			int ret = 0;
			int fd=0;
			unsigned char wepmode;
			ret = read_csman(fd,0x00191400,&wepmode,sizeof(unsigned char),TYPE_U32);
			printf("wepmode = %u\n",wepmode);
			long_ret = wepmode;
			return (unsigned char *) &long_ret;
		}

    case WIRELESSCHANNEL:
		{
			*write_method = write_wirelessChannel;
			int ret = 0;
			int fd=0;
			unsigned char channel;
			ret = read_csman(fd,0x00190c00,&channel,sizeof(unsigned char),TYPE_U32);
			printf("channel = %u\n",channel);
			long_ret = channel;
	        return (unsigned char *) &long_ret;  
		}
    case WLANESSID:
		{
			*write_method = write_wLANESSID;
			int ret = 0;
			int fd=0;
			unsigned char wlanssid[32];
			
			memset(wlanssid,0,sizeof(wlanssid));
			ret = read_csman(fd,0x00190400,wlanssid,sizeof(wlanssid),TYPE_STR);
	
			strcpy(string,wlanssid);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    case WLANFUNCTIONSWITCH:
		{
			*write_method = write_wLANFunctionSwitch;
			int ret = 0;
			int fd=0;
			unsigned char wireless_enable;
			ret = read_csman(fd,0x00010010,&wireless_enable,sizeof(unsigned char),TYPE_U32);
			printf("wireless_enable = %u\n",wireless_enable);
			long_ret = wireless_enable;
	        return (unsigned char *) &long_ret;  
		}
		
	case WLANKEYTYPE1:
		{
			*write_method = write_wlankeytype1;
			int ret = 0;
			int fd=0;
			unsigned char wlankeytype1;
			ret = read_csman(fd,0x00191700,&wlankeytype1,sizeof(unsigned char),TYPE_U32);
			printf("wlankeytype1 = %u\n",wlankeytype1);
			long_ret = wlankeytype1;
	        return (unsigned char *) &long_ret;  
		}

	case WLANKEYTYPE2:
		{
			*write_method = write_wlankeytype2;
			int ret = 0;
			int fd=0;
			unsigned char wlankeytype2;
			ret = read_csman(fd,0x00191900,&wlankeytype2,sizeof(unsigned char),TYPE_U32);
			printf("wlankeytype2 = %u\n",wlankeytype2);
			long_ret = wlankeytype2;
	        return (unsigned char *) &long_ret;  
		}

	case WLANKEYTYPE3:
		{
			*write_method = write_wlankeytype3;
			int ret = 0;
			int fd=0;
			unsigned char wlankeytype3;
			ret = read_csman(fd,0x00191b00,&wlankeytype3,sizeof(unsigned char),TYPE_U32);
			printf("wlankeytype3 = %u\n",wlankeytype3);
			long_ret = wlankeytype3;
	        return (unsigned char *) &long_ret;  
		}

	case WLANKEYTYPE4:
		{
			*write_method = write_wlankeytype4;
			int ret = 0;
			int fd=0;
			unsigned char wlankeytype4;
			ret = read_csman(fd,0x00191d00,&wlankeytype4,sizeof(unsigned char),TYPE_U32);
			printf("wlankeytype4 = %u\n",wlankeytype4);
			long_ret = wlankeytype4;
	        return (unsigned char *) &long_ret;  
		}
	case PRESHAREKEY:
		{
			*write_method = write_presharekey;
			int ret = 0;
			int fd=0;
			unsigned char presharekey[512];
			
			memset(presharekey,0,sizeof(presharekey));
			ret = read_csman(fd,0x00035002,presharekey,sizeof(presharekey),TYPE_STR);
	
			strcpy(string,presharekey);
			*var_len = strlen(string);
			return (unsigned char *) string;
		}
	case RADIUSSVRIP:
		{
			*write_method = write_radiussvrip;
			*string = 0;
			int ret = 0;
			int fd=0;
			unsigned char radiussvrip[4];
			memset(radiussvrip,0,sizeof(radiussvrip));
			ret = read_csman(fd,0x00193000,radiussvrip,sizeof(radiussvrip),TYPE_IPV4);
		
			int i=0;
			for(i=0;i<4;i++)
			{
				string[i]=radiussvrip[i];
			}
			printf("string = %u.%u.%u.%u\n",string[0],string[1],string[2],string[3]);
			//        *string = 0;
			*var_len = strlen(string);
			printf("var_len = %d\n",*var_len);
			return (unsigned char *) string;
		}
	case RADIUSSVRPORT:
		{
			*write_method = write_radiussvrport;
			int ret = 0;
			int fd=0;
			unsigned int radiussvrport = 0;
			ret = read_csman(fd,0x00030002,&radiussvrport,sizeof(unsigned int),TYPE_U32);
			printf("radiussvrport = %d\n",radiussvrport);
			long_ret = radiussvrport;
	        return (unsigned int *) &long_ret;  
		}
	case RADIUSPRESHAREKEY:
		{
			*write_method = write_radiuspresharekey;
			int ret = 0;
			int fd=0;
			unsigned char radiuspresharekey[256];
			memset(radiuspresharekey,0,sizeof(radiuspresharekey));
			ret = read_csman(fd,0x00194000,radiuspresharekey,sizeof(radiuspresharekey),TYPE_STR);
	
			strcpy(string,radiuspresharekey);
			printf("string = %s\n",string);
			//        *string = 0;
			*var_len = strlen(string);
			return (unsigned char *) string;
		}

    default:
      ERROR_MSG("");
  }
  return NULL;
}





int
write_antennaTransmitPower(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to antennaTransmitPower not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to antennaTransmitPower: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_sSIDbroadcast(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to sSIDbroadcast not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to sSIDbroadcast: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00190e00,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_authenticationtype(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to authenticationtype not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to authenticationtype: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00191300,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_preambletype(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to preambletype not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to preambletype: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_txRate(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to txRate not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to txRate: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wirelessMode(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wirelessMode not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wirelessMode: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00190c00,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_dTIMinterval(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dTIMinterval not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dTIMinterval: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00190a00,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_fragmentationthreshold(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to fragmentationthreshold not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to fragmentationthreshold: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00190700,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_rTSthreshold(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to rTSthreshold not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to rTSthreshold: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00190800,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_beaconInterval(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to beaconInterval not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to beaconInterval: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00190900,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_enableKeynumber(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to enableKeynumber not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to enableKeynumber: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00191600,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wLANKey4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wLANKey4 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wLANKey4: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00191e00,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wLANKey3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wLANKey3 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wLANKey3: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
			  memset(string,0,sizeof(string));
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00191c00,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wLANKey2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wLANKey2 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wLANKey2: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00191a00,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wLANKey1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wLANKey1 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wLANKey1: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          //string = (char *) var_val;
          strcpy(string , (char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00191800,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wEPKeytype(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wEPKeytype not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wEPKeytype: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wEPMode(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wEPMode not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wEPMode: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00191400,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wirelessChannel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wirelessChannel not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wirelessChannel: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00190c00,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wLANESSID(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wLANESSID not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wLANESSID: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  break;
		  }

        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			int altered=1;
			ret = write_csman(fd,0x00190400,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}




int
write_wLANFunctionSwitch(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wLANFunctionSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wLANFunctionSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00010010,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}


int
write_wlankeytype1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wLANFunctionSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wLANFunctionSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00191700,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}



int
write_wlankeytype2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wLANFunctionSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wLANFunctionSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00191900,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}

int
write_wlankeytype3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wLANFunctionSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wLANFunctionSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00191b00,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}

int
write_wlankeytype4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to wLANFunctionSwitch not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to wLANFunctionSwitch: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00191d00,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}

int
write_presharekey(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to wANHostName not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to wANHostName: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }

          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00191f00,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}

int
write_radiussvrip(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to secWINS not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to secWINS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
		  memset(string,0,sizeof(string));
          //string = (char *) var_val;
		  strcpy(string,(char *) var_val);


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret;
			  int fd;
			  ret=write_csman(fd,0x00193000,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}

int
write_radiussvrport(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned int long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to dHCPLeaseTime not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to dHCPLeaseTime: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = *(unsigned int *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			  int ret=0;
			  int fd=0;
			  ret=write_csman(fd,0x00193800,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
  }
  return SNMP_ERR_NOERROR;
}

int
write_radiuspresharekey(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;
//  printf("action = %d,var_val = %s,var_val_type = %u\nvar_val_len = %d,*statP = %s\n",action,var_val,var_val_type,var_val_len,statP);
  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              printf(stderr, "write to domainsuffix not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              printf(stderr,"write to domainsuffix: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
		  {
			  size = var_val_len;
			  memset(string,0,sizeof(string));
			  strcpy(string , (char *) var_val);
			  printf("RESERVE2: string = %s\n",string);
			  break;
		  }

        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
		  {
			int ret;
			int fd;
			ret = write_csman(fd,0x00194000,string,strlen(string)+1,TYPE_STR);
			break;
		  }
  }
  return SNMP_ERR_NOERROR;
}
