/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
 */

#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "IPv6SystemStatus.h"
#include "csman.h"

/* 
 * IPv6SystemStatus_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
#ifdef SNMP_CUSTOMER_ID //netcom
 // #error 11
oid IPv6SystemStatus_variables_oid[] = { 1,3,6,1,4,1,851,2,3,9,1,1,2 };
#else
 // #error 00
oid IPv6SystemStatus_variables_oid[] = { 1,3,6,1,4,1,12823,2,3,9,1,1,2 };
#endif

/* 
 * variable7 IPv6SystemStatus_variables:
 *   this variable defines function callbacks and type return information 
 *   for the IPv6SystemStatus mib section 
 */

struct variable7 IPv6SystemStatus_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
{STAT6IPV6ENABLE,  ASN_INTEGER,  RONLY ,  var_IPv6SystemStatus, 1,  { 1 }},
{STAT6WANLINKLOCALTYPE,  ASN_INTEGER,  RONLY ,  var_IPv6SystemStatus, 1,  { 2 }},
{STAT6WANLINKLOCALADDRESS,  ASN_OCTET_STR,  RONLY ,  var_IPv6SystemStatus, 1,  { 3 }},
{STAT6GLOBALADDRESS,  ASN_OCTET_STR,  RONLY ,  var_IPv6SystemStatus, 1,  { 4 }},
{STAT6LANLINKLOCALADDRESS,  ASN_OCTET_STR,  RONLY ,  var_IPv6SystemStatus, 1,  { 5 }},
{STAT6LINKSTATUS,  ASN_INTEGER,  RONLY ,  var_IPv6SystemStatus, 1,  { 6 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the IPv6SystemStatus module */
void
init_IPv6SystemStatus(void)
{

    DEBUGMSGTL(("IPv6SystemStatus", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("IPv6SystemStatus", IPv6SystemStatus_variables, variable7,
               IPv6SystemStatus_variables_oid);

    /* place any other initialization junk you need here */
}

/*
 * var_IPv6SystemStatus():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_IPv6SystemStatus(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {

    case STAT6IPV6ENABLE:
		{
			unsigned char stat6_ipv6_enable;
			read_csman(fd,0x00900000,&stat6_ipv6_enable,sizeof(unsigned int),TYPE_U32);
			long_ret = stat6_ipv6_enable;
	        return (unsigned char *) &long_ret;
		}
    case STAT6WANLINKLOCALTYPE:
		{
			unsigned int stat6_ipv6_type;
			read_csman(fd,0x00900001,&stat6_ipv6_type,sizeof(unsigned int),TYPE_U32);
			
			if(stat6_ipv6_type == 0x0100) //Static IPv6
				long_ret = 1;
			else if (stat6_ipv6_type == 0x0200) //DHCP IPv6
				long_ret = 2;
			else if (stat6_ipv6_type == 0x0300) //PPPoE
				long_ret = 3;
			else if (stat6_ipv6_type == 0x0400) //6 to 4
				long_ret = 4;
			else if (stat6_ipv6_type == 0x0500) //6 in 4
				long_ret = 5;

	        return (unsigned char *) &long_ret;
		}
    case STAT6WANLINKLOCALADDRESS:
		{
			unsigned char stat6_wan_ll_addr[64];
			memset(stat6_wan_ll_addr,0,sizeof(stat6_wan_ll_addr));
			read_csman(fd,0x80900006,stat6_wan_ll_addr,sizeof(stat6_wan_ll_addr),TYPE_STR);
			*var_len = strlen(stat6_wan_ll_addr)-1;
			return (unsigned char *) stat6_wan_ll_addr;
		}
    case STAT6GLOBALADDRESS:
		{
			unsigned char stat6_globle_addr[64];
			memset(stat6_globle_addr,0,sizeof(stat6_globle_addr));
			read_csman(fd,0x80900009,stat6_globle_addr,sizeof(stat6_globle_addr),TYPE_STR);
			*var_len = strlen(stat6_globle_addr)-1;
			return (unsigned char *) stat6_globle_addr;
		}
    case STAT6LANLINKLOCALADDRESS:
		{
			unsigned char stat6_lan_ll_addr[64];
			memset(stat6_lan_ll_addr,0,sizeof(stat6_lan_ll_addr));
			read_csman(fd,0x80900008,stat6_lan_ll_addr,sizeof(stat6_lan_ll_addr),TYPE_STR);
			*var_len = strlen(stat6_lan_ll_addr)-1;
			return (unsigned char *) stat6_lan_ll_addr;
		}
    case STAT6LINKSTATUS:
		{
			unsigned int stat6_ipv6_type;
			unsigned int stat6_link_stat;

			read_csman(fd,0x00900001,&stat6_ipv6_type,sizeof(unsigned int),TYPE_U32);

			if(stat6_ipv6_type == 0x0100) //Static IPv6
				read_csman(fd,0x8090000D,&stat6_link_stat,sizeof(unsigned int),TYPE_U32);
			else if (stat6_ipv6_type == 0x0200) //DHCP IPv6
				read_csman(fd,0x80900701,&stat6_link_stat,sizeof(unsigned int),TYPE_U32);
			else if (stat6_ipv6_type == 0x0300) //PPPoE
				read_csman(fd,0x80900030,&stat6_link_stat,sizeof(unsigned int),TYPE_U32);
			else if (stat6_ipv6_type == 0x0400) //6 to 4
				read_csman(fd,0x80900801,&stat6_link_stat,sizeof(unsigned int),TYPE_U32);
			else if (stat6_ipv6_type == 0x0500) //6 in 4
				read_csman(fd,0x80900901,&stat6_link_stat,sizeof(unsigned int),TYPE_U32);

			long_ret = stat6_link_stat;
	        return (unsigned char *) &long_ret;
		}
    default:
      ERROR_MSG("");
    }
    return NULL;
}




