#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "csman.h"
#include "SystemUserMgntAddUserList.h"
#include <stdio.h>
#include <string.h>

#ifdef SNMP_CUSTOMER_SMARTLINK
oid SystemUserMgntAddUserList_variables_oid[] = { 1,3,6,1,4,1,12823,1,2,2,4,5,11,2 };
#else
oid SystemUserMgntAddUserList_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,5,11,2 };
#endif

struct variable7 SystemUserMgntAddUserList_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{SYSUSERMGNTADDUSERALTER,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 1,1 }},
{SYSTEMUSERMGNTADDUSER1USERNAME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 2,1 }},
{SYSTEMUSERMGNTADDUSER1PASSWORD,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 2,2 }},
{SYSTEMUSERMGNTADDUSER1USERLEVEL,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 2,3 }},
{SYSTEMUSERMGNTADDUSER1LEASETIME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 2,4 }},
{SYSTEMUSERMGNTADDUSER1IDLETIMEOUT,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 2,5 }},
{SYSTEMUSERMGNTADDUSER1GROUPTO,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 2,6 }},
{SYSTEMUSERMGNTADDUSER1PROFILE,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 2,7 }},
{SYSTEMUSERMGNTADDUSER2USERNAME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 3,1 }},
{SYSTEMUSERMGNTADDUSER2PASSWORD,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 3,2 }},
{SYSTEMUSERMGNTADDUSER2USERLEVEL,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 3,3 }},
{SYSTEMUSERMGNTADDUSER2LEASETIME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 3,4 }},
{SYSTEMUSERMGNTADDUSER2IDLETIMEOUT,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 3,5 }},
{SYSTEMUSERMGNTADDUSER2GROUPTO,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 3,6 }},
{SYSTEMUSERMGNTADDUSER2PROFILE,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 3,7 }},
{SYSTEMUSERMGNTADDUSER3USERNAME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 4,1 }},
{SYSTEMUSERMGNTADDUSER3PASSWORD,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 4,2 }},
{SYSTEMUSERMGNTADDUSER3USERLEVEL,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 4,3 }},
{SYSTEMUSERMGNTADDUSER3LEASETIME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 4,4 }},
{SYSTEMUSERMGNTADDUSER3IDLETIMEOUT,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 4,5 }},
{SYSTEMUSERMGNTADDUSER3GROUPTO,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 4,6 }},
{SYSTEMUSERMGNTADDUSER3PROFILE,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 4,7 }},
{SYSTEMUSERMGNTADDUSER4USERNAME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 5,1 }},
{SYSTEMUSERMGNTADDUSER4PASSWORD,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 5,2 }},
{SYSTEMUSERMGNTADDUSER4USERLEVEL,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 5,3 }},
{SYSTEMUSERMGNTADDUSER4LEASETIME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 5,4 }},
{SYSTEMUSERMGNTADDUSER4IDLETIMEOUT,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 5,5 }},
{SYSTEMUSERMGNTADDUSER4GROUPTO,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 5,6 }},
{SYSTEMUSERMGNTADDUSER4PROFILE,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 5,7 }},
{SYSTEMUSERMGNTADDUSER5USERNAME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 6,1 }},
{SYSTEMUSERMGNTADDUSER5PASSWORD,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 6,2 }},
{SYSTEMUSERMGNTADDUSER5USERLEVEL,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 6,3 }},
{SYSTEMUSERMGNTADDUSER5LEASETIME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 6,4 }},
{SYSTEMUSERMGNTADDUSER5IDLETIMEOUT,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 6,5 }},
{SYSTEMUSERMGNTADDUSER5GROUPTO,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 6,6 }},
{SYSTEMUSERMGNTADDUSER5PROFILE,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 6,7 }},
{SYSTEMUSERMGNTADDUSER6USERNAME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 7,1 }},
{SYSTEMUSERMGNTADDUSER6PASSWORD,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 7,2 }},
{SYSTEMUSERMGNTADDUSER6USERLEVEL,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 7,3 }},
{SYSTEMUSERMGNTADDUSER6LEASETIME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 7,4 }},
{SYSTEMUSERMGNTADDUSER6IDLETIMEOUT,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 7,5 }},
{SYSTEMUSERMGNTADDUSER6GROUPTO,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 7,6 }},
{SYSTEMUSERMGNTADDUSER6PROFILE,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 7,7 }},
{SYSTEMUSERMGNTADDUSER7USERNAME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 8,1 }},
{SYSTEMUSERMGNTADDUSER7PASSWORD,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 8,2 }},
{SYSTEMUSERMGNTADDUSER7USERLEVEL,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 8,3 }},
{SYSTEMUSERMGNTADDUSER7LEASETIME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 8,4 }},
{SYSTEMUSERMGNTADDUSER7IDLETIMEOUT,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 8,5 }},
{SYSTEMUSERMGNTADDUSER7GROUPTO,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 8,6 }},
{SYSTEMUSERMGNTADDUSER7PROFILE,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 8,7 }},
{SYSTEMUSERMGNTADDUSER8USERNAME,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 9,1 }},
{SYSTEMUSERMGNTADDUSER8PASSWORD,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 9,2 }},
{SYSTEMUSERMGNTADDUSER8USERLEVEL,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 9,3 }},
{SYSTEMUSERMGNTADDUSER8LEASETIME,  ASN_OCTET_STR,  RWRITE, var_SystemUserMgntAddUserList, 2,  { 9,4 }},
{SYSTEMUSERMGNTADDUSER8IDLETIMEOUT,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 9,5 }},
{SYSTEMUSERMGNTADDUSER8GROUPTO,  ASN_OCTET_STR,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 9,6 }},
{SYSTEMUSERMGNTADDUSER8PROFILE,  ASN_INTEGER,  RWRITE,var_SystemUserMgntAddUserList, 2,  { 9,7 }},

};
/*    (L = length of the oidsuffix) */


/** Initializes the SystemUserMgntAddUserList module */
void
init_SystemUserMgntAddUserList(void)
{
    DEBUGMSGTL(("SystemUserMgntAddUserList", "Initializing\n"));
    REGISTER_MIB("SystemUserMgntAddUserList", SystemUserMgntAddUserList_variables, variable7,
               SystemUserMgntAddUserList_variables_oid);
}

unsigned char *
var_SystemUserMgntAddUserList(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSUSERMGNTADDUSERALTER:
        *write_method = write_SysUserMgntAddUserAlter;
        read_csman(fd,0x80990101,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER1USERNAME:
        *write_method = write_SystemUserMgntAddUser1UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991000,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER1PASSWORD:
        *write_method = write_SystemUserMgntAddUser1Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991001,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER1USERLEVEL:
        *write_method = write_SystemUserMgntAddUser1UserLevel;
        read_csman(fd,0x00991002,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER1LEASETIME:
        *write_method = write_SystemUserMgntAddUser1LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991003,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER1IDLETIMEOUT:
        *write_method = write_SystemUserMgntAddUser1IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991004,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER1GROUPTO:
        *write_method = write_SystemUserMgntAddUser1Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991005,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER1PROFILE:
        *write_method = write_SystemUserMgntAddUser1Profile;
        read_csman(fd,0x00991006,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER2USERNAME:
        *write_method = write_SystemUserMgntAddUser2UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991100,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER2PASSWORD:
        *write_method = write_SystemUserMgntAddUser2Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991101,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER2USERLEVEL:
        *write_method = write_SystemUserMgntAddUser2UserLevel;
        read_csman(fd,0x00991102,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER2LEASETIME:
        *write_method = write_SystemUserMgntAddUser2LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991103,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER2IDLETIMEOUT:
        *write_method = write_SystemUserMgntAddUser2IdleTimeout;
         memset(string,0,sizeof(string));
		read_csman(fd,0x00991104,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER2GROUPTO:
        *write_method = write_SystemUserMgntAddUser2Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991105,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER2PROFILE:
        *write_method = write_SystemUserMgntAddUser2Profile;
        read_csman(fd,0x00991106,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER3USERNAME:
        *write_method = write_SystemUserMgntAddUser3UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991200,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER3PASSWORD:
        *write_method = write_SystemUserMgntAddUser3Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991201,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER3USERLEVEL:
        *write_method = write_SystemUserMgntAddUser3UserLevel;
        read_csman(fd,0x00991202,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER3LEASETIME:
        *write_method = write_SystemUserMgntAddUser3LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991203,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER3IDLETIMEOUT:
        *write_method = write_SystemUserMgntAddUser3IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991204,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER3GROUPTO:
        *write_method = write_SystemUserMgntAddUser3Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991205,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER3PROFILE:
        *write_method = write_SystemUserMgntAddUser3Profile;
        read_csman(fd,0x00991206,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER4USERNAME:
        *write_method = write_SystemUserMgntAddUser4UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991300,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER4PASSWORD:
        *write_method = write_SystemUserMgntAddUser4Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991301,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER4USERLEVEL:
        *write_method = write_SystemUserMgntAddUser4UserLevel;
        read_csman(fd,0x00991302,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER4LEASETIME:
        *write_method = write_SystemUserMgntAddUser4LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991303,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER4IDLETIMEOUT:
        *write_method = write_SystemUserMgntAddUser4IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991304,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER4GROUPTO:
        *write_method = write_SystemUserMgntAddUser4Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991305,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER4PROFILE:
        *write_method = write_SystemUserMgntAddUser4Profile;
        read_csman(fd,0x00991306,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER5USERNAME:
        *write_method = write_SystemUserMgntAddUser5UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991400,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER5PASSWORD:
        *write_method = write_SystemUserMgntAddUser5Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991401,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER5USERLEVEL:
        *write_method = write_SystemUserMgntAddUser5UserLevel;
        read_csman(fd,0x00991402,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER5LEASETIME:
        *write_method = write_SystemUserMgntAddUser5LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991403,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER5IDLETIMEOUT:
        *write_method = write_SystemUserMgntAddUser5IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991404,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER5GROUPTO:
        *write_method = write_SystemUserMgntAddUser5Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991405,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER5PROFILE:
        *write_method = write_SystemUserMgntAddUser5Profile;
        read_csman(fd,0x00991406,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER6USERNAME:
        *write_method = write_SystemUserMgntAddUser6UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991500,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER6PASSWORD:
        *write_method = write_SystemUserMgntAddUser6Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991501,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER6USERLEVEL:
        *write_method = write_SystemUserMgntAddUser6UserLevel;
        read_csman(fd,0x00991502,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER6LEASETIME:
        *write_method = write_SystemUserMgntAddUser6LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991503,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER6IDLETIMEOUT:
        *write_method = write_SystemUserMgntAddUser6IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991504,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER6GROUPTO:
        *write_method = write_SystemUserMgntAddUser6Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991505,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER6PROFILE:
        *write_method = write_SystemUserMgntAddUser6Profile;
        read_csman(fd,0x00991506,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER7USERNAME:
        *write_method = write_SystemUserMgntAddUser7UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991600,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER7PASSWORD:
        *write_method = write_SystemUserMgntAddUser7Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991601,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER7USERLEVEL:
        *write_method = write_SystemUserMgntAddUser7UserLevel;
        read_csman(fd,0x00991602,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER7LEASETIME:
        *write_method = write_SystemUserMgntAddUser7LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991603,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER7IDLETIMEOUT:
        *write_method = write_SystemUserMgntAddUser7IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991604,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER7GROUPTO:
        *write_method = write_SystemUserMgntAddUser7Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991605,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER7PROFILE:
        *write_method = write_SystemUserMgntAddUser7Profile;
        read_csman(fd,0x00991606,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER8USERNAME:
        *write_method = write_SystemUserMgntAddUser8UserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991700,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER8PASSWORD:
        *write_method = write_SystemUserMgntAddUser8Password;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991701,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER8USERLEVEL:
        *write_method = write_SystemUserMgntAddUser8UserLevel;
        read_csman(fd,0x00991702,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMUSERMGNTADDUSER8LEASETIME:
        *write_method = write_SystemUserMgntAddUser8LeaseTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991703,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER8IDLETIMEOUT:
        *write_method = write_SystemUserMgntAddUser8IdleTimeout;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991704,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER8GROUPTO:
        *write_method = write_SystemUserMgntAddUser8Groupto;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00991705,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMUSERMGNTADDUSER8PROFILE:
        *write_method = write_SystemUserMgntAddUser8Profile;
        read_csman(fd,0x00991706,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}





int
write_SysUserMgntAddUserAlter(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x80990101,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			write_csman(fd,0x80990100,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		} 
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser1UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991000,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser1Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991001,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser1UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser1LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991003,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser1IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991004,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser1Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991005,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser1Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991006,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser2UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991100,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser2Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991101,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser2UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991102,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser2LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991103,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser2IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991104,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser2Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991105,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser2Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991106,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser3UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991200,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser3Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991201,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser3UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;


        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991202,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser3LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991203,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser3IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991204,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser3Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991205,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser3Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991206,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser4UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991300,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser4Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991301,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser4UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991302,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser4LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991303,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser4IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991304,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser4Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991305,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser4Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991306,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser5UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991400,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser5Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991401,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser5UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991402,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser5LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991403,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser5IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991404,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser5Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991405,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser5Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991406,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser6UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991500,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser6Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991501,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser6UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991502,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser6LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991503,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser6IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;
			
        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991504,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser6Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991505,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser6Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991506,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser7UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;
			
        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991600,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser7Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991601,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser7UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991602,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser7LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991603,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser7IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991604,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser7Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991605,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser7Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991606,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser8UserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991700,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser8Password(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991701,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser8UserLevel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991702,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser8LeaseTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991703,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser8IdleTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {	
			int fd=0;
         	write_csman(fd,0x00991704,string,strlen(string)+1,TYPE_STR);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser8Groupto(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
		 	int fd=0;
         	write_csman(fd,0x00991705,string,strlen(string)+1,TYPE_STR);
			break;
         }    
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemUserMgntAddUser8Profile(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SysUserMgntAddUserList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SysUserMgntAddUserList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00991706,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


