#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UI3G4GModemStatus.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#define NUM_Status3G4GModem 16

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UI3G4GModemStatus_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,1,1,4 };
#else
oid UI3G4GModemStatus_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,1,1,4 };
#endif 
/* 
 * variable4 UI3G4GModemStatus_variables:
 *   this variable defines function callbacks and type return information 
 *   for the UI3G4GModemStatus mib section 
 */

struct variable7 UI3G4GModemStatus_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{M3G4GSTATUSIDINDEX,ASN_INTEGER,RONLY,var_UIStatus3G4GModemTable, 3,  { 1 , 1, 1 }},
{M3G4GSTATUSMODEMID,ASN_OCTET_STR,RONLY,var_UIStatus3G4GModemTable, 3,  { 1 , 1, 2 }},
{M3G4GCARDINFORMATION,ASN_OCTET_STR,RONLY,var_UIStatus3G4GModemTable, 3,  { 1 , 1, 3 }},
{M3G4GLINKSTATUS,ASN_INTEGER,RONLY,var_UIStatus3G4GModemTable, 3,  { 1 , 1, 4 }},
{M3G4GSIGNALSTRENGTH,ASN_INTEGER,RONLY,var_UIStatus3G4GModemTable, 3,  { 1 , 1, 5 }},
{M3G4GNETWORKNAME,ASN_OCTET_STR,RONLY,var_UIStatus3G4GModemTable, 3,  { 1 , 1, 6 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the UI3G4GModemStatus module */
void
init_UI3G4GModemStatus(void)
{
    DEBUGMSGTL(("UI3G4GModemStatus", "Initializing\n"));
    REGISTER_MIB("UI3G4GModemStatus", UI3G4GModemStatus_variables, variable7, UI3G4GModemStatus_variables_oid);
}

static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	#ifdef SNMP_CUSTOMER_SMARTLINK
	#define IFENTRY_NAME_LENGTH     17
	#else
	#define IFENTRY_NAME_LENGTH     16
	#endif
	/* in this case, oid len is 16*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}

unsigned char *
var_UI3G4GModemStatus(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    default:
      ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_UIStatus3G4GModemTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_UI3G4GModemStatus above.
 */
unsigned char *
var_UIStatus3G4GModemTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;

	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_Status3G4GModem);
		
	if ( index == MATCH_FAILED )
		return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case M3G4GSTATUSIDINDEX:
        long_ret = index;
        return (unsigned int *) &long_ret;
    case M3G4GSTATUSMODEMID:
	{
		memset(string,0,sizeof(string));	
		if(index == 1)			strcpy(string,"3G-1 ");
		else if(index == 2)		strcpy(string,"3G-2 ");
		else if(index == 3)		strcpy(string,"3G-3 ");
		else if(index == 4)		strcpy(string,"3G-4 ");
		else if(index == 5)		strcpy(string,"3G-5 ");
		else if(index == 6)		strcpy(string,"3G-6 ");
		else if(index == 7)		strcpy(string,"3G-7 ");
		else if(index == 8)		strcpy(string,"3G-8 ");
		else if(index == 9)		strcpy(string,"3G-9 ");
		else if(index == 10)	strcpy(string,"3G-10 ");
		else if(index == 11)	strcpy(string,"3G-11 ");
		else if(index == 12)	strcpy(string,"3G-12 ");
		else if(index == 13)	strcpy(string,"3G-13 ");
		else if(index == 14)	strcpy(string,"3G-14 ");
		else if(index == 15)	strcpy(string,"3G-15 ");
		else if(index == 16)	strcpy(string,"3G-16 ");
        *var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case M3G4GCARDINFORMATION:
        memset(string,0,sizeof(string));
		read_csman(fd,0x801e0d01+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case M3G4GLINKSTATUS:
		read_csman(fd,0x801e0701+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case M3G4GSIGNALSTRENGTH:
		read_csman(fd,0x801e0e01+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case M3G4GNETWORKNAME:
        memset(string,0,sizeof(string));
		read_csman(fd,0x801e1001+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
