#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UIAdvFWIPS.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIAdvFWIPS_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,3,1,7 };
#else
oid UIAdvFWIPS_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,3,1,7 };
#endif 

struct variable7 UIAdvFWIPS_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{ADVANCEIPSENABLE,  ASN_INTEGER,  RWRITE,var_UIAdvFWIPS, 1,  { 1 }},
{ADVANCEIPSLOGALTERENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 2 }},
{ADVANCEIPSSYNFLOODDEFENSEENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 3 }},
{ADVANCEIPSSYNFLOODDEFENSEVALUE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 4 }},
{ADVANCEIPSUDPFLOODDEFENSEENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 5 }},
{ADVANCEIPSUDPFLOODDEFENSEVALUE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 6 }},
{ADVANCEIPSICMPFLOODDEFENSEENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 7 }},
{ADVANCEIPSICMPFLOODVALUE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 8 }},
{ADVANCEIPSPORTSCANDETECTIONENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 9 }},
{ADVANCEIPSPORTSCANDETECTIONVALUE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 10 }},
{ADVANCEIPSBLOCKLANDATTACKENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 11 }},
{ADVANCEIPSBLOCKPINGORDEATHENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 12 }},
{ADVANCEIPSBLOCKIPSPOOFENABLE,ASN_INTEGER,RWRITE, var_UIAdvFWIPS, 1,  { 13 }},
{ADVANCEIPSBLOCKTCPFLAGSCANENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 14 }},
{ADVANCEIPSBLOCKTEARDROPENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 15 }},
{ADVANCEIPSBLOCKSMURFENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 16 }},
{ADVANCEIPSBLOCKTRACEROUTEENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 17 }},
{ADVANCEIPSBLOCKICMPFRAGMENTENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 18 }},
{ADVANCEIPSBLOCKSYNFRAGMENTENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 19 }},
{ADVANCEIPSBLOCKFRAGGLEATTACKENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 20 }},
{ADVANCEIPSBLOCKARPSPOOFINGENABLE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 21 }},
{ADVANCEIPSBLOCKARPSPOOFINGVALUE,ASN_INTEGER,RWRITE,var_UIAdvFWIPS, 1,  { 22 }},

};
/*    (L = length of the oidsuffix) */


/** Initializes the UIAdvFWIPS module */
void
init_UIAdvFWIPS(void)
{
    DEBUGMSGTL(("UIAdvFWIPS", "Initializing\n"));
    REGISTER_MIB("UIAdvFWIPS", UIAdvFWIPS_variables, variable7,UIAdvFWIPS_variables_oid);
}

unsigned char *
var_UIAdvFWIPS(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVANCEIPSENABLE:
        *write_method = write_AdvanceIPSEnable;
        read_csman(fd,0x00150600,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSLOGALTERENABLE:
        *write_method = write_AdvanceIPSLogAlterEnable;
        read_csman(fd,0x00150601,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSSYNFLOODDEFENSEENABLE:
        *write_method = write_AdvanceIPSSYNFloodDefenseEnable;
		read_csman(fd,0x00150601,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSSYNFLOODDEFENSEVALUE:
        *write_method = write_AdvanceIPSSYNFloodDefenseValue;
        read_csman(fd,0x00150602,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSUDPFLOODDEFENSEENABLE:
        *write_method = write_AdvanceIPSUDPFloodDefenseEnable;
        read_csman(fd,0x00150607,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSUDPFLOODDEFENSEVALUE:
        *write_method = write_AdvanceIPSUDPFloodDefenseValue;
        read_csman(fd,0x00150608,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSICMPFLOODDEFENSEENABLE:
        *write_method = write_AdvanceIPSICMPFloodDefenseEnable;
        read_csman(fd,0x00150604,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSICMPFLOODVALUE:
        *write_method = write_AdvanceIPSICMPFloodValue;
        read_csman(fd,0x00150605,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSPORTSCANDETECTIONENABLE:
        *write_method = write_AdvanceIPSPortScanDetectionEnable;
        read_csman(fd,0x0015060a,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSPORTSCANDETECTIONVALUE:
        *write_method = write_AdvanceIPSPortScanDetectionValue;
        read_csman(fd,0x0015060b,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKLANDATTACKENABLE:
        *write_method = write_AdvanceIPSBlockLandAttackEnable;
        read_csman(fd,0x0015060e,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKPINGORDEATHENABLE:
        *write_method = write_AdvanceIPSBlockPingorDeathEnable;
        read_csman(fd,0x00150612,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKIPSPOOFENABLE:
        *write_method = write_AdvanceIPSBlockIPSpoofEnable;
        read_csman(fd,0x00150618,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKTCPFLAGSCANENABLE:
        *write_method = write_AdvanceIPSBlockTCPFlagScanEnable;
        read_csman(fd,0x00150617,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKTEARDROPENABLE:
        *write_method = write_AdvanceIPSBlockTearDropEnable;
        read_csman(fd,0x00150616,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKSMURFENABLE:
        *write_method = write_AdvanceIPSBlockSmurfEnable;
        read_csman(fd,0x0015060c,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKTRACEROUTEENABLE:
        *write_method = write_AdvanceIPSBlockTracerouteEnable;
        read_csman(fd,0x00150615,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKICMPFRAGMENTENABLE:
        *write_method = write_AdvanceIPSBlockICMPFragmentEnable;
        read_csman(fd,0x00150613,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKSYNFRAGMENTENABLE:
        *write_method = write_AdvanceIPSBlockSYNFragmentEnable;
        read_csman(fd,0x00150614,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKFRAGGLEATTACKENABLE:
        *write_method = write_AdvanceIPSBlockFraggleAttackEnable;
        read_csman(fd,0x0015060f,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKARPSPOOFINGENABLE:
        *write_method = write_AdvanceIPSBlockARPSpoofingEnable;
        read_csman(fd,0x00150619,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSBLOCKARPSPOOFINGVALUE:
        *write_method = write_AdvanceIPSBlockARPSpoofingValue;
        read_csman(fd,0x0015061A,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}

int
write_AdvanceIPSEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150600,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSLogAlterEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150620,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSSYNFloodDefenseEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150601,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSSYNFloodDefenseValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150602,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSUDPFloodDefenseEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150607,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSUDPFloodDefenseValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150608,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSICMPFloodDefenseEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150604,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSICMPFloodValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150605,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSPortScanDetectionEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x0015060a,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSPortScanDetectionValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x0015060b,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockLandAttackEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x0015060e,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockPingorDeathEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150612,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockIPSpoofEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150618,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockTCPFlagScanEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150617,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockTearDropEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150616,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockSmurfEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x0015060c,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockTracerouteEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150615,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockICMPFragmentEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150613,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockSYNFragmentEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150614,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockFraggleAttackEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x0015060f,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockARPSpoofingEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x00150619,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceIPSBlockARPSpoofingValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to AdvIPS not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to AdvIPS: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = * (unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
        {
           int fd=0;
           write_csman(fd,0x0015061A,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		   break;
        }
    }
    return SNMP_ERR_NOERROR;
}
