#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UIAdvVPNConfiguration.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#include "UIAdvVPNIPSecTunnelListStatus.h"

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIAdvVPNIPSecTunnelListStatus_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,3,3,3 };
#else
oid UIAdvVPNIPSecTunnelListStatus_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,3,3,3 };
#endif

struct variable7 UIAdvVPNIPSecTunnelListStatus_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{ADVANCEIPSECTUNNELSTATUSINDEX,ASN_INTEGER,RONLY,var_UIAdvVPNIPSecTunnelListStatusTable, 3,  { 1 , 1, 1 }},
{ADVANCEIPSECTUNNELSTATUSINTERFACE,ASN_INTEGER,RONLY,var_UIAdvVPNIPSecTunnelListStatusTable, 3,  { 1 , 1, 2 }},
{ADVANCEIPSECTUNNELSTATUSTUNNELNAME,ASN_OCTET_STR,RONLY,var_UIAdvVPNIPSecTunnelListStatusTable, 3,  { 1 , 1, 3 }},
{ADVANCEIPSECTUNNELSTATUSREMOTESUBNET,ASN_IPADDRESS,RONLY,var_UIAdvVPNIPSecTunnelListStatusTable, 3,  { 1 , 1, 4 }},
{ADVANCEIPSECTUNNELSTATUSREMOTENETMASK,ASN_IPADDRESS,RONLY,var_UIAdvVPNIPSecTunnelListStatusTable, 3,  { 1 , 1, 5 }},
{ADVANCEIPSECTUNNELSTATUSGATEWAY,ASN_OCTET_STR,RONLY,var_UIAdvVPNIPSecTunnelListStatusTable, 3,  { 1 , 1, 6 }},
{ADVANCEIPSECTUNNELLINKINGSTATUS,ASN_OCTET_STR,RONLY,var_UIAdvVPNIPSecTunnelListStatusTable, 3,  { 1 , 1, 7 }},
{ADVANCEIPSECTUNNELSTATUSENABLE,ASN_OCTET_STR,RONLY,var_UIAdvVPNIPSecTunnelListStatusTable, 3,  { 1 , 1, 8 }},
};

void
init_UIAdvVPNIPSecTunnelListStatus(void)
{
    DEBUGMSGTL(("UIAdvVPNIPSecTunnelListStatus", "Initializing\n"));
    REGISTER_MIB("UIAdvVPNIPSecTunnelListStatus", UIAdvVPNIPSecTunnelListStatus_variables, variable7,
               UIAdvVPNIPSecTunnelListStatus_variables_oid);
}

static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	#ifdef SNMP_CUSTOMER_SMARTLINK
	#define IFENTRY_NAME_LENGTH     17
	#else
	#define IFENTRY_NAME_LENGTH     16
	#endif
	/* in this case, oid len is 17*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}

unsigned char *
var_UIAdvVPNIPSecTunnelListStatus(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    default:
      ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_UIAdvVPNIPSecTunnelListStatusTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_UIAdvVPNIPSecTunnelListStatus above.
 */
unsigned char *
var_UIAdvVPNIPSecTunnelListStatusTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;

     /* get index */
	int tunnel_number=0;
	read_csman(fd,0x00700040,&tunnel_number,sizeof(unsigned int),TYPE_U32);
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,tunnel_number);

    if ( index == MATCH_FAILED )
        return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVANCEIPSECTUNNELSTATUSINDEX:
        long_ret = index;
		return (unsigned int *) &long_ret;
    case ADVANCEIPSECTUNNELSTATUSINTERFACE:
        read_csman(fd,0x00701000+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSECTUNNELSTATUSTUNNELNAME:
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700100+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCEIPSECTUNNELSTATUSREMOTESUBNET:
	{	
		int method=0;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700300+index-1,&method,sizeof(unsigned int),TYPE_U32);
		if(method == 0 || method == 3)
			read_csman(fd,0x00700600+index-1,string,sizeof(string),TYPE_IPV4);
		else if(method == 1)
			read_csman(fd,0x00700B00+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    }
    case ADVANCEIPSECTUNNELSTATUSREMOTENETMASK:
	{	
		int method=0;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700300+index-1,&method,sizeof(unsigned int),TYPE_U32);
		if(method == 0 || method == 3)
			read_csman(fd,0x00700700+index-1,string,sizeof(string),TYPE_IPV4);
		else if(method == 1)
			read_csman(fd,0x00700C00+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    }
    case ADVANCEIPSECTUNNELSTATUSGATEWAY:
	{	
		int method=0;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700300+index-1,&method,sizeof(unsigned int),TYPE_U32);
		if(method == 0 || method == 3)
			read_csman(fd,0x00700800+index-1,string,sizeof(string),TYPE_STR);
		else if(method == 1)
			read_csman(fd,0x00700D00+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCEIPSECTUNNELLINKINGSTATUS:
        read_csman(fd,0x80700100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSECTUNNELSTATUSENABLE:
        read_csman(fd,0x00700200+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}


