#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UIAdvVPNConfiguration.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>
#include "UIAdvVPNSSLVPNNetworkExtenderList.h"

#define NUM_ADV_VPN_SSLPVPN_NW_EXTENDER			5
#define NUM_ADV_VPN_SSLPVPN_NW_EXTENDER_LIST	16

int w_index_adv_vpn_sslvpn_nw_extender;
int w_index_adv_vpn_sslvpn_nw_extender_list;

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIAdvVPNSSLVPNNetworkExtenderList_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,3,3,15,2 };
#else
oid UIAdvVPNSSLVPNNetworkExtenderList_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,3,3,15,2 };
#endif

struct variable7 UIAdvVPNSSLVPNNetworkExtenderList_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
{ADVANCESSLVPNNWEXTENDERLISTINDEX,ASN_INTEGER,RONLY,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 1 }},
{ADVANCESSLVPNNWEXTENDERLISTID,ASN_OCTET_STR,RONLY,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 2 }},
{ADVANCESSLVPNNWEXTENDERLISTPROTOCOL,ASN_INTEGER,RWRITE,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 3 }},
{ADVANCESSLVPNNWEXTENDERLISTPORT,ASN_INTEGER,RWRITE,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 4 }},
{ADVANCESSLVPNNWEXTENDERLISTIDLETIMEOUT,ASN_INTEGER,RWRITE,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 5 }},
{ADVANCESSLVPNNWEXTENDERLISTCLEANWEBCACHEENABLE,ASN_INTEGER,RWRITE,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 6 }},
{ADVANCESSLVPNNWEXTENDERLISTFULLTUNNELENABLE,ASN_INTEGER,RWRITE,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 7 }},
{ADVANCESSLVPNNWEXTENDERLISTSERVERVIRTUALIP,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 8 }},
{ADVANCESSLVPNNWEXTENDERLISTIPPOOLSTARTADDRESS,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 9 }},
{ADVANCESSLVPNNWEXTENDERLISTIPPOOLENDADDRESS,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 10 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERENABLE,ASN_INTEGER,RWRITE,var_AdvanceSSLVPNNWExtenderListTable, 3,  { 1 , 1, 11 }},
//Extende List Index
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERINDEX,ASN_INTEGER,RONLY,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 1 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN1NAME,ASN_OCTET_STR,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 2 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN1IP,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 3 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN1MASK,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 4 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN2NAME,ASN_OCTET_STR,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 5 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN2IP,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 6 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN2MASK,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 7 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN3NAME,ASN_OCTET_STR,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 8 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN3IP,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 9 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN3MASK,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 10 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN4NAME,ASN_OCTET_STR,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 11 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN4IP,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 12 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN4MASK,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 13 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN5NAME,ASN_OCTET_STR,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 14 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN5IP,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 15 }},
{ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN5MASK,ASN_IPADDRESS,RWRITE,var_AdvanceSSLVPNNWExtenderListExtenderTable, 3,  { 2 , 1, 16 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the UIAdvVPNSSLVPNNetworkExtenderList module */
void
init_UIAdvVPNSSLVPNNetworkExtenderList(void)
{
    DEBUGMSGTL(("UIAdvVPNSSLVPNNetworkExtenderList", "Initializing\n"));
    REGISTER_MIB("UIAdvVPNSSLVPNNetworkExtenderList", UIAdvVPNSSLVPNNetworkExtenderList_variables, variable7,
               UIAdvVPNSSLVPNNetworkExtenderList_variables_oid);
}

static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	#ifdef SNMP_CUSTOMER_SMARTLINK
	#define IFENTRY_NAME_LENGTH     18
	#else
	#define IFENTRY_NAME_LENGTH     17
	#endif
	/* in this case, oid len is 17*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}

unsigned char *
var_UIAdvVPNSSLVPNNetworkExtenderList(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    default:
      ERROR_MSG("");
    }
    return NULL;
}


unsigned char *
var_AdvanceSSLVPNNWExtenderListTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;
    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_ADV_VPN_SSLPVPN_NW_EXTENDER);
	w_index_adv_vpn_sslvpn_nw_extender = index;
    if ( index == MATCH_FAILED )
        return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVANCESSLVPNNWEXTENDERLISTINDEX:
        long_ret = index;
		return (unsigned int *) &long_ret;
    case ADVANCESSLVPNNWEXTENDERLISTID:
	{
        memset(string,0,sizeof(string));
		sprintf(string,"WAN-%d",index);	
		*var_len = strlen(string);
		return (unsigned char *) string;
    }
    case ADVANCESSLVPNNWEXTENDERLISTPROTOCOL:
        *write_method = write_AdvanceSSLVPNNWExtenderListProtocol;
        read_csman(fd,0x009C0040+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCESSLVPNNWEXTENDERLISTPORT:
        *write_method = write_AdvanceSSLVPNNWExtenderListPort;
        read_csman(fd,0x009C0030+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCESSLVPNNWEXTENDERLISTIDLETIMEOUT:
        *write_method = write_AdvanceSSLVPNNWExtenderListIdleTImeout;
        read_csman(fd,0x009C0060+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCESSLVPNNWEXTENDERLISTCLEANWEBCACHEENABLE:
        *write_method = write_AdvanceSSLVPNNWExtenderListCleanWebCacheEnable;
        read_csman(fd,0x009C0070+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCESSLVPNNWEXTENDERLISTFULLTUNNELENABLE:
        *write_method = write_AdvanceSSLVPNNWExtenderListFullTunnelEnable;
        read_csman(fd,0x009C0110+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCESSLVPNNWEXTENDERLISTSERVERVIRTUALIP:
        *write_method = write_AdvanceSSLVPNNWExtenderListServerVirtualIP;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C00F0+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTIPPOOLSTARTADDRESS:
        *write_method = write_AdvanceSSLVPNNWExtenderListIPPoolStartAddress;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0130+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTIPPOOLENDADDRESS:
        *write_method = write_AdvanceSSLVPNNWExtenderListIPPoolEndAddress;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0140+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERENABLE:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderEnable;
        read_csman(fd,0x009C0010+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}

unsigned char *
var_AdvanceSSLVPNNWExtenderListExtenderTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
    int fd=0;
    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_ADV_VPN_SSLPVPN_NW_EXTENDER_LIST);
	w_index_adv_vpn_sslvpn_nw_extender_list = index;
    if ( index == MATCH_FAILED )
        return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERINDEX:
        long_ret = index;
		return (unsigned int *) &long_ret;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN1NAME:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN1Name;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0200+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN1IP:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN1IP;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0300+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN1MASK:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN1Mask;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0400+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN2NAME:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN2Name;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0210+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN2IP:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN2IP;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0310+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN2MASK:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN2Mask;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0410+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN3NAME:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN3Name;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0220+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN3IP:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN3IP;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0320+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN3MASK:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN3Mask;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0420+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN4NAME:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN4Name;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0230+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN4IP:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN4IP;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0330+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN4MASK:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN4Mask;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0430+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN5NAME:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN5Name;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0240+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN5IP:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN5IP;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0340+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case ADVANCESSLVPNNWEXTENDERLISTEXTENDERSUBNETLISTWAN5MASK:
        *write_method = write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN5Mask;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0440+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}


int
write_AdvanceSSLVPNNWExtenderListProtocol(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x009C0040+w_index_adv_vpn_sslvpn_nw_extender-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListPort(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x009C0030+w_index_adv_vpn_sslvpn_nw_extender-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListIdleTImeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x009C0060+w_index_adv_vpn_sslvpn_nw_extender-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListCleanWebCacheEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x009C0070+w_index_adv_vpn_sslvpn_nw_extender-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListFullTunnelEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x009C0110+w_index_adv_vpn_sslvpn_nw_extender-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListServerVirtualIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;


        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C00F0+w_index_adv_vpn_sslvpn_nw_extender-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListIPPoolStartAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0130+w_index_adv_vpn_sslvpn_nw_extender-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListIPPoolEndAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0140+w_index_adv_vpn_sslvpn_nw_extender-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x009C0010+w_index_adv_vpn_sslvpn_nw_extender-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN1Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x009C0200+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN1IP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0300+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN1Mask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0400+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN2Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x009C0210+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN2IP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0310+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN2Mask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0410+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN3Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x009C0220+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN3IP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0320+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN3Mask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0420+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN4Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x009C0230+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN4IP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0330+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN4Mask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0430+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN5Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x009C0240+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN5IP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0340+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceSSLVPNNWExtenderListExtenderSubnetListWAN5Mask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNNetworkExtenderList not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNNetworkExtenderList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x009C0440+w_index_adv_vpn_sslvpn_nw_extender_list-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
