#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UIAdvVPNConfiguration.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#include "UIAdvVPNSSLVPNPortalScreenConfig.h"

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIAdvVPNSSLVPNPortalScreenConfig_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,3,3,15,5 };
#else
oid UIAdvVPNSSLVPNPortalScreenConfig_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,3,3,15,5 };
#endif

struct variable7 UIAdvVPNSSLVPNPortalScreenConfig_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{ADVANCESSLVPNPORTALSCREENCONFIGWELCOMESTRING,ASN_OCTET_STR,RWRITE,
 var_UIAdvVPNSSLVPNPortalScreenConfig, 1,  { 1 }},

};

void
init_UIAdvVPNSSLVPNPortalScreenConfig(void)
{
    DEBUGMSGTL(("UIAdvVPNSSLVPNPortalScreenConfig", "Initializing\n"));
    REGISTER_MIB("UIAdvVPNSSLVPNPortalScreenConfig", UIAdvVPNSSLVPNPortalScreenConfig_variables, variable7,
               UIAdvVPNSSLVPNPortalScreenConfig_variables_oid);
}


unsigned char *
var_UIAdvVPNSSLVPNPortalScreenConfig(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVANCESSLVPNPORTALSCREENCONFIGWELCOMESTRING:
        *write_method = write_AdvanceSSLVPNPortalScreenConfigWelcomeString;
        memset(string,0,sizeof(string));
		read_csman(fd,0x009C0001,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}





int
write_AdvanceSSLVPNPortalScreenConfigWelcomeString(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNSSLVPNPortalScreenConfig not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNSSLVPNPortalScreenConfig: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x009C0001,string,strlen(string)+1,TYPE_STR);
             break;
         }
    }
    return SNMP_ERR_NOERROR;
}

