#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "UIBasicCommBusVirtualComTCPClient.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIBasicCommBusVirtualComTCPClient_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,2,9,3 };
#else
oid UIBasicCommBusVirtualComTCPClient_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,2,9,3 };
#endif

struct variable7 UIBasicCommBusVirtualComTCPClient_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{BASICVIRTUALCOMTCPCLIENTCONNCONTROL,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 1 }},
{BASICVIRTUALCOMTCPCLIENTCONNIDLETIME,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 2 }},
{BASICVIRTUALCOMTCPCLIENTALIVECHECKTIME,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 3 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPHOST1,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 4 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPREMOTEPORT1,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 5 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPDEFINITIONENABLE1,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 6 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPHOST2,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 7 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPREMOTEPORT2,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 8 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPDEFINITIONENABLE2,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 9 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPHOST3,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 10 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPREMOTEPORT3,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 11 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPDEFINITIONENABLE3,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 12 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPHOST4,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 13 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPREMOTEPORT4,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 14 }},
{BASICVIRTUALCOMTCPCLIENTLEGALIPDEFINITIONENABLE4,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComTCPClient, 1,  { 15 }},

};

void
init_UIBasicCommBusVirtualComTCPClient(void)
{
    DEBUGMSGTL(("UIBasicCommBusVirtualComTCPClient", "Initializing\n"));
    REGISTER_MIB("UIBasicCommBusVirtualComTCPClient", UIBasicCommBusVirtualComTCPClient_variables, variable7,
               UIBasicCommBusVirtualComTCPClient_variables_oid);
}

unsigned char *
var_UIBasicCommBusVirtualComTCPClient(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICVIRTUALCOMTCPCLIENTCONNCONTROL:
        *write_method = write_BasicVirtualComTCPClientConnControl;
        read_csman(fd,0x00420189,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMTCPCLIENTCONNIDLETIME:
        *write_method = write_BasicVirtualComTCPClientConnIdleTime;
        read_csman(fd,0x00420112,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMTCPCLIENTALIVECHECKTIME:
        *write_method = write_BasicVirtualComTCPClientAliveCheckTime;
        read_csman(fd,0x00420184,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPHOST1:
        *write_method = write_BasicVirtualComTCPClientLegalIPHost1;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420190,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPREMOTEPORT1:
        *write_method = write_BasicVirtualComTCPClientLegalIPRemotePort1;
        read_csman(fd,0x00420194,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPDEFINITIONENABLE1:
        *write_method = write_BasicVirtualComTCPClientLegalIPDefinitionEnable1;
        read_csman(fd,0x00420185,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPHOST2:
        *write_method = write_BasicVirtualComTCPClientLegalIPHost2;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420191,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPREMOTEPORT2:
        *write_method = write_BasicVirtualComTCPClientLegalIPRemotePort2;
        read_csman(fd,0x00420195,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPDEFINITIONENABLE2:
        *write_method = write_BasicVirtualComTCPClientLegalIPDefinitionEnable2;
        read_csman(fd,0x00420186,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPHOST3:
        *write_method = write_BasicVirtualComTCPClientLegalIPHost3;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420192,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPREMOTEPORT3:
        *write_method = write_BasicVirtualComTCPClientLegalIPRemotePort3;
        read_csman(fd,0x00420196,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPDEFINITIONENABLE3:
        *write_method = write_BasicVirtualComTCPClientLegalIPDefinitionEnable3;
        read_csman(fd,0x00420187,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPHOST4:
        *write_method = write_BasicVirtualComTCPClientLegalIPHost4;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420193,string,sizeof(string),TYPE_IPV4);
		*var_len = 4;
		return (unsigned char *) string;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPREMOTEPORT4:
        *write_method = write_BasicVirtualComTCPClientLegalIPRemotePort4;
        read_csman(fd,0x00420197,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMTCPCLIENTLEGALIPDEFINITIONENABLE4:
        *write_method = write_BasicVirtualComTCPClientLegalIPDefinitionEnable4;
        read_csman(fd,0x00420188,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}

int
write_BasicVirtualComTCPClientConnControl(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420189,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientConnIdleTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420112,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientAliveCheckTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420184,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPHost1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00420190,string,strlen(string)+1,TYPE_IPV4);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPRemotePort1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420194,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPDefinitionEnable1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420185,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPHost2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00420191,string,strlen(string)+1,TYPE_IPV4);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPRemotePort2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420195,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPDefinitionEnable2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420186,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
        }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPHost3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00420192,string,strlen(string)+1,TYPE_IPV4);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPRemotePort3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420196,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPDefinitionEnable3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420187,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPHost4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd;
             write_csman(fd,0x00420193,string,strlen(string)+1,TYPE_IPV4);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPRemotePort4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420197,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComTCPClientLegalIPDefinitionEnable4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPClient not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPClient: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;
			
        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420188,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}

