#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "UIBasicCommBusVirtualComUDP.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIBasicCommBusVirtualComUDP_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,2,9,5 };
#else
oid UIBasicCommBusVirtualComUDP_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,2,9,5 };
#endif

struct variable7 UIBasicCommBusVirtualComUDP_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{BASICVIRTUALCOMUDPLISTENPORT,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 1 }},
{BASICVIRTUALCOMUDPLEGALIPHOSTFROM1,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 2 }},
{BASICVIRTUALCOMUDPLEGALIPHOSTTO1,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 3 }},
{BASICVIRTUALCOMUDPLEGALIPREMOTEPORT1,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 4 }},
{BASICVIRTUALCOMUDPLEGALIPDEFINITIONENABLE1,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 5 }},
{BASICVIRTUALCOMUDPLEGALIPHOSTFROM2,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 6 }},
{BASICVIRTUALCOMUDPLEGALIPHOSTTO2,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 7 }},
{BASICVIRTUALCOMUDPLEGALIPREMOTEPORT2,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 8 }},
{BASICVIRTUALCOMUDPLEGALIPDEFINITIONENABLE2,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 9 }},
{BASICVIRTUALCOMUDPLEGALIPHOSTFROM3,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 10 }},
{BASICVIRTUALCOMUDPLEGALIPHOSTTO3,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 11 }},
{BASICVIRTUALCOMUDPLEGALIPREMOTEPORT3,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 12 }},
{BASICVIRTUALCOMUDPLEGALIPDEFINITIONENABLE3,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 13 }},
{BASICVIRTUALCOMUDPLEGALIPHOSTFROM4,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 14 }},
{BASICVIRTUALCOMUDPLEGALIPHOSTTO4,ASN_IPADDRESS,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 15 }},
{BASICVIRTUALCOMUDPLEGALIPREMOTEPORT4,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 16 }},
{BASICVIRTUALCOMUDPLEGALIPDEFINITIONENABLE4,ASN_INTEGER,RWRITE,var_UIBasicCommBusVirtualComUDP, 1,  { 17 }},

};

void
init_UIBasicCommBusVirtualComUDP(void)
{
    DEBUGMSGTL(("UIBasicCommBusVirtualComUDP", "Initializing\n"));
    REGISTER_MIB("UIBasicCommBusVirtualComUDP", UIBasicCommBusVirtualComUDP_variables, variable7,
               UIBasicCommBusVirtualComUDP_variables_oid);
}

unsigned char *
var_UIBasicCommBusVirtualComUDP(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;
	
    switch(vp->magic) {
    case BASICVIRTUALCOMUDPLISTENPORT:
        *write_method = write_BasicVirtualComUDPListenPort;
        read_csman(fd,0x0042001C,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMUDPLEGALIPHOSTFROM1:
        *write_method = write_BasicVirtualComUDPLegalIPHostFrom1;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420206,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case BASICVIRTUALCOMUDPLEGALIPHOSTTO1:
        *write_method = write_BasicVirtualComUDPLegalIPHostTo1;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420207,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case BASICVIRTUALCOMUDPLEGALIPREMOTEPORT1:
        *write_method = write_BasicVirtualComUDPLegalIPRemotePort1;
        read_csman(fd,0x00420214,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMUDPLEGALIPDEFINITIONENABLE1:
        *write_method = write_BasicVirtualComUDPLegalIPDefinitionEnable1;
        read_csman(fd,0x00420202,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMUDPLEGALIPHOSTFROM2:
        *write_method = write_BasicVirtualComUDPLegalIPHostFrom2;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420208,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case BASICVIRTUALCOMUDPLEGALIPHOSTTO2:
        *write_method = write_BasicVirtualComUDPLegalIPHostTo2;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420209,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case BASICVIRTUALCOMUDPLEGALIPREMOTEPORT2:
        *write_method = write_BasicVirtualComUDPLegalIPRemotePort2;
        read_csman(fd,0x00420215,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMUDPLEGALIPDEFINITIONENABLE2:
        *write_method = write_BasicVirtualComUDPLegalIPDefinitionEnable2;
        read_csman(fd,0x00420203,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMUDPLEGALIPHOSTFROM3:
        *write_method = write_BasicVirtualComUDPLegalIPHostFrom3;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420210,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case BASICVIRTUALCOMUDPLEGALIPHOSTTO3:
        *write_method = write_BasicVirtualComUDPLegalIPHostTo3;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420211,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case BASICVIRTUALCOMUDPLEGALIPREMOTEPORT3:
        *write_method = write_BasicVirtualComUDPLegalIPRemotePort3;
        read_csman(fd,0x00420216,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMUDPLEGALIPDEFINITIONENABLE3:
        *write_method = write_BasicVirtualComUDPLegalIPDefinitionEnable3;
        read_csman(fd,0x00420204,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMUDPLEGALIPHOSTFROM4:
        *write_method = write_BasicVirtualComUDPLegalIPHostFrom4;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420212,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case BASICVIRTUALCOMUDPLEGALIPHOSTTO4:
        *write_method = write_BasicVirtualComUDPLegalIPHostTo4;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00420213,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case BASICVIRTUALCOMUDPLEGALIPREMOTEPORT4:
        *write_method = write_BasicVirtualComUDPLegalIPRemotePort4;
        read_csman(fd,0x00420217,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVIRTUALCOMUDPLEGALIPDEFINITIONENABLE4:
        *write_method = write_BasicVirtualComUDPLegalIPDefinitionEnable4;
        read_csman(fd,0x00420205,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}

int
write_BasicVirtualComUDPListenPort(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComTCPServer not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComTCPServer: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x0042001C,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPHostFrom1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
            int fd=0;
			write_csman(fd,0x00420206,string,strlen(string) ,TYPE_IPV4);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPHostTo1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
            int fd=0;
			write_csman(fd,0x00420207,string,strlen(string) ,TYPE_IPV4);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPRemotePort1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          	long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420214,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPDefinitionEnable1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          	long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420203,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPHostFrom2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
            int fd=0;
			write_csman(fd,0x00420208,string,strlen(string) ,TYPE_IPV4);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPHostTo2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
            int fd=0;
			write_csman(fd,0x00420209,string,strlen(string) ,TYPE_IPV4);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPRemotePort2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          	long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420215,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPDefinitionEnable2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          	long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420202,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPHostFrom3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
            int fd=0;
			write_csman(fd,0x00420210,string,strlen(string) ,TYPE_IPV4);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPHostTo3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;
			
        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
            int fd=0;
			write_csman(fd,0x00420211,string,strlen(string) ,TYPE_IPV4);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPRemotePort3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          	long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420216,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPDefinitionEnable3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          	long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420204,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPHostFrom4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
            int fd=0;
			write_csman(fd,0x00420212,string,strlen(string) ,TYPE_IPV4);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPHostTo4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
            int fd=0;
			write_csman(fd,0x00420213,string,strlen(string) ,TYPE_IPV4);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPRemotePort4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          	long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420217,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicVirtualComUDPLegalIPDefinitionEnable4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicCommBusVirtualComUDP not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicCommBusVirtualComUDP: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          	long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00420205,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			break;
		}
    }
    return SNMP_ERR_NOERROR;
}

