#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UIBasicNATBridgingSpecialAPALG.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#define NUM_BAS_SpecialAPALG	10
int w_index_bas_nat_specialapalg;

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIBasicNATBridgingSpecialAPALG_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,2,6,4 };
#else
oid UIBasicNATBridgingSpecialAPALG_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,2,6,4 };
#endif

struct variable7 UIBasicNATBridgingSpecialAPALG_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{BASICNATBRIDGALGSPECIALAPENABLE,ASN_INTEGER,RWRITE,var_UIBasicNATBridgingSpecialAPALG, 1,  { 1 }},
{BASICNATBRIDGALGSPECIALAPINDEX,ASN_INTEGER,RONLY,var_BasicSpecialAPALGTable, 3,  { 2 , 1, 1 }},
{BASICNATBRIDGALGSPECIALAPTRIGGER,ASN_OCTET_STR,RWRITE,var_BasicSpecialAPALGTable, 3,  { 2 , 1, 2 }},
{BASICNATBRIDGALGSPECIALAPINCOMINGPORT,ASN_OCTET_STR,RWRITE,var_BasicSpecialAPALGTable, 3,  { 2 , 1, 3 }},
{BASICNATBRIDGALGSPECIALAPENABLE,ASN_INTEGER,RWRITE,var_BasicSpecialAPALGTable, 3,  { 2 , 1, 4 }},
{BASICNATBRIDGALGSPECIALAPSCHEDULE,ASN_INTEGER,RWRITE,var_BasicSpecialAPALGTable, 3,  { 2 , 1, 5 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the UIBasicNATBridgingSpecialAPALG module */
void
init_UIBasicNATBridgingSpecialAPALG(void)
{
    DEBUGMSGTL(("UIBasicNATBridgingSpecialAPALG", "Initializing\n"));
    REGISTER_MIB("UIBasicNATBridgingSpecialAPALG", UIBasicNATBridgingSpecialAPALG_variables, variable7,
               UIBasicNATBridgingSpecialAPALG_variables_oid);
}

static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	#ifdef SNMP_CUSTOMER_SMARTLINK
	#define IFENTRY_NAME_LENGTH     17
	#else
	#define IFENTRY_NAME_LENGTH     16
	#endif
	
	/* in this case, oid len is 16*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}

unsigned char *
var_UIBasicNATBridgingSpecialAPALG(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICNATBRIDGALGSPECIALAPENABLE:
        *write_method = write_BasicNATBridgSpecialAPALGEnable;
         read_csman(fd,0x00240005,&long_ret,sizeof(unsigned int),TYPE_U32);
		 return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_BasicSpecialAPALGTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_UIBasicNATBridgingSpecialAPALG above.
 */
unsigned char *
var_BasicSpecialAPALGTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;

	/* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_BAS_SpecialAPALG);
    w_index_bas_nat_specialapalg=index;

    if ( index == MATCH_FAILED )
        return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICNATBRIDGALGSPECIALAPINDEX:
        long_ret = index;
		return (unsigned int *) &long_ret;
    case BASICNATBRIDGALGSPECIALAPTRIGGER:
        *write_method = write_BasicNATBridgSpecialAPALGTrigger;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00170011+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case BASICNATBRIDGALGSPECIALAPINCOMINGPORT:
        *write_method = write_BasicNATBridgSpecialAPALGIncomingPort;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00170021+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case BASICNATBRIDGALGSPECIALAPINDEXENABLE:
        *write_method = write_BasicNATBridgSpecialAPALGIndexEnable;
        read_csman(fd,0x00170001+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICNATBRIDGALGSPECIALAPSCHEDULE:
        *write_method = write_BasicNATBridgSpecialAPALGSchedule;
        read_csman(fd,0x00170100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}



int
write_BasicNATBridgSpecialAPALGEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicNATBridgingSpecialAPALG not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicNATBridgingSpecialAPALG: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
              int fd=0;
              write_csman(fd,0x00240005,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
         }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicNATBridgSpecialAPALGTrigger(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIBasicNATBridgingSpecialAPALG not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicNATBridgingSpecialAPALG: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00170011+w_index_bas_nat_specialapalg-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicNATBridgSpecialAPALGIncomingPort(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIBasicNATBridgingSpecialAPALG not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIBasicNATBridgingSpecialAPALG: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		{
			int fd=0;
			write_csman(fd,0x00170021+w_index_bas_nat_specialapalg-1,string,strlen(string)+1,TYPE_STR);
			break;
		}

    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicNATBridgSpecialAPALGIndexEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicNATBridgingSpecialAPALG not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicNATBridgingSpecialAPALG: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;


        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
			{
				int fd=0;
				write_csman(fd,0x00170001+w_index_bas_nat_specialapalg-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
				break;
			}
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicNATBridgSpecialAPALGSchedule(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    long value;
    int size;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicNATBridgingSpecialAPALG not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long)) {
              fprintf(stderr,"write to UIBasicNATBridgingSpecialAPALG: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          size  = var_val_len;
          value = * (long *) var_val;

          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          break;
    }
    return SNMP_ERR_NOERROR;
}
