#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UIBasicVLANPBDMZVlanDefinition.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIBasicVLANPBDMZVlanDefinition_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,2,2,4 };
#else
oid UIBasicVLANPBDMZVlanDefinition_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,2,2,4 };
#endif

struct variable7 UIBasicVLANPBDMZVlanDefinition_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{BASICVLANPBDMZPORT,ASN_INTEGER,RONLY,var_UIBasicVLANPBDMZVlanDefinition, 1,  { 1 }},
{BASICVLANPBDMZDHCPSERVER,ASN_INTEGER,RONLY,var_UIBasicVLANPBDMZVlanDefinition, 1,  { 2 }},

};
/*    (L = length of the oidsuffix) */


/** Initializes the UIBasicVLANPBDMZVlanDefinition module */
void
init_UIBasicVLANPBDMZVlanDefinition(void)
{
    DEBUGMSGTL(("UIBasicVLANPBDMZVlanDefinition", "Initializing\n"));
    REGISTER_MIB("UIBasicVLANPBDMZVlanDefinition", UIBasicVLANPBDMZVlanDefinition_variables, variable7,
               UIBasicVLANPBDMZVlanDefinition_variables_oid);
}

unsigned char *
var_UIBasicVLANPBDMZVlanDefinition(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICVLANPBDMZPORT:
        long_ret=6;
		return (unsigned char *) &long_ret;
    case BASICVLANPBDMZDHCPSERVER:
        read_csman(fd,0x00932066,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}




