#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UIBasicVLANPortBaseVLANList.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIBasicVLANPortBaseVLANList_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,2,2,3 };
#else
oid UIBasicVLANPortBaseVLANList_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,2,2,3 };
#endif

#define NUM_BAS_VLAN_PB_ETHERNET	4
#define NUM_BAS_VLAN_PB_VAP1		8
#define NUM_BAS_VLAN_PB_VAP2		8
int w_index_bas_lan_pb_ethernet;
int w_index_bas_lan_pb_vap1;
int w_index_bas_lan_pb_vap2;


struct variable7 UIBasicVLANPortBaseVLANList_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{BASICVLANPBETHERNETPORTINDEX,ASN_INTEGER,RONLY,var_BasicVLANPBEthernetPortTable, 3,  { 1 , 1, 1 }},
{BASICVLANPBETHERNETPORTTYPE,ASN_INTEGER,RWRITE,var_BasicVLANPBEthernetPortTable, 3,  { 1 , 1, 2 }},
{BASICVLANPBETHERNETPORTLANVID,ASN_INTEGER,RWRITE,var_BasicVLANPBEthernetPortTable, 3,  { 1 , 1, 3 }},
{BASICVLANPBETHERNETPORTTXTAG,ASN_INTEGER,RWRITE,var_BasicVLANPBEthernetPortTable, 3,  { 1 , 1, 4 }},
{BASICVLANPBETHERNETPORTDHCPSERVER,ASN_INTEGER,RWRITE,var_BasicVLANPBEthernetPortTable, 3,  { 1 , 1, 5 }},
{BASICVLANPBETHERNETPORTAVAILABLEWAN,ASN_INTEGER,RWRITE,var_BasicVLANPBEthernetPortTable, 3,  { 1 , 1, 6 }},
{BASICVLANPBETHERNETPORTWANVID,ASN_INTEGER,RWRITE,var_BasicVLANPBEthernetPortTable, 3,  { 1 , 1, 7 }},

{BASICVLANPBVIRTUALAPINDEX,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAPPortTable, 3,  { 2 , 1, 1 }},
{BASICVLANPBVIRTUALAPTYPE,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAPPortTable, 3,  { 2 , 1, 2 }},
{BASICVLANPBVIRTUALAPVID,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAPPortTable, 3,  { 2 , 1, 3 }},
{BASICVLANPBVIRTUALAPTXTAG,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAPPortTable, 3,  { 2 , 1, 4 }},
{BASICVLANPBVIRTUALAPDHCP,ASN_INTEGER,RWRITE,var_BasicVLANPBVirtualAPPortTable, 3,  { 2 , 1, 5 }},
{BASICVLANPBVIRTUALAPAVAILABLEWAN,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAPPortTable, 3,  { 2 , 1, 6 }},
{BASICVLANPBVIRTUALAPWANVID,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAPPortTable, 3,  { 2 , 1, 7 }},

{BASICVLANPBVIRTUALAP2INDEX,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAP2PortTable, 3,  { 3 , 1, 1 }},
{BASICVLANPBVIRTUALAP2TYPE,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAP2PortTable, 3,  { 3 , 1, 2 }},
{BASICVLANPBVIRTUALAP2VID,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAP2PortTable, 3,  { 3 , 1, 3 }},
{BASICVLANPBVIRTUALAP2TXTAG,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAP2PortTable, 3,  { 3 , 1, 4 }},
{BASICVLANPBVIRTUALAP2DHCP,ASN_INTEGER,RWRITE,var_BasicVLANPBVirtualAP2PortTable, 3,  { 3 , 1, 5 }},
{BASICVLANPBVIRTUALAP2AVAILABLEWAN,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAP2PortTable, 3,  { 3 , 1, 6 }},
{BASICVLANPBVIRTUALAP2WANVID,ASN_INTEGER,RONLY,var_BasicVLANPBVirtualAP2PortTable, 3,  { 3 , 1, 7 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the UIBasicVLANPortBaseVLANList module */
void
init_UIBasicVLANPortBaseVLANList(void)
{
    DEBUGMSGTL(("UIBasicVLANPortBaseVLANList", "Initializing\n"));
    REGISTER_MIB("UIBasicVLANPortBaseVLANList", UIBasicVLANPortBaseVLANList_variables, variable7,
               UIBasicVLANPortBaseVLANList_variables_oid);
}

static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{

	#ifdef SNMP_CUSTOMER_SMARTLINK
	#define IFENTRY_NAME_LENGTH     17
	#else
	#define IFENTRY_NAME_LENGTH     16
	#endif

	/* in this case, oid len is 16*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}

unsigned char *
var_UIBasicVLANPortBaseVLANList(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    default:
      ERROR_MSG("");
    }
    return NULL;
}

unsigned char *
var_BasicVLANPBEthernetPortTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_BAS_VLAN_PB_ETHERNET);
    w_index_bas_lan_pb_ethernet=index;

    if ( index == MATCH_FAILED )
        return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICVLANPBETHERNETPORTINDEX:
        long_ret = index;
		return (unsigned int *) &long_ret;
    case BASICVLANPBETHERNETPORTTYPE:
        *write_method = write_BasicVLANPBEthernetPortType;
        read_csman(fd,0x00932032+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBETHERNETPORTLANVID:
        read_csman(fd,0x00932012+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBETHERNETPORTTXTAG:
        *write_method = write_BasicVLANPBEthernetPortTxTAG;
        read_csman(fd,0x009320c2+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBETHERNETPORTDHCPSERVER:
        *write_method = write_BasicVLANPBEthernetPortDHCPServer;
        read_csman(fd,0x00932062+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBETHERNETPORTAVAILABLEWAN:
        *write_method = write_BasicVLANPBEthernetPortAvailableWAN;
        read_csman(fd,0x00934011+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBETHERNETPORTWANVID:
        *write_method = write_BasicVLANPBEthernetPortWANVID;
        read_csman(fd,0x00932002+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_BasicVLANPBVirtualAPPortTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_UIBasicVLANPortBaseVLANList above.
 */
unsigned char *
var_BasicVLANPBVirtualAPPortTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_BAS_VLAN_PB_VAP1);
    w_index_bas_lan_pb_vap1=index;

    if ( index == MATCH_FAILED )
        return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICVLANPBVIRTUALAPINDEX:
        long_ret = index;
		return (unsigned int *) &long_ret;
    case BASICVLANPBVIRTUALAPTYPE:
        read_csman(fd,0x00932150+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBVIRTUALAPVID:
        read_csman(fd,0x00932100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBVIRTUALAPTXTAG:
        read_csman(fd,0x00932120+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBVIRTUALAPDHCP:
        *write_method = write_BasicVLANPBVirtualAPDHCP;
        read_csman(fd,0x00932130+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBVIRTUALAPAVAILABLEWAN:
        long_ret=0;
		return (unsigned char *) &long_ret;
    case BASICVLANPBVIRTUALAPWANVID:
        read_csman(fd,0x00932110+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_BasicVLANPBVirtualAP2PortTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_UIBasicVLANPortBaseVLANList above.
 */
unsigned char *
var_BasicVLANPBVirtualAP2PortTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_BAS_VLAN_PB_VAP2);
    w_index_bas_lan_pb_vap2=index;

    if ( index == MATCH_FAILED )
        return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case BASICVLANPBVIRTUALAP2INDEX:
        long_ret = index;
		return (unsigned int *) &long_ret;
    case BASICVLANPBVIRTUALAP2TYPE:
        read_csman(fd,0x009321b0+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBVIRTUALAP2VID:
        read_csman(fd,0x00932160+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBVIRTUALAP2TXTAG:
        read_csman(fd,0x00932180+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBVIRTUALAP2DHCP:
        *write_method = write_BasicVLANPBVirtualAP2DHCP;
        read_csman(fd,0x00932190+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case BASICVLANPBVIRTUALAP2AVAILABLEWAN:
        long_ret=0;
		return (unsigned char *) &long_ret;
    case BASICVLANPBVIRTUALAP2WANVID:
        read_csman(fd,0x00932170+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}


int
write_BasicVLANPBEthernetPortType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicVLANPortBaseVLANList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicVLANPortBaseVLANList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {
            int fd=0;
            write_csman(fd,0x00932032+w_index_bas_lan_pb_ethernet-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
            break;
        }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicVLANPBEthernetPortTxTAG(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicVLANPortBaseVLANList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicVLANPortBaseVLANList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {
            int fd=0;
            write_csman(fd,0x009320c2+w_index_bas_lan_pb_ethernet-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
            break;
        }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicVLANPBEthernetPortDHCPServer(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicVLANPortBaseVLANList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicVLANPortBaseVLANList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {
            int fd=0;
            write_csman(fd,0x00932062+w_index_bas_lan_pb_ethernet-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
            break;
        }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicVLANPBEthernetPortAvailableWAN(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicVLANPortBaseVLANList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicVLANPortBaseVLANList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {
            int fd=0;
            write_csman(fd,0x00934011+w_index_bas_lan_pb_ethernet-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
            break;
        }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicVLANPBEthernetPortWANVID(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicVLANPortBaseVLANList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicVLANPortBaseVLANList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {
            int fd=0;
            write_csman(fd,0x00932002+w_index_bas_lan_pb_ethernet-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
            break;
        }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicVLANPBVirtualAPDHCP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicVLANPortBaseVLANList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicVLANPortBaseVLANList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {
            int fd=0;
            write_csman(fd,0x00932130+w_index_bas_lan_pb_vap1-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
            break;
        }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicVLANPBVirtualAP2DHCP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIBasicVLANPortBaseVLANList not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIBasicVLANPortBaseVLANList: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
        {
            int fd=0;
            write_csman(fd,0x00932190+w_index_bas_lan_pb_vap2-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
            break;
        }
    }
    return SNMP_ERR_NOERROR;
}
