#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "UIInternetSetupOtherSet.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#define NUM_BAS_WAN_MULTI_IGMP	16
#define NUM_BAS_WAN_MULTI_NM	16
int w_index_bas_wan_multiigmp;
int w_index_bas_wan_multinm;

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIInternetSetupOtherSet_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,2,1,3 };
#else
oid UIInternetSetupOtherSet_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,2,1,3 };
#endif

struct variable7 UIInternetSetupOtherSet_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{BASICWANSETUPOTIGMPTYPE,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 1 }},
{BASICWANSETUPOTIGMPPROXYENABLE,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 2 }},
{BASICWANSETUPOTWANALISEENABLE,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 3 }},
{BASICWANSETUPOTWANALISEIP,ASN_IPADDRESS,RWRITE,var_UIInternetSetupOtherSet, 1,  { 4 }},

{BASICWANSETUPOTIGMPMULTIWANINDEX,ASN_INTEGER,RONLY,var_BasicWANSetupOTMultiIGMPTable, 3,	{ 5 , 1, 1 }},
{BASICWANSETUPOTIGMPMULTIWANINTERFACE,ASN_INTEGER,RWRITE,var_BasicWANSetupOTMultiIGMPTable, 3,	{ 5 , 1, 2 }},
{BASICWANSETUPOTIGMPMULTIWANVERSION,ASN_INTEGER,RWRITE,var_BasicWANSetupOTMultiIGMPTable, 3,	{ 5 , 1, 3 }},

{BASICWANSETUPOTNMENABLE,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 6 }},
{BASICWANSETUPOTNMTYPE,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 7 }},
{BASICWANSETUPOTNMLOADCHECKENABLE,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 8 }},
{BASICWANSETUPOTNMCHECKINTERVAL,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 9 }},
{BASICWANSETUPOTNMCHECKTIMEOUT,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 10 }},
{BASICWANSETUPOTNMLATENCYTHRESHOLD,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 11 }},
{BASICWANSETUPOTNMFAILTHRESHOLD,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 12 }},
{BASICWANSETUPOTNMTARGET1TYPE,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 13 }},
{BASICWANSETUPOTNMTARGET1HOST,ASN_OCTET_STR,RWRITE,var_UIInternetSetupOtherSet, 1,  { 14 }},
{BASICWANSETUPOTNMTARGET2TYPE,ASN_INTEGER,RWRITE,var_UIInternetSetupOtherSet, 1,  { 15 }},
{BASICWANSETUPOTNMTARGET2HOST,ASN_OCTET_STR,RWRITE,var_UIInternetSetupOtherSet, 1,  { 16 }},

{BASICWANSETUPOTNMMULTIWANINDEX,ASN_INTEGER,RONLY,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 1 }},
{BASICWANSETUPOTNMMULTIWANENABLE,ASN_INTEGER,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 2 }},
{BASICWANSETUPOTNMMULTIWANTYPE,ASN_INTEGER,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 3 }},
{BASICWANSETUPOTNMMULTIWANLOADCHECKENABLE,ASN_INTEGER,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 4 }},
{BASICWANSETUPOTNMMULTIWANCHECKINTERVAL,ASN_INTEGER,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 5 }},
{BASICWANSETUPOTNMMULTIWANCHECKTIMEOUT,ASN_INTEGER,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 6 }},
{BASICWANSETUPOTNMMULTIWANLATENCYTHRESHOLD,ASN_INTEGER,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 7 }},
{BASICWANSETUPOTNMMULTIWANFAILTHRESHOLD,ASN_INTEGER,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 8 }},
{BASICWANSETUPOTNMMULTIWANTARGET1TYPE,ASN_INTEGER,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 9 }},
{BASICWANSETUPOTNMMULTIWANTARGET1HOST,ASN_OCTET_STR,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 10 }},
{BASICWANSETUPOTNMMULTIWANTARGET2TYPE,ASN_INTEGER,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 11 }},
{BASICWANSETUPOTNMMULTIWANTARGET2HOST,ASN_OCTET_STR,RWRITE,var_BasicWANSetupOTNMMultiWANTable, 3,  { 17 , 1, 12 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the UIInternetSetupOtherSet module */
void
init_UIInternetSetupOtherSet(void)
{
    DEBUGMSGTL(("UIInternetSetupOtherSet", "Initializing\n"));
    REGISTER_MIB("UIInternetSetupOtherSet", UIInternetSetupOtherSet_variables, variable7,
               UIInternetSetupOtherSet_variables_oid);
}

static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	
	#ifdef SNMP_CUSTOMER_SMARTLINK
	#define IFENTRY_NAME_LENGTH     17
	#else
	#define IFENTRY_NAME_LENGTH     16
	#endif
	/* in this case, oid len is 16*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}

unsigned char *
var_UIInternetSetupOtherSet(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    switch(vp->magic) {
    case BASICWANSETUPOTIGMPTYPE:
        *write_method = write_BasicWANSetupOTIGMPType;
        read_csman(fd,0x00010210,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTIGMPPROXYENABLE:
        *write_method = write_BasicWANSetupOTIGMPProxyEnable;
        read_csman(fd,0x0015000C,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTWANALISEENABLE:
        *write_method = write_BasicWANSetupOTWANAliseEnable;
        read_csman(fd,0x00010220,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTWANALISEIP:
        *write_method = write_BasicWANSetupOTWANAliseIP;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00010221,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case BASICWANSETUPOTNMENABLE:
        *write_method = write_BasicWANSetupOTNMEnable;
        read_csman(fd,0x00010800,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMTYPE:
        *write_method = write_BasicWANSetupOTNMType;
        read_csman(fd,0x0043000c,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMLOADCHECKENABLE:
        *write_method = write_BasicWANSetupOTNMLoadCheckEnable;
        read_csman(fd,0x00100801,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMCHECKINTERVAL:
        *write_method = write_BasicWANSetupOTNMCheckInterval;
        read_csman(fd,0x004301d2,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMCHECKTIMEOUT:
        *write_method = write_BasicWANSetupOTNMCheckTimeout;
        read_csman(fd,0x004301d4,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMLATENCYTHRESHOLD:
        *write_method = write_BasicWANSetupOTNMLatencyThreshold;
        read_csman(fd,0x004301d3,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMFAILTHRESHOLD:
        *write_method = write_BasicWANSetupOTNMFailThreshold;
        read_csman(fd,0x004301d0,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMTARGET1TYPE:
        *write_method = write_BasicWANSetupOTNMTarget1Type;
        read_csman(fd,0x004301d7,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMTARGET1HOST:
        *write_method = write_BasicWANSetupOTNMTarget1Host;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00430002,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case BASICWANSETUPOTNMTARGET2TYPE:
        *write_method = write_BasicWANSetupOTNMTarget2Type;
        read_csman(fd,0x004301d8,&long_ret,sizeof(unsigned int),TYPE_U32);	
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMTARGET2HOST:
        *write_method = write_BasicWANSetupOTNMTarget2Host;
        memset(string,0,sizeof(string));
		read_csman(fd,0x004301d6,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_BasicWANSetupOTMultiIGMPTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_UIInternetSetupOtherSet above.
 */
unsigned char *
var_BasicWANSetupOTMultiIGMPTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;

     /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_BAS_WAN_MULTI_IGMP);
    w_index_bas_wan_multiigmp=index;

    if ( index == MATCH_FAILED )
        return NULL;

    switch(vp->magic) {
    case BASICWANSETUPOTIGMPMULTIWANINDEX:
        long_ret = index;
        return (unsigned int *) &long_ret;
    case BASICWANSETUPOTIGMPMULTIWANINTERFACE:
        *write_method = write_BasicWANSetupOTIGMPMultiWANInterface;
        read_csman(fd,0x00010199+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTIGMPMULTIWANVERSION:
        *write_method = write_BasicWANSetupOTIGMPMultiWANVersion;
        read_csman(fd,0x00010200+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_BasicWANSetupOTNMMultiWANTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_UIInternetSetupOtherSet above.
 */
unsigned char *
var_BasicWANSetupOTNMMultiWANTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;

	 /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_BAS_WAN_MULTI_NM);
    w_index_bas_wan_multinm=index;

    if ( index == MATCH_FAILED )
        return NULL;
	
    switch(vp->magic) {
    case BASICWANSETUPOTNMMULTIWANINDEX:
        long_ret = index;
        return (unsigned int *) &long_ret;
    case BASICWANSETUPOTNMMULTIWANENABLE:
        *write_method = write_BasicWANSetupOTNMMultiWANEnable;
        read_csman(fd,0x00010810+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMMULTIWANTYPE:
        *write_method = write_BasicWANSetupOTNMMultiWANType;
        read_csman(fd,0x00431020+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMMULTIWANLOADCHECKENABLE:
        *write_method = write_BasicWANSetupOTNMMultiWANLoadCheckEnable;
        read_csman(fd,0x00010820+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMMULTIWANCHECKINTERVAL:
        *write_method = write_BasicWANSetupOTNMMultiWANCheckInterval;
        read_csman(fd,0x00431090+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMMULTIWANCHECKTIMEOUT:
        *write_method = write_BasicWANSetupOTNMMultiWANCheckTimeout;
        read_csman(fd,0x004310b0+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMMULTIWANLATENCYTHRESHOLD:
        *write_method = write_BasicWANSetupOTNMMultiWANLatencyThreshold;
        read_csman(fd,0x004310a0+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMMULTIWANFAILTHRESHOLD:
        *write_method = write_BasicWANSetupOTNMMultiWANFailThreshold;
        read_csman(fd,0x00431070+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMMULTIWANTARGET1TYPE:
        *write_method = write_BasicWANSetupOTNMMultiWANTarget1Type;
        read_csman(fd,0x004310c0+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMMULTIWANTARGET1HOST:
        *write_method = write_BasicWANSetupOTNMMultiWANTarget1Host;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00431010+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case BASICWANSETUPOTNMMULTIWANTARGET2TYPE:
        *write_method = write_BasicWANSetupOTNMMultiWANTarget2Type;
        read_csman(fd,0x004310d0+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
	 	return (unsigned char *) &long_ret;
    case BASICWANSETUPOTNMMULTIWANTARGET2HOST:
        *write_method = write_BasicWANSetupOTNMMultiWANTarget2Host;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00431060+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}

int
write_BasicWANSetupOTIGMPType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
			  if(long_ret > 0)	write_csman(fd,0x0015003A,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  
              write_csman(fd,0x00010210,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicWANSetupOTIGMPProxyEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x0015000C,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicWANSetupOTWANAliseEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00010220,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicWANSetupOTWANAliseIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			memcpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00010221,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00010800,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x0043000c,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMLoadCheckEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00100801,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMCheckInterval(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x004301d2,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMCheckTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x004301d4,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMLatencyThreshold(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x004301d3,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMFailThreshold(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x004301d0,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMTarget1Type(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x004301d7,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMTarget1Host(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00430002,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMTarget2Type(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x004301d8,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_BasicWANSetupOTNMTarget2Host(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x004301d6,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicWANSetupOTIGMPMultiWANInterface(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00010199+w_index_bas_wan_multiigmp-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTIGMPMultiWANVersion(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00010200+w_index_bas_wan_multiigmp-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_BasicWANSetupOTNMMultiWANEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00010810+w_index_bas_wan_multinm-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTNMMultiWANType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00431020+w_index_bas_wan_multinm-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTNMMultiWANLoadCheckEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00010820+w_index_bas_wan_multinm-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTNMMultiWANCheckInterval(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00431090+w_index_bas_wan_multinm-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTNMMultiWANCheckTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x004310b0+w_index_bas_wan_multinm-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTNMMultiWANLatencyThreshold(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x004310a0+w_index_bas_wan_multinm-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTNMMultiWANFailThreshold(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00431070+w_index_bas_wan_multinm-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTNMMultiWANTarget1Type(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x004310c0+w_index_bas_wan_multinm-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTNMMultiWANTarget1Host(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  memset(string,0,sizeof(string));
			  strncpy(string , (char *) var_val, var_val_len);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00431010+w_index_bas_wan_multinm-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTNMMultiWANTarget2Type(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x004310d0+w_index_bas_wan_multinm-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_BasicWANSetupOTNMMultiWANTarget2Host(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIInternetSetupOtherSet not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIInternetSetupOtherSet: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			  memset(string,0,sizeof(string));
			  strncpy(string , (char *) var_val, var_val_len);
			  break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00431060+w_index_bas_wan_multinm-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
