#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "UISystemOthers.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UISystemOthers_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,5,7 };
#else
oid UISystemOthers_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,5,7 };
#endif

struct variable7 UISystemOthers_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{SYSTEMOTHERCPUUSAGE,ASN_OCTET_STR,RONLY,var_UISystemOthers, 1,  { 1 }},

};

void
init_UISystemOthers(void)
{
    DEBUGMSGTL(("UISystemOthers", "Initializing\n"));
    REGISTER_MIB("UISystemOthers", UISystemOthers_variables, variable7,
               UISystemOthers_variables_oid);
}

unsigned char *
var_UISystemOthers(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMOTHERCPUUSAGE:
	{
		memset(string,0,sizeof(string));
		system("get_cpu_usage");
		read_csman(fd,0x8000f403,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    default:
      ERROR_MSG("");
    }
    return NULL;
}
