#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UITR069Status.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UITR069Status_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,1,6,3 };
#else
oid UITR069Status_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,1,6,3 };
#endif

struct variable7 UITR069Status_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{TR069LINKINGSTATUS,ASN_INTEGER,RONLY,var_UITR069Status, 1, { 1 }},
};

void
init_UITR069Status(void)
{
    DEBUGMSGTL(("UITR069Status", "Initializing\n"));
    REGISTER_MIB("UITR069Status", UITR069Status_variables, variable7, UITR069Status_variables_oid);
    /* place any other initialization junk you need here */
}

unsigned char *
var_UITR069Status(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    switch(vp->magic) {
    case TR069LINKINGSTATUS:
        read_csman(fd,0x00300001,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
