#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UIWANInterfaceIPv4NetworkStatus.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIWANInterfaceIPv4NetworkStatus_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,1,1,1 };
#else
oid UIWANInterfaceIPv4NetworkStatus_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,1,1,1 };
#endif

struct variable7 UIWANInterfaceIPv4NetworkStatus_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{STATUSIPV4WANID1,ASN_OCTET_STR,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 1 }},
{STATUSIPV4INTERFACE1,ASN_OCTET_STR,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 2 }},
{STATUSIPV4WANTYPE1,ASN_INTEGER,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 3 }},
{STATUSIPV4IPADDR1,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,	{ 4 }},
{STATUSIPV4SUBNETMASK1,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,	{ 5 }},
{STATUSIPV4GATEWAY1,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,	{ 6 }},
{STATUSIPV4DNS11,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,	{ 7 }},
{STATUSIPV4DNS12,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1, { 8 }},
{STATUSIPV4MACADDRESS1,ASN_OCTET_STR,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1, { 9 }},
{STATUSIPV4CONNECTSTATUS1,ASN_INTEGER,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 10 }},
{STATUSIPV4WANID2,ASN_OCTET_STR,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 11 }},
{STATUSIPV4INTERFACE2,ASN_OCTET_STR,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 12 }},
{STATUSIPV4WANTYPE2,ASN_INTEGER,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 13 }},
{STATUSIPV4IPADDR2,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,	{ 14 }},
{STATUSIPV4SUBNETMASK2,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,	{ 15 }},
{STATUSIPV4GATEWAY2,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1, { 16 }},
{STATUSIPV4DNS21,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,	{ 17 }},
{STATUSIPV4DNS22,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1, { 18 }},
{STATUSIPV4MACADDRESS2,ASN_OCTET_STR,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1, { 19 }},
{STATUSIPV4CONNECTSTATUS2,ASN_INTEGER,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 20 }},
{STATUSIPV4WANID3,ASN_OCTET_STR,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 21 }},
{STATUSIPV4INTERFACE3,ASN_OCTET_STR,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 22 }},
{STATUSIPV4WANTYPE3,ASN_INTEGER,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 23 }},
{STATUSIPV4IPADDR3,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,	{ 24 }},
{STATUSIPV4SUBNETMASK3,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,	{ 25 }},
{STATUSIPV4GATEWAY3,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1, { 26 }},
{STATUSIPV4DNS31,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,	{ 27 }},
{STATUSIPV4DNS32,ASN_IPADDRESS,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1, { 28 }},
{STATUSIPV4MACADDRESS3,ASN_OCTET_STR,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1, { 29 }},
{STATUSIPV4CONNECTSTATUS3,ASN_INTEGER,RONLY,var_UIWANInterfaceIPv4NetworkStatus, 1,  { 30 }},
};

void
init_UIWANInterfaceIPv4NetworkStatus(void)
{
    DEBUGMSGTL(("UIWANInterfaceIPv4NetworkStatus", "Initializing\n"));
    REGISTER_MIB("UIWANInterfaceIPv4NetworkStatus", UIWANInterfaceIPv4NetworkStatus_variables, variable7,
               UIWANInterfaceIPv4NetworkStatus_variables_oid);
}

unsigned char *
var_UIWANInterfaceIPv4NetworkStatus(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case STATUSIPV4WANID1:
		memset(string,0,sizeof(string));
		strcpy(string,"WAN-1 ");
        *var_len = strlen(string)-1;
		return (unsigned char *) string;
    case STATUSIPV4INTERFACE1:
	{
		int wan_index=0;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00010600,&wan_index,sizeof(unsigned int),TYPE_U32);

		if(wan_index==99)	strcpy(string,"Ethernet ");
		else if(wan_index==1 || wan_index==2 || wan_index==3 || wan_index==4 || wan_index==5){
			strcpy(string,"Ethernet ");
		}
		else if(wan_index==14 || wan_index==15)	strcpy(string,"3G4G ");
		else if(wan_index==16)	strcpy(string,"Dial-up ");
		else strcpy(string,"Disable ");
		*var_len = strlen(string)-1;
		return (unsigned char *) string;	
	}
    case STATUSIPV4WANTYPE1:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		read_csman(fd,0x00010600,&wan_index,sizeof(unsigned int),TYPE_U32);

		if(wan_index == 99){
			//read_csman(fd,0x00010083,&local_wan_enable,sizeof(unsigned int),TYPE_U32);
			//if(local_wan_enable){
				read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
				if(local_wan_type == LOCAL_WANTYPE_DHCP)		long_ret=0;
				else if(local_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=1;
				else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	long_ret=2;
				else if(local_wan_type == LOCAL_WANTYPE_PPTP)	long_ret=3;
				else if(local_wan_type == LOCAL_WANTYPE_L2TP)	long_ret=4;
			//}
		}
		else if (wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == LOCAL_WANTYPE_DHCP)		long_ret=0;
			else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=1;
			else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	long_ret=2;
			else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	long_ret=3;
			else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	long_ret=4;
		}
		else if (wan_index == 14 || wan_index == 15 || wan_index == 16 ){
			if(wan_index == 14 || wan_index == 15 ) long_ret=5;
			else	long_ret=6;
			#if 0
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == 14 || multi_wan_type == 15 )		long_ret=5;
			else if (multi_wan_type == 144 || multi_wan_type == 16)	long_ret=6;
			#endif
		}
		else long_ret=-1;
		return (unsigned int *) &long_ret;	
    }
    case STATUSIPV4IPADDR1:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char ip[4];
		read_csman(fd,0x00010600,&wan_index,sizeof(unsigned int),TYPE_U32);

		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035002,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110001,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040200,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050200,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060200,ip,sizeof(ip),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035110+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110110+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040201+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050201+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062200+wan_index-1,ip,sizeof(ip),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x001e2060,ip,sizeof(ip),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420101,ip,sizeof(ip),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) ip;
	}
    case STATUSIPV4SUBNETMASK1:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char subnet_mask[4];
		read_csman(fd,0x00010600,&wan_index,sizeof(unsigned int),TYPE_U32);
		
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035003,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110002,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040300,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050300,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060300,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035120+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110120+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040301+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050301+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062300+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0301,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420102,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) subnet_mask;
	}
	case STATUSIPV4GATEWAY1:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char gateway[4];
		read_csman(fd,0x00010600,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035004,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110003,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040400,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050400,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060400,gateway,sizeof(gateway),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035130+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110130+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040401+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050401+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062400+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0401,gateway,sizeof(gateway),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420103,gateway,sizeof(gateway),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) gateway;
	}
	case STATUSIPV4DNS11:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char dns[4];
		read_csman(fd,0x00010600,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035005,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110004,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x00040700,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050500,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060500,dns,sizeof(dns),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035140+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110140+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040501+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050501+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062500+wan_index-1,dns,sizeof(dns),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0501,dns,sizeof(dns),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420104,dns,sizeof(dns),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) dns;
	}
	case STATUSIPV4DNS12:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char dns[4];
		read_csman(fd,0x00010600,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035006,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110005,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x00040800,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050600,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060600,dns,sizeof(dns),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035150+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110150+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040601+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050601+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062600+wan_index-1,dns,sizeof(dns),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0601,dns,sizeof(dns),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420105,dns,sizeof(dns),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) dns;
	}
	case STATUSIPV4MACADDRESS1:
	{
        memset(string,0,sizeof(string));
		read_csman(fd,0x8000F371,string,sizeof(string),TYPE_MAC);
		*var_len = 6;
		return (unsigned char *) string;
	}
	case STATUSIPV4CONNECTSTATUS1:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		read_csman(fd,0x00010600,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035007,&long_ret,sizeof(unsigned int),TYPE_U32);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=0;
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040700,&long_ret,sizeof(unsigned int),TYPE_U32);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050700,&long_ret,sizeof(unsigned int),TYPE_U32);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060700,&long_ret,sizeof(unsigned int),TYPE_U32);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035160+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=0;
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040701+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050701+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062700+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0701,&long_ret,sizeof(unsigned int),TYPE_U32);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420200,&long_ret,sizeof(unsigned int),TYPE_U32);
		}
		else long_ret=-1;
		return (unsigned char *) &long_ret;
	} 
	case STATUSIPV4WANID2:
		memset(string,0,sizeof(string));
		strcpy(string,"WAN-2 ");
        *var_len = strlen(string)-1;
		return (unsigned char *) string;
	case STATUSIPV4INTERFACE2:
	{
		int wan_index=0;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00010601,&wan_index,sizeof(unsigned int),TYPE_U32);

		if(wan_index==99)	strcpy(string,"Ethernet ");
		else if(wan_index==1 || wan_index==2 || wan_index==3 || wan_index==4 || wan_index==5){
			strcpy(string,"Ethernet ");
		}
		else if(wan_index==14 || wan_index==15)	strcpy(string,"3G4G ");
		else if(wan_index==16)	strcpy(string,"Dial-up ");
		else strcpy(string,"Disable ");
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
	}
	case STATUSIPV4WANTYPE2:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		read_csman(fd,0x00010601,&wan_index,sizeof(unsigned int),TYPE_U32);

		if(wan_index == 99){
			read_csman(fd,0x00010083,&local_wan_enable,sizeof(unsigned int),TYPE_U32);
			if(local_wan_enable){
				read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
				if(local_wan_type == LOCAL_WANTYPE_DHCP)		long_ret=0;
				else if(local_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=1;
				else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	long_ret=2;
				else if(local_wan_type == LOCAL_WANTYPE_PPTP)	long_ret=3;
				else if(local_wan_type == LOCAL_WANTYPE_L2TP)	long_ret=4;
			}
		}
		else if (wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == LOCAL_WANTYPE_DHCP)		long_ret=0;
			else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=1;
			else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	long_ret=2;
			else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	long_ret=3;
			else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	long_ret=4;
		}
		else if (wan_index == 14 || wan_index == 15 || wan_index == 16 ){
			if(wan_index == 14 || wan_index == 15 ) long_ret=5;
			else	long_ret=6;
			#if 0
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == 14 || multi_wan_type == 15 )		long_ret=5;
			else if (multi_wan_type == 144 || multi_wan_type == 16)	long_ret=6;
			#endif
		} 
		else long_ret=-1;
		return (unsigned int *) &long_ret;	
	}
	case STATUSIPV4IPADDR2:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char ip[4];
		read_csman(fd,0x00010601,&wan_index,sizeof(unsigned int),TYPE_U32);
	
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035002,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110001,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040200,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050200,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060200,ip,sizeof(ip),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035110+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110110+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040201+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050201+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062200+wan_index-1,ip,sizeof(ip),TYPE_IPV4);			
		}
		*var_len = 4;
		return (unsigned char *) ip;
	}
	case STATUSIPV4SUBNETMASK2:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char subnet_mask[4];
		read_csman(fd,0x00010601,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035003,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110002,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040300,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050300,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060300,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035120+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110120+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040301+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050301+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062300+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0301,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420102,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) subnet_mask;
	}
	case STATUSIPV4GATEWAY2:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char gateway[4];
		read_csman(fd,0x00010601,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035004,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110003,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040400,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050400,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060400,gateway,sizeof(gateway),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035130+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110130+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040401+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050401+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062400+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0401,gateway,sizeof(gateway),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420103,gateway,sizeof(gateway),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) gateway;
	}
	case STATUSIPV4DNS21:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char dns[4];
		read_csman(fd,0x00010601,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035005,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110004,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x00040700,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050500,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060500,dns,sizeof(dns),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035140+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110140+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040501+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050501+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062500+wan_index-1,dns,sizeof(dns),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0501,dns,sizeof(dns),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420104,dns,sizeof(dns),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) dns;
	}
	case STATUSIPV4DNS22:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char dns[4];
		read_csman(fd,0x00010601,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035006,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110005,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x00040800,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050600,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060600,dns,sizeof(dns),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035150+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110150+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040601+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050601+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062600+wan_index-1,dns,sizeof(dns),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0601,dns,sizeof(dns),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420105,dns,sizeof(dns),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) dns;
	}
	case STATUSIPV4MACADDRESS2:
	{
        memset(string,0,sizeof(string));
		read_csman(fd,0x8000F372,string,sizeof(string),TYPE_MAC);
		*var_len = 6;
		return (unsigned char *) string;
	}
	case STATUSIPV4CONNECTSTATUS2:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		read_csman(fd,0x00010601,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035007,&long_ret,sizeof(unsigned int),TYPE_U32);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=0;
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040700,&long_ret,sizeof(unsigned int),TYPE_U32);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050700,&long_ret,sizeof(unsigned int),TYPE_U32);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060700,&long_ret,sizeof(unsigned int),TYPE_U32);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035160+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=0;
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040701+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050701+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062700+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0701,&long_ret,sizeof(unsigned int),TYPE_U32);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420200,&long_ret,sizeof(unsigned int),TYPE_U32);
		}
		else long_ret=-1;
		return (unsigned char *) &long_ret;
	}
	case STATUSIPV4WANID3:
		memset(string,0,sizeof(string));
		strcpy(string,"WAN-3 ");
        *var_len = strlen(string)-1;
		return (unsigned char *) string;
	case STATUSIPV4INTERFACE3:
	{
		int wan_index=0;
		memset(string,0,sizeof(string));
		read_csman(fd,0x00010602,&wan_index,sizeof(unsigned int),TYPE_U32);

		if(wan_index==99)	strcpy(string,"Ethernet ");
		else if(wan_index==1 || wan_index==2 || wan_index==3 || wan_index==4 || wan_index==5){
			strcpy(string,"Ethernet ");
		}
		else if(wan_index==14 || wan_index==15)	strcpy(string,"3G4G ");
		else if(wan_index==16)	strcpy(string,"Dial-up ");
		else strcpy(string,"Disable ");
		*var_len = strlen(string)-1;
		return (unsigned char *) string;

	}
	case STATUSIPV4WANTYPE3:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		read_csman(fd,0x00010602,&wan_index,sizeof(unsigned int),TYPE_U32);

		if(wan_index == 99){
			read_csman(fd,0x00010083,&local_wan_enable,sizeof(unsigned int),TYPE_U32);
			if(local_wan_enable){
				read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
				if(local_wan_type == LOCAL_WANTYPE_DHCP)		long_ret=0;
				else if(local_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=1;
				else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	long_ret=2;
				else if(local_wan_type == LOCAL_WANTYPE_PPTP)	long_ret=3;
				else if(local_wan_type == LOCAL_WANTYPE_L2TP)	long_ret=4;
			}
		}
		else if (wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == LOCAL_WANTYPE_DHCP)		long_ret=0;
			else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=1;
			else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	long_ret=2;
			else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	long_ret=3;
			else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	long_ret=4;
		}
		else if (wan_index == 14 || wan_index == 15 || wan_index == 16 ){
			if(wan_index == 14 || wan_index == 15 ) long_ret=5;
			else	long_ret=6;
			#if 0
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == 14 || multi_wan_type == 15 )		long_ret=5;
			else if (multi_wan_type == 144 || multi_wan_type == 16)	long_ret=6;
			#endif
		}
		else long_ret=-1;
		return (unsigned int *) &long_ret;	
	}
	case STATUSIPV4IPADDR3:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char ip[4];
		read_csman(fd,0x00010602,&wan_index,sizeof(unsigned int),TYPE_U32);
		
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035002,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110001,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040200,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050200,ip,sizeof(ip),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060200,ip,sizeof(ip),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035110+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110110+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040201+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050201+wan_index-1,ip,sizeof(ip),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062200+wan_index-1,ip,sizeof(ip),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x001e2060,ip,sizeof(ip),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420101,ip,sizeof(ip),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) ip;
	}
	case STATUSIPV4SUBNETMASK3:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char subnet_mask[4];
		read_csman(fd,0x00010602,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035003,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110002,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040300,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050300,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060300,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
			read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
			if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035120+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110120+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040301+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050301+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
			else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062300+wan_index-1,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0301,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420102,subnet_mask,sizeof(subnet_mask),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) subnet_mask;
	}
	case STATUSIPV4GATEWAY3:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char gateway[4];
		read_csman(fd,0x00010602,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035004,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110003,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040400,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050400,gateway,sizeof(gateway),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060400,gateway,sizeof(gateway),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035130+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110130+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040401+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050401+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062400+wan_index-1,gateway,sizeof(gateway),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0401,gateway,sizeof(gateway),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420103,gateway,sizeof(gateway),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) gateway;
	}
	case STATUSIPV4DNS31:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char dns[4];
		read_csman(fd,0x00010602,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035005,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110004,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x00040700,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050500,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060500,dns,sizeof(dns),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035140+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110140+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040501+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050501+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062500+wan_index-1,dns,sizeof(dns),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0501,dns,sizeof(dns),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420104,dns,sizeof(dns),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) dns;
	}
	case STATUSIPV4DNS32:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		unsigned char dns[4];
		read_csman(fd,0x00010602,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035006,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110005,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x00040800,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050600,dns,sizeof(dns),TYPE_IPV4);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060600,dns,sizeof(dns),TYPE_IPV4);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035150+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	read_csman(fd,0x00110150+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040601+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050601+wan_index-1,dns,sizeof(dns),TYPE_IPV4);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062600+wan_index-1,dns,sizeof(dns),TYPE_IPV4);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0601,dns,sizeof(dns),TYPE_IPV4);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420105,dns,sizeof(dns),TYPE_IPV4);
		}
		*var_len = 4;
		return (unsigned char *) dns;
	}
	case STATUSIPV4MACADDRESS3:
	{
        memset(string,0,sizeof(string));
		read_csman(fd,0x8000F372,string,sizeof(string),TYPE_MAC);
		*var_len = 6;
		return (unsigned char *) string;
	}
	case STATUSIPV4CONNECTSTATUS3:
	{
		int wan_type=0,wan_index=0;
		int local_wan_enable=0,local_wan_type=0;
		int multi_wan_enable=0,multi_wan_type=0;
		read_csman(fd,0x00010602,&wan_index,sizeof(unsigned int),TYPE_U32);
			
		if(wan_index == 99){
			read_csman(fd,0x00010003,&local_wan_type,sizeof(unsigned int),TYPE_U32);
			if(local_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035007,&long_ret,sizeof(unsigned int),TYPE_U32);
			else if(local_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=0;
			else if(local_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040700,&long_ret,sizeof(unsigned int),TYPE_U32);
			else if(local_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050700,&long_ret,sizeof(unsigned int),TYPE_U32);
			else if(local_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80060700,&long_ret,sizeof(unsigned int),TYPE_U32);		
		}
		else if(wan_index == 1 || wan_index == 2 || wan_index == 3 || wan_index == 4 || wan_index == 5){
		read_csman(fd,0x00010120+wan_index-1,&multi_wan_type,sizeof(unsigned int),TYPE_U32);
		if(multi_wan_type == LOCAL_WANTYPE_DHCP)		read_csman(fd,0x80035160+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(multi_wan_type == LOCAL_WANTYPE_FIXED)	long_ret=0;
		else if(multi_wan_type == LOCAL_WANTYPE_PPPOE)	read_csman(fd,0x80040701+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(multi_wan_type == LOCAL_WANTYPE_PPTP)	read_csman(fd,0x80050701+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(multi_wan_type == LOCAL_WANTYPE_L2TP)	read_csman(fd,0x80062700+wan_index-1,&long_ret,sizeof(unsigned int),TYPE_U32);			
		}
		else if(wan_index == 14 || wan_index == 15){
			read_csman(fd,0x801e0701,&long_ret,sizeof(unsigned int),TYPE_U32);
		}
		else if(wan_index == 16 || wan_index == 144){
			read_csman(fd,0x80420200,&long_ret,sizeof(unsigned int),TYPE_U32);
		}
		else long_ret=-1;
		return (unsigned char *) &long_ret;
	}
    default:
      ERROR_MSG("");
    }
    return NULL;
}
