#ifndef _CSMAN_H
#define _CSMAN_H

#define SNMPRESULT "/tmp/snmp_return"
#define TMPSIZE 8192

#define TYPE_U8 "u8"
#define TYPE_U16 "u16"
#define TYPE_U32 "u32"
#define TYPE_STR "str"
#define TYPE_IPV4 "ipv4"
#define TYPE_MAC "mac"

#define LOCAL_WANTYPE_DHCP              0x00
#define LOCAL_WANTYPE_NULL              0x01
#define LOCAL_WANTYPE_3G                0x10
#define LOCAL_WANTYPE_IBURST            0x11
#define LOCAL_WANTYPE_WIBRO             0x12
#define LOCAL_WANTYPE_WISP              0x13
#define LOCAL_WANTYPE_FIXED             0x20
#define LOCAL_WANTYPE_PPPOE             0x40
#define LOCAL_WANTYPE_PPPOE_MULTI       0x41
#define LOCAL_WANTYPE_PPTP              0x60
#define LOCAL_WANTYPE_L2TP              0x80
#define LOCAL_WANTYPE_DIALUP            0x90


int open_csman(const char *config, int flags);
int close_csman(int fd);
ssize_t read_csman(int fd, unsigned int csid, void *buf, size_t count, char *type);
ssize_t write_csman(int fd, unsigned int csid, const void *buf, size_t count, char *type);
char switch_type(char *type);

#endif 
