#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */

#include "csman.h"
#include "SystemUserGroup.h"
#include <stdio.h>
#include <string.h>

#define NUM_USERGROUP	32
int usergroup_w_index=0;

#ifdef SNMP_CUSTOMER_SMARTLINK
oid SystemUserGroup_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,5,10,2 };
#else
oid SystemUserGroup_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,5,10,2 };
#endif

struct variable7 SystemUserGroup_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

/*Add Group*/
{SYSTEMADDGROUPALTER,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 1 }},
{SYSTEMADDGROUPNAME,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 2 }},
{SYSTEMADDGROUPUSER01,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 3 }},
{SYSTEMADDGROUPUSER02,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 4 }},
{SYSTEMADDGROUPUSER03,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 5 }},
{SYSTEMADDGROUPUSER04,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 6 }},
{SYSTEMADDGROUPUSER05,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 7 }},
{SYSTEMADDGROUPUSER06,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 8 }},
{SYSTEMADDGROUPUSER07,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 9 }},
{SYSTEMADDGROUPUSER08,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 10 }},
{SYSTEMADDGROUPUSER09,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 11 }},
{SYSTEMADDGROUPUSER10,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 12 }},
{SYSTEMADDGROUPUSER11,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 13 }},
{SYSTEMADDGROUPUSER12,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 14 }},
{SYSTEMADDGROUPUSER13,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 15 }},
{SYSTEMADDGROUPUSER14,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 16 }},
{SYSTEMADDGROUPUSER15,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 17 }},
{SYSTEMADDGROUPUSER16,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 18 }},
{SYSTEMADDGROUPUSER17,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 19 }},
{SYSTEMADDGROUPUSER18,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 20 }},
{SYSTEMADDGROUPUSER19,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 21 }},
{SYSTEMADDGROUPUSER20,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 22 }},
{SYSTEMADDGROUPUSER21,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 23 }},
{SYSTEMADDGROUPUSER22,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 24 }},
{SYSTEMADDGROUPUSER23,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 25 }},
{SYSTEMADDGROUPUSER24,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 26 }},
{SYSTEMADDGROUPUSER25,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 27 }},
{SYSTEMADDGROUPUSER26,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 28 }},
{SYSTEMADDGROUPUSER27,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 29 }},
{SYSTEMADDGROUPUSER28,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 30 }},
{SYSTEMADDGROUPUSER29,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 31 }},
{SYSTEMADDGROUPUSER30,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 32 }},
{SYSTEMADDGROUPUSER31,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 33 }},
{SYSTEMADDGROUPUSER32,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 34 }},
{SYSTEMADDGROUPXAUTH,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 35 }},
{SYSTEMADDGROUPNAS,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 36 }},
{SYSTEMADDGROUPRADIUS,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 37 }},
{SYSTEMADDGROUPVPN,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 38 }},
{SYSTEMADDGROUPACCOUNTING,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 39 }},
{SYSTEMADDGROUPBILLING,ASN_INTEGER,	RWRITE,var_SystemUserGroup, 1,  { 40 }},
{SYSTEMADDAddQOsBWMPROPERTY,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 41 }},
{SYSTEMADDAddQOsBWMPROPERTYVALUE,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 42 }},
{SYSTEMADDAddQOsBWMPROPERTYUNITS,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 43 }},
{SYSTEMADDPOLICYROUTINGPROPERTY,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 44 }},
{SYSTEMADDGROUPENABLE,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 45 }},
/*Delete Group*/
{SYSTEMDELETEGROUPALTER,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 46 }},
{SYSTEMDELETEGROUPINDEX,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 47 }},
/*Mod Group*/
{SYSTEMMODGROUPALTER,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 48 }},
{SYSTEMMODGROUPNAMEORIGINAL,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 49 }},
{SYSTEMMODGROUPNAME,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 50 }},
{SYSTEMMODGROUPUSER01,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 51 }},
{SYSTEMMODGROUPUSER02,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 52 }},
{SYSTEMMODGROUPUSER03,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 53 }},
{SYSTEMMODGROUPUSER04,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 54 }},
{SYSTEMMODGROUPUSER05,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 55 }},
{SYSTEMMODGROUPUSER06,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 56 }},
{SYSTEMMODGROUPUSER07,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 57 }},
{SYSTEMMODGROUPUSER08,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 58 }},
{SYSTEMMODGROUPUSER09,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 59 }},
{SYSTEMMODGROUPUSER10,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 60 }},
{SYSTEMMODGROUPUSER11,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 61 }},
{SYSTEMMODGROUPUSER12,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 62 }},
{SYSTEMMODGROUPUSER13,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 63 }},
{SYSTEMMODGROUPUSER14,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 64 }},
{SYSTEMMODGROUPUSER15,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 65 }},
{SYSTEMMODGROUPUSER16,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 66 }},
{SYSTEMMODGROUPUSER17,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 67 }},
{SYSTEMMODGROUPUSER18,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 68 }},
{SYSTEMMODGROUPUSER19,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 69 }},
{SYSTEMMODGROUPUSER20,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 70 }},
{SYSTEMMODGROUPUSER21,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 71 }},
{SYSTEMMODGROUPUSER22,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 72 }},
{SYSTEMMODGROUPUSER23,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 73 }},
{SYSTEMMODGROUPUSER24,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 74 }},
{SYSTEMMODGROUPUSER25,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 75 }},
{SYSTEMMODGROUPUSER26,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 76 }},
{SYSTEMMODGROUPUSER27,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 77 }},
{SYSTEMMODGROUPUSER28,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 78 }},
{SYSTEMMODGROUPUSER29,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 79 }},
{SYSTEMMODGROUPUSER30,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 80 }},
{SYSTEMMODGROUPUSER31,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 81 }},
{SYSTEMMODGROUPUSER32,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 82 }},
{SYSTEMMODGROUPXAUTH,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 83 }},
{SYSTEMMODGROUPNAS,ASN_INTEGER,RWRITE, var_SystemUserGroup, 1,  { 84 }},
{SYSTEMMODGROUPRADIUS,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 85 }},
{SYSTEMMODGROUPVPN,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 86 }},
{SYSTEMMODGROUPACCOUNTING,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 87 }},
{SYSTEMMODGROUPBILLING,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 88 }},
{SYSTEMMODAddQOsBWMPROPERTY,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 89 }},
{SYSTEMMODAddQOsBWMPROPERTYVALUE,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 90 }},
{SYSTEMMODAddQOsBWMPROPERTYUNITS,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 91 }},
{SYSTEMMODPOLICYROUTINGPROPERTY,ASN_OCTET_STR,RWRITE,var_SystemUserGroup, 1,  { 92 }},
{SYSTEMMODGROUPENABLE,ASN_INTEGER,RWRITE,var_SystemUserGroup, 1,  { 93 }},
/*Group List*/
{SYSTEMRADIUSGROUPIDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupTable, 3,  { 94 , 1, 1 }},
{SYSTEMRADIUSGROUPNAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupTable, 3,  { 94 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER01IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser01Table, 3,  { 95 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER01NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser01Table, 3,  { 95 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER02IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser02Table, 3,  { 96 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER02NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser02Table, 3,  { 96 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER03IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser03Table, 3,  { 97 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER03NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser03Table, 3,  { 97 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER04IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser04Table, 3,  { 98 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER04NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser04Table, 3,  { 98 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER05IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser05Table, 3,  { 99 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER05NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser05Table, 3,  { 99 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER06IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser06Table, 3,  { 100 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER06NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser06Table, 3,  { 100 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER07IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser07Table, 3,  { 101 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER07NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser07Table, 3,  { 101 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER08IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser08Table, 3,  { 102 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER08NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser08Table, 3,  { 102 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER09IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser09Table, 3,  { 103 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER09NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser09Table, 3,  { 103 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER10IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser10Table, 3,  { 104 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER10NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser10Table, 3,  { 104 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER11IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser11Table, 3,  { 105 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER11NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser11Table, 3,  { 105 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER12IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser12Table, 3,  { 106 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER12NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser12Table, 3,  { 106 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER13IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser13Table, 3,  { 107 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER13NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser13Table, 3,  { 107 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER14IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser14Table, 3,  { 108 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER14NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser14Table, 3,  { 108 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER15IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser15Table, 3,  { 109 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER15NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser15Table, 3,  { 109 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER16IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser16Table, 3,  { 110 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER16NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser16Table, 3,  { 110 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER17IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser17Table, 3,  { 111 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER17NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser17Table, 3,  { 111 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER18IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser18Table, 3,  { 112 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER18NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser18Table, 3,  { 112 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER19IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser19Table, 3,  { 113 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER19NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser19Table, 3,  { 113 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER20IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser20Table, 3,  { 114 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER20NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser20Table, 3,  { 114 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER21IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser21Table, 3,  { 115 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER21NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser21Table, 3,  { 115 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER22IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser22Table, 3,  { 116 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER22NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser22Table, 3,  { 116 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER23IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser23Table, 3,  { 117 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER23NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser23Table, 3,  { 117 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER24IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser24Table, 3,  { 118 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER24NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser24Table, 3,  { 118 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER25IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser25Table, 3,  { 119 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER25NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser25Table, 3,  { 119 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER26IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser26Table, 3,  { 120 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER26NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser26Table, 3,  { 120 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER27IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser27Table, 3,  { 121 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER27NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser27Table, 3,  { 121 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER28IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser28Table, 3,  { 122 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER28NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser28Table, 3,  { 122 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER29IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser29Table, 3,  { 123 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER29NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser29Table, 3,  { 123 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER30IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser30Table, 3,  { 124 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER30NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser30Table, 3,  { 124 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER31IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser31Table, 3,  { 125 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER31NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser31Table, 3,  { 125 , 1, 2 }},
{SYSTEMRADIUSGROUPUSER32IDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupUser32Table, 3,  { 126 , 1, 1 }},
{SYSTEMRADIUSGROUPUSER32NAME,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupUser32Table, 3,  { 126 , 1, 2 }},
{SYSTEMRADIUSGROUPXAUTHIDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupxAUthTable, 3,  { 127 , 1, 1 }},
{SYSTEMRADIUSGROUPXAUTH,ASN_INTEGER,RWRITE,var_SystemRadiusGroupxAUthTable, 3,  { 127 , 1, 2 }},
{SYSTEMRADIUSGROUPNASIDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupNASTable, 3,  { 128 , 1, 1 }},
{SYSTEMRADIUSGROUPNAS,ASN_INTEGER,RWRITE,var_SystemRadiusGroupNASTable, 3,  { 128 , 1, 2 }},
{SYSTEMRADIUSGROUPRADIUSIDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupRadiusTable, 3,  { 129 , 1, 1 }},
{SYSTEMRADIUSGROUPRADIUS,ASN_INTEGER,RWRITE,var_SystemRadiusGroupRadiusTable, 3,  { 129 , 1, 2 }},
{SYSTEMRADIUSGROUPVPNIDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupVPNTable, 3,  { 130 , 1, 1 }},
{SYSTEMRADIUSGROUPVPN,ASN_INTEGER,RWRITE,var_SystemRadiusGroupVPNTable, 3,  { 130 , 1, 2 }},
{SYSTEMRADIUSGROUPACCOUNDINGIDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupAccoundingTable, 3,  { 131 , 1, 1 }},
{SYSTEMRADIUSGROUPACCOUNDING,ASN_INTEGER,RWRITE,var_SystemRadiusGroupAccoundingTable, 3,  { 131 , 1, 2 }},
{SYSTEMRADIUSGROUPBILLINGIDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupBillingTable, 3,  { 132 , 1, 1 }},
{SYSTEMRADIUSGROUPBILLING,ASN_INTEGER,RWRITE,var_SystemRadiusGroupBillingTable, 3,  { 132, 1, 2 }},
{SYSTEMRADIUSGROUPQOsBWMPROPERTYIDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupQoSBWMPropertyTable, 3,  { 133 , 1, 1 }},
{SYSTEMRADIUSGROUPQOsBWMPROPERTY,ASN_INTEGER,RWRITE,var_SystemRadiusGroupQoSBWMPropertyTable, 3,  { 133 , 1, 2 }},
{SYSTEMRADIUSGROUPQOsBWMPROPERTYVALUEIDINDEX,ASN_INTEGER, RONLY,var_SystemRadiusGroupQoSBWMPropertyValueTable, 3,  { 134 , 1, 1 }},
{SYSTEMRADIUSGROUPQOsBWMPROPERTYVALUE,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupQoSBWMPropertyValueTable, 3,  { 134 , 1, 2 }},
{SYSTEMRADIUSGROUPQOsBWMPROPERTYUNITSIDINDEX,ASN_INTEGER, RONLY,var_SystemRadiusGroupQoSBWMPropertyUnitsTable, 3,  { 135 , 1, 1 }},
{SYSTEMRADIUSGROUPQOsBWMPROPERTYUNITS,ASN_INTEGER,RWRITE,var_SystemRadiusGroupQoSBWMPropertyUnitsTable, 3,  { 135 , 1, 2 }},
{SYSTEMRADIUSGROUPPOLICYROUTINGPROPERTYIDINDEX,ASN_INTEGER, RONLY,var_SystemRadiusGroupPolicyRoutingPropertyTable, 3,  { 136 , 1, 1 }},
{SYSTEMRADIUSGROUPPOLICYROUTINGPROPERTY,ASN_OCTET_STR,RWRITE,var_SystemRadiusGroupPolicyRoutingPropertyTable, 3,  { 136 , 1, 2 }},
{SYSTEMRADIUSGROUPENABLEIDINDEX,ASN_INTEGER,  RONLY,var_SystemRadiusGroupEnableTable, 3,  { 137 , 1, 1 }},
{SYSTEMRADIUSGROUPENABLE,ASN_INTEGER,RWRITE,var_SystemRadiusGroupEnableTable, 3,  { 137 , 1, 2 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the SystemUserGroup module */
void
init_SystemUserGroup(void)
{
    DEBUGMSGTL(("SystemUserGroup", "Initializing\n"));
    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("SystemUserGroup", SystemUserGroup_variables, variable7,
               SystemUserGroup_variables_oid);
    /* place any other initialization junk you need here */
}

static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	#ifdef SNMP_CUSTOMER_SMARTLINK
	#define IFENTRY_NAME_LENGTH     17
	#else
	#define IFENTRY_NAME_LENGTH     16
	#endif
	/* in this case, oid len is 16*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}


/*
 * var_SystemUserGroup():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_SystemUserGroup(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMADDGROUPALTER:
        *write_method = write_SystemAddGroupAlter;
        read_csman(fd,0x809e0101,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMADDGROUPNAME:
        *write_method = write_SystemAddGroupName;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1000,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER01:
        *write_method = write_SystemAddGroupUser01;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1010,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER02:
        *write_method = write_SystemAddGroupUser02;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1011,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER03:
        *write_method = write_SystemAddGroupUser03;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1012,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER04:
        *write_method = write_SystemAddGroupUser04;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1013,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER05:
        *write_method = write_SystemAddGroupUser05;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1014,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER06:
        *write_method = write_SystemAddGroupUser06;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1015,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER07:
        *write_method = write_SystemAddGroupUser07;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1016,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER08:
        *write_method = write_SystemAddGroupUser08;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1017,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER09:
        *write_method = write_SystemAddGroupUser09;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1018,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER10:
        *write_method = write_SystemAddGroupUser10;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1019,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER11:
        *write_method = write_SystemAddGroupUser11;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e101a,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER12:
        *write_method = write_SystemAddGroupUser12;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e101b,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER13:
        *write_method = write_SystemAddGroupUser13;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e101c,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER14:
        *write_method = write_SystemAddGroupUser14;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e101d,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER15:
        *write_method = write_SystemAddGroupUser15;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e101e,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER16:
        *write_method = write_SystemAddGroupUser16;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e101f,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;;
    case SYSTEMADDGROUPUSER17:
        *write_method = write_SystemAddGroupUser17;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1020,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER18:
        *write_method = write_SystemAddGroupUser18;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1021,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER19:
        *write_method = write_SystemAddGroupUser19;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1022,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER20:
        *write_method = write_SystemAddGroupUser20;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1023,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER21:
        *write_method = write_SystemAddGroupUser21;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1024,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER22:
        *write_method = write_SystemAddGroupUser22;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1025,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER23:
        *write_method = write_SystemAddGroupUser23;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1026,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER24:
        *write_method = write_SystemAddGroupUser24;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1027,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER25:
        *write_method = write_SystemAddGroupUser25;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1028,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER26:
        *write_method = write_SystemAddGroupUser26;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1029,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER27:
        *write_method = write_SystemAddGroupUser27;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e102a,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER28:
        *write_method = write_SystemAddGroupUser28;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e102b,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER29:
        *write_method = write_SystemAddGroupUser29;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e102c,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER30:
        *write_method = write_SystemAddGroupUser30;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e102d,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER31:
        *write_method = write_SystemAddGroupUser31;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e102e,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPUSER32:
        *write_method = write_SystemAddGroupUser32;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e102f,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPXAUTH:
        *write_method = write_SystemAddGroupXAuth;
        read_csman(fd,0x009e1030,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMADDGROUPNAS:
        *write_method = write_SystemAddGroupNAS;
        read_csman(fd,0x009e1031,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMADDGROUPRADIUS:
        *write_method = write_SystemAddGroupRadius;
        read_csman(fd,0x009e1032,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMADDGROUPVPN:
        *write_method = write_SystemAddGroupVPN;
        read_csman(fd,0x009e1033,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMADDGROUPACCOUNTING:
        *write_method = write_SystemAddGroupAccounting;
        read_csman(fd,0x009e1034,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMADDGROUPBILLING:
        *write_method = write_SystemAddGroupBilling;
        read_csman(fd,0x009e1035,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
	case SYSTEMADDAddQOsBWMPROPERTY:
        *write_method = write_SystemAddQosBWMProperty;
        read_csman(fd,0x009e1036,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;	
	case SYSTEMADDAddQOsBWMPROPERTYVALUE:
        *write_method = write_SystemAddQosBWMPropertyValue;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1037,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
	case SYSTEMADDAddQOsBWMPROPERTYUNITS:
        *write_method = write_SystemAddQosBWMPropertyUnits;
		read_csman(fd,0x009e1039,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;	
	case SYSTEMADDPOLICYROUTINGPROPERTY:
        *write_method = write_SystemAddPolicyRoutingProperty;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e1038,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMADDGROUPENABLE:
        *write_method = write_SystemAddGroupEnable;
        read_csman(fd,0x009e1050,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMDELETEGROUPALTER:
        *write_method = write_SystemDeleteGroupAlter;
        read_csman(fd,0x809e0100,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMDELETEGROUPINDEX:
        *write_method = write_SystemDeleteGroupIndex;
		read_csman(fd,0x809e0102,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMMODGROUPALTER:
        *write_method = write_SystemModGroupAlter;
        read_csman(fd,0x809e0104,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMMODGROUPNAMEORIGINAL:
        *write_method = write_SystemModGroupNameOriginal;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3000,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPNAME:
        *write_method = write_SystemModGroupName;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3001,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER01:
        *write_method = write_SystemModGroupUser01;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3010,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER02:
        *write_method = write_SystemModGroupUser02;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3011,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER03:
        *write_method = write_SystemModGroupUser03;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3012,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER04:
        *write_method = write_SystemModGroupUser04;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3013,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER05:
        *write_method = write_SystemModGroupUser05;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3014,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER06:
        *write_method = write_SystemModGroupUser06;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3015,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER07:
        *write_method = write_SystemModGroupUser07;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3016,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER08:
        *write_method = write_SystemModGroupUser08;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3017,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER09:
        *write_method = write_SystemModGroupUser09;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3018,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER10:
        *write_method = write_SystemModGroupUser10;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3019,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER11:
        *write_method = write_SystemModGroupUser11;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e301a,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER12:
        *write_method = write_SystemModGroupUser12;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e301b,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER13:
        *write_method = write_SystemModGroupUser13;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e301c,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER14:
        *write_method = write_SystemModGroupUser14;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e301d,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER15:
        *write_method = write_SystemModGroupUser15;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e301e,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER16:
        *write_method = write_SystemModGroupUser16;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e301f,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER17:
        *write_method = write_SystemModGroupUser17;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3020,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER18:
        *write_method = write_SystemModGroupUser18;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3021,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER19:
        *write_method = write_SystemModGroupUser19;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3022,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER20:
        *write_method = write_SystemModGroupUser20;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3023,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER21:
        *write_method = write_SystemModGroupUser21;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3024,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER22:
        *write_method = write_SystemModGroupUser22;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3025,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER23:
        *write_method = write_SystemModGroupUser23;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3026,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER24:
        *write_method = write_SystemModGroupUser24;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3027,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER25:
        *write_method = write_SystemModGroupUser25;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3028,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER26:
        *write_method = write_SystemModGroupUser26;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3029,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER27:
        *write_method = write_SystemModGroupUser27;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e302a,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER28:
        *write_method = write_SystemModGroupUser28;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e302b,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER29:
        *write_method = write_SystemModGroupUser29;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e302c,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER30:
        *write_method = write_SystemModGroupUser30;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e302d,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER31:
        *write_method = write_SystemModGroupUser31;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e302e,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPUSER32:
        *write_method = write_SystemModGroupUser32;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e302f,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case SYSTEMMODGROUPXAUTH:
        *write_method = write_SystemModGroupXAuth;
        read_csman(fd,0x009e3030,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMMODGROUPNAS:
        *write_method = write_SystemModGroupNAS;
        read_csman(fd,0x009e3031,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;		
    case SYSTEMMODGROUPRADIUS:
        *write_method = write_SystemModGroupRadius;
        read_csman(fd,0x009e3032,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMMODGROUPVPN:
        *write_method = write_SystemModGroupVPN;
        read_csman(fd,0x009e3033,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMMODGROUPACCOUNTING:
        *write_method = write_SystemModGroupAccounting;
        read_csman(fd,0x009e3034,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case SYSTEMMODGROUPBILLING:
        *write_method = write_SystemModGroupBilling;
        read_csman(fd,0x009e3035,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
	case SYSTEMMODAddQOsBWMPROPERTY:
	    *write_method = write_SystemModGroupQosBWMProperty;
        read_csman(fd,0x009e3036,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
	case SYSTEMMODAddQOsBWMPROPERTYVALUE:
		*write_method = write_SystemModGroupQosBWMPropertyValue;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3037,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
	case SYSTEMMODAddQOsBWMPROPERTYUNITS:
	    *write_method = write_SystemModGroupQosBWMPropertyUnits;
        read_csman(fd,0x009e3039,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;	
	case SYSTEMMODPOLICYROUTINGPROPERTY:
        *write_method = write_SystemModGroupPolicyRoutingProperty;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e3038,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
	case SYSTEMMODGROUPENABLE:
        *write_method = write_SystemModGroupEnable;
        read_csman(fd,0x009e3050,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_SystemRadiusGroupTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;

    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
			
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPNAME:
        *write_method = write_SystemRadiusGroupName;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4000+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser01Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser01Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;

    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
			
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER01IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER01NAME:
        *write_method = write_SystemRadiusGroupUser01Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4020+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser02Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser02Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER02IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER02NAME:
        *write_method = write_SystemRadiusGroupUser02Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4040+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser03Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser03Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER03IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER03NAME:
        *write_method = write_SystemRadiusGroupUser03Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4060+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser04Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser04Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER04IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER04NAME:
        *write_method = write_SystemRadiusGroupUser04Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4080+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser05Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser05Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER05IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER05NAME:
        *write_method = write_SystemRadiusGroupUser05Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e40a0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser06Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser06Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER06IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER06NAME:
        *write_method = write_SystemRadiusGroupUser06Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e40c0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser07Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser07Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER07IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER07NAME:
        *write_method = write_SystemRadiusGroupUser07Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e40e0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser08Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser08Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER08IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER08NAME:
        *write_method = write_SystemRadiusGroupUser08Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4100+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser09Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser09Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER09IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER09NAME:
        *write_method = write_SystemRadiusGroupUser09Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4120+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser10Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser10Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER10IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER10NAME:
        *write_method = write_SystemRadiusGroupUser10Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4140+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser11Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser11Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER11IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER11NAME:
        *write_method = write_SystemRadiusGroupUser11Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4160+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser12Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser12Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER12IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER12NAME:
        *write_method = write_SystemRadiusGroupUser12Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4180+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser13Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser13Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER13IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER13NAME:
        *write_method = write_SystemRadiusGroupUser13Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e41a0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser14Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser14Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER14IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER14NAME:
        *write_method = write_SystemRadiusGroupUser14Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e41c0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser15Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser15Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER15IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER15NAME:
        *write_method = write_SystemRadiusGroupUser15Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e41e0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser16Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser16Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER16IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER16NAME:
        *write_method = write_SystemRadiusGroupUser16Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4200+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser17Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser17Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER17IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER17NAME:
        *write_method = write_SystemRadiusGroupUser17Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4220+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser18Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser18Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER18IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER18NAME:
        *write_method = write_SystemRadiusGroupUser18Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4240+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser19Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser19Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER19IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER19NAME:
        *write_method = write_SystemRadiusGroupUser19Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4260+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser20Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser20Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER20IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER20NAME:
        *write_method = write_SystemRadiusGroupUser20Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4280+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser21Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser21Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER21IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER21NAME:
        *write_method = write_SystemRadiusGroupUser21Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e42a0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser22Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser22Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER22IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER22NAME:
        *write_method = write_SystemRadiusGroupUser22Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e42c0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser23Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser23Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER23IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER23NAME:
        *write_method = write_SystemRadiusGroupUser23Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e42e0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;

    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser24Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser24Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER24IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER24NAME:
        *write_method = write_SystemRadiusGroupUser24Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4300+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser25Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser25Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER25IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER25NAME:
        *write_method = write_SystemRadiusGroupUser25Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4320+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser26Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser26Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER26IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER26NAME:
        *write_method = write_SystemRadiusGroupUser26Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4340+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser27Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser27Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER27IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER27NAME:
        *write_method = write_SystemRadiusGroupUser27Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4360+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser28Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser28Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER28IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER28NAME:
        *write_method = write_SystemRadiusGroupUser28Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4380+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser29Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser29Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER29IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER29NAME:
        *write_method = write_SystemRadiusGroupUser29Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e43a0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser30Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser30Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER30IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER30NAME:
        *write_method = write_SystemRadiusGroupUser30Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e43c0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser31Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser31Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER31IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER31NAME:
        *write_method = write_SystemRadiusGroupUser31Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e43e0+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;

    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupUser32Table():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupUser32Table(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPUSER32IDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPUSER32NAME:
        *write_method = write_SystemRadiusGroupUser32Name;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4400+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;

    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupxAUthTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupxAUthTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPXAUTHIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPXAUTH:
        *write_method = write_SystemRadiusGroupxAuth;
		read_csman(fd, 0x009e4420+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupNASTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupNASTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPNASIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPNAS:
        *write_method = write_SystemRadiusGroupNAS;
		read_csman(fd, 0x009e4440+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupRadiusTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupRadiusTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPRADIUSIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPRADIUS:
        *write_method = write_SystemRadiusGroupRadius;
		read_csman(fd, 0x009e4460+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupVPNTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupVPNTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPVPNIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPVPN:
        *write_method = write_SystemRadiusGroupVPN;
		read_csman(fd, 0x009e4480+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupAccoundingTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupAccoundingTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPACCOUNDINGIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPACCOUNDING:
        *write_method = write_SystemRadiusGroupAccounding;
		read_csman(fd, 0x009e44a0+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_SystemRadiusGroupBillingTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupBillingTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPBILLINGIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPBILLING:
        *write_method = write_SystemRadiusGroupBilling;
		read_csman(fd, 0x009e44c0+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}

unsigned char *
var_SystemRadiusGroupQoSBWMPropertyTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPQOsBWMPROPERTYIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPQOsBWMPROPERTY:
        *write_method = write_SystemRadiusGroupQoSBWMProperty;
		read_csman(fd, 0x009e4620+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}

unsigned char *
var_SystemRadiusGroupQoSBWMPropertyUnitsTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPQOsBWMPROPERTYUNITSIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPQOsBWMPROPERTYUNITS:
        *write_method = write_SystemRadiusGroupQoSBWMPropertyUnits;
		read_csman(fd, 0x009e46a0+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}


unsigned char *
var_SystemRadiusGroupQoSBWMPropertyValueTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPQOsBWMPROPERTYVALUEIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPQOsBWMPROPERTYVALUE:
        *write_method = write_SystemRadiusGroupQoSBWMPropertyValue;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4640+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}

unsigned char *
var_SystemRadiusGroupPolicyRoutingPropertyTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPPOLICYROUTINGPROPERTYIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPPOLICYROUTINGPROPERTY:
        *write_method = write_SystemRadiusGroupPolicyRoutingProperty;
		memset(string,0,sizeof(string));
		read_csman(fd,0x009e4680+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}

/*
 * var_SystemRadiusGroupEnableTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_SystemUserGroup above.
 */
unsigned char *
var_SystemRadiusGroupEnableTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
	/* get index */
	register int index;
	index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_USERGROUP);
	usergroup_w_index=index;
				
	if ( index == MATCH_FAILED )
		return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case SYSTEMRADIUSGROUPENABLEIDINDEX:
		long_ret = index;
		return (unsigned int *) &long_ret;
    case SYSTEMRADIUSGROUPENABLE:
        *write_method = write_SystemRadiusGroupEnable;
		read_csman(fd, 0x009e4600+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;

    default:
      ERROR_MSG("");
    }
    return NULL;
}



int
write_SystemAddGroupAlter(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
		{
			write_csman(fd,0x809e0101,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			write_csman(fd,0x809e0100,&long_ret,sizeof(unsigned int) ,TYPE_U32);
		}                       
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1000,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser01(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1010,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser02(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1011,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser03(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1012,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser04(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1013,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser05(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1014,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser06(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1015,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser07(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1016,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser08(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1017,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser09(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1018,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser10(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1019,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser11(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e101a,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser12(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e101b,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser13(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e101c,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser14(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e101d,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser15(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e101e,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser16(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e101f,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser17(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1020,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser18(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1021,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser19(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1022,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser20(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
           {
         	write_csman(fd,0x009e1023,string,strlen(string)+1,TYPE_STR);
         }                   
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser21(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1024,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser22(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1025,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser23(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1026,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser24(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1027,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser25(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1028,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser26(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1029,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser27(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e102a,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser28(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e102b,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser29(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e102c,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser30(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e102d,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser31(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e102e,string,strlen(string)+1,TYPE_STR);
         }                    
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupUser32(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e102f,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupXAuth(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x009e1030,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}         
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupNAS(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x009e1031,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupRadius(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x009e1032,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupVPN(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x009e1033,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupAccounting(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x009e1034,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemAddGroupBilling(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x009e1035,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemAddQosBWMProperty(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x009e1036,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemAddQosBWMPropertyUnits(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x009e1039,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemAddQosBWMPropertyValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1037,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemAddPolicyRoutingProperty(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e1038,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemAddGroupEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x009e1050,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemDeleteGroupAlter(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x809e0100,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			//write_csman(fd,0x809e0102,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemDeleteGroupIndex(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			//write_csman(fd,0x809e0100,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			write_csman(fd,0x809e0102,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}



int
write_SystemModGroupAlter(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         	{
			write_csman(fd,0x809e0104,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			write_csman(fd,0x809e0100,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}                
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupNameOriginal(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3000,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3001,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser01(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3010,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser02(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3011,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser03(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3012,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser04(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3013,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser05(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3014,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser06(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3015,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser07(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3016,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser08(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3017,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser09(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3018,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser10(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e3019,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser11(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e301a,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser12(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e301b,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser13(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e301c,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser14(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e301d,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser15(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e301e,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser16(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e301f,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser17(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3020,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser18(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3021,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser19(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3022,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser20(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3023,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser21(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3024,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser22(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3025,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser23(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3026,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser24(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3027,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser25(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3028,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser26(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3029,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser27(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e302a,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser28(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e302b,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser29(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e302c,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser30(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e302d,string,strlen(string)+1,TYPE_STR);
         }                  
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser31(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e302e,string,strlen(string)+1,TYPE_STR);
         }                     
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupUser32(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e302f,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupXAuth(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e3030,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemModGroupNAS(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e3031,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}




int
write_SystemModGroupRadius(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e3032,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupVPN(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e3033,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupAccounting(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e3034,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemModGroupBilling(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
           	{
			write_csman(fd,0x009e3035,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}              
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemModGroupQosBWMProperty(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
           	{
			write_csman(fd,0x009e3036,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}              
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemModGroupQosBWMPropertyValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3037,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemModGroupQosBWMPropertyUnits(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
           	{
			write_csman(fd,0x009e3039,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}              
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemModGroupPolicyRoutingProperty(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e3038,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemModGroupEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e3050,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemRadiusGroupName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
           {
         	write_csman(fd,0x009e4000+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }              
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser01Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
           {
         	write_csman(fd,0x009e4020+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }              
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser02Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4040+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser03Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
           {
         	write_csman(fd,0x009e4060+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }              
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser04Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4080+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser05Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
           {
         	write_csman(fd,0x009e40a0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }              
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser06Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e40c0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser07Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e40e0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser08Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4100+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser09Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4120+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser10Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4140+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser11Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
    			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4160+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }              
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser12Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
   			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4180+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser13Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
   			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e41a0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser14Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
   			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e41c0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser15Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e41e0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser16Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
    			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4200+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser17Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e4220+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser18Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4240+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser19Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e4260+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser20Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
   			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e4280+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser21Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
  			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e42a0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser22Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e42c0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser23Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e42e0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser24Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e4300+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser25Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e4320+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser26Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e4340+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser27Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e4360+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser28Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e4380+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser29Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e43a0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser30Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e43c0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser31Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e43e0+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupUser32Name(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
         {
         	write_csman(fd,0x009e4400+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }                 
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupxAuth(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e4420+usergroup_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupNAS(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e4440+usergroup_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupRadius(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e4460+usergroup_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupVPN(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;


    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e4480+usergroup_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}
int
write_SystemRadiusGroupAccounding(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e44a0+usergroup_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemRadiusGroupBilling(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e44c0+usergroup_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemRadiusGroupQoSBWMProperty(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e4620+usergroup_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemRadiusGroupQoSBWMPropertyUnits(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e46a0+usergroup_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}


int
write_SystemRadiusGroupQoSBWMPropertyValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4640+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemRadiusGroupPolicyRoutingProperty(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to SystemUserGroup not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
 			//for STR/MAC data type
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          {
         	write_csman(fd,0x009e4680+usergroup_w_index-1,string,strlen(string)+1,TYPE_STR);
         }               
          break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_SystemRadiusGroupEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned long long_ret;
	int fd=0;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to SystemUserGroup not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to SystemUserGroup: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = * (unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
             /*
              * Things are working well, so it's now safe to make the change
              * permanently.  Make sure that anything done here can't fail!
              */
          	{
			write_csman(fd,0x009e4600+usergroup_w_index-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			}               
          break;
    }
    return SNMP_ERR_NOERROR;
}

