#ifdef IN_UCD_SNMP_SOURCE
#include <config.h>
#include "mibincl.h"
#include "util_funcs.h"
#else /* !IN_UCD_SNMP_SOURCE */
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>
#endif /* !IN_UCD_SNMP_SOURCE */
#include "UIAdvVPNIPSec.h"
#include "csman.h"
#include <stdio.h>
#include <string.h>

#define NUM_ADV_VPN_IPSEC		32
#define NUM_ADV_VPN_XAUTH_SERV	10
int w_index_adv_vpn_ipsec=0;
int w_index_adv_vpn_xauth_serv;

#ifdef SNMP_CUSTOMER_SMARTLINK
oid UIAdvVPNIPSec_variables_oid[] = { 1,3,6,1,4,1,36293,1,2,2,4,3,3,2 };
#else
oid UIAdvVPNIPSec_variables_oid[] = { 1,3,6,1,4,1,12823,4,4,9,3,3,2 };
#endif

struct variable7 UIAdvVPNIPSec_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

{ADVANCEIPSECALTERED,ASN_INTEGER,RWRITE,var_UIAdvVPNIPSec, 1,  { 1 }},
{ADVANCEIPSECENABLE,ASN_INTEGER,RWRITE,var_UIAdvVPNIPSec, 1,  { 2 }},
{ADVANCEIPSECNETBIOSOVERIPSECENABLE,ASN_INTEGER,RWRITE,var_UIAdvVPNIPSec, 1,  { 3 }},
{ADVANCEIPSECNATTAVERSALENABLE,ASN_INTEGER,RWRITE,var_UIAdvVPNIPSec, 1,  { 4 }},
{ADVANCEIPSECMAXTUNNELS,ASN_INTEGER,RWRITE,var_UIAdvVPNIPSec, 1,  { 5 }},
{ADVANCETUNNELCONFIGINDEX,ASN_INTEGER,RONLY,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 1 }},
{ADVANCETUNNELCONFIGTUNNELNAME,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 2 }},
{ADVANCETUNNELCONFIGINTERFACE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 3 }},
{ADVANCETUNNELCONFIGSCENARIO,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 4 }},
{ADVANCETUNNELCONFIGOPERATIONMODE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 5 }},
{ADVANCETUNNELCONFIGOPERATIONMODEFAILOVERTYPE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 6 }},
{ADVANCETUNNELCONFIGOPERATIONMODEFAILOVERTUNNEL,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 7 }},
{ADVANCETUNNELCONFIGTUNNELSCENARIOIKE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,	{ 6 , 1, 8 }},
{ADVANCETUNNELCONFIGTUNNELSCENARIOMANAUAL,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 9 }},
{ADVANCETUNNELCONFIGENCAPSULATIONPROTOCOLIKE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 10 }},
{ADVANCETUNNELCONFIGENCAPSULATIONPROTOCOLMANAUAL,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 11 }},
{ADVANCETUNNELCONFIGKEEPALIVEENABLE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 12 }},
{ADVANCETUNNELCONFIGKEEPALIVETYPE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 13 }},
{ADVANCETUNNELCONFIGKEEPALIVEIP,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 14 }},
{ADVANCETUNNELCONFIGKEEPALIVEINTERVALTIME,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 15 }},
{ADVANCETUNNELHUBSPOKEENABLE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 16 }},
{ADVANCETUNNELCONFIGLOCALSUBNET,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 17 }},
{ADVANCETUNNELCONFIGLOCALSUBNET1,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 18 }},
{ADVANCETUNNELCONFIGLOCALSUBNET2,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 19 }},
{ADVANCETUNNELCONFIGLOCALSUBNET3,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 20 }},
{ADVANCETUNNELCONFIGLOCALSUBNET4,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 21 }},
{ADVANCETUNNELCONFIGLOACLNETMASK,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 22 }},
{ADVANCETUNNELCONFIGLOACLNETMASK1,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 23 }},
{ADVANCETUNNELCONFIGLOACLNETMASK2,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 24 }},
{ADVANCETUNNELCONFIGLOACLNETMASK3,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 25 }},
{ADVANCETUNNELCONFIGLOACLNETMASK4,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 26 }},
{ADVANCETUNNELCONFIGFULLTUNNELENABLE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 27 }},
{ADVANCETUNNELCONFIGIKEREMOTESUBNET,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 28 }},
{ADVANCETUNNELCONFIGIKEREMOTESUBNET1,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 29 }},
{ADVANCETUNNELCONFIGIKEREMOTESUBNET2,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 30 }},
{ADVANCETUNNELCONFIGIKEREMOTESUBNET3,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 31 }},
{ADVANCETUNNELCONFIGIKEREMOTESUBNET4,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 32 }},
{ADVANCETUNNELCONFIGIKEREMOTENETMASK,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 33 }},
{ADVANCETUNNELCONFIGIKEREMOTENETMASK1,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 34 }},
{ADVANCETUNNELCONFIGIKEREMOTENETMASK2,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 35 }},
{ADVANCETUNNELCONFIGIKEREMOTENETMASK3,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 36 }},
{ADVANCETUNNELCONFIGIKEREMOTENETMASK4,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 37 }},
{ADVANCETUNNELCONFIGIKEGATEWAY,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 38 }},
{ADVANCETUNNELCONFIGMANUALLYREMOTESUBNET,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 39 }},
{ADVANCETUNNELCONFIGMANUALLYREMOTENETMASK,ASN_IPADDRESS,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 40 }},
{ADVANCETUNNELCONFIGMANUALLYREMOTEGATEWAY,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 41 }},
{ADVANCETUNNELCONFIGKEYMANAGEMENTTYPE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 42 }},
{ADVANCETUNNELCONFIGKEYMANAGEMENTIKEPRESHAREKEY,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 43 }},
{ADVANCETUNNELCONFIGLOCALIDIKETYPE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 44 }},
{ADVANCETUNNELCONFIGLOACLIDIKEVALUE,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 45 }},
{ADVANCETUNNELCONFIGLOCALIDMANUALLYTYPE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 46 }},
{ADVANCETUNNELCONFIGLOCALIDMANUALLYVALUE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 47 }},
{ADVANCETUNNELCONFIGREMOTEIDIKETYPE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 48 }},
{ADVANCETUNNELCONFIGREMOTEIDIKEVALUE,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 49 }},
{ADVANCETUNNELCONFIGREMOTEIDMANUALLYTYPE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 50 }},
{ADVANCETUNNELCONFIGREMOTEIDMANUALLYVALUE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 51 }},
{ADVANCETUNNELCONFIGIKENEGOTIATIONMODE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 52 }},
{ADVANCETUNNELCONFIGIKEXAUTHTYPE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 53 }},
{ADVANCETUNNELCONFIGIKEXAUTHCLIENTUSERNAME,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 54 }},
{ADVANCETUNNELCONFIGIKEXAUTHCLIENTPASSWORD,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 55 }},
{ADVANCETUNNELCONFIGIKEDPDENABLE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 56 }},
{ADVANCETUNNELCONFIGIKEDPDTIMEOUT,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 57 }},
{ADVANCETUNNELCONFIGIKEDPDDELAY,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 58 }},
{ADVANCETUNNELCONFIGIKEPHASE1KEYLIFETIME,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 59 }},
{ADVANCETUNNELCONFIGIPSECPHASE2KEYLIFETIME,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 60 }},
{ADVANCETUNNELCONFIGIKEPROPOENABLE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 61 }},
{ADVANCETUNNELCONFIGIKEPROPOENCRYPTION1,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 62 }},
{ADVANCETUNNELCONFIGIKEPROPOAUTH1,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 63 }},
{ADVANCETUNNELCONFIGIKEPROPODHGROUP1,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 64 }},
{ADVANCETUNNELCONFIGIKEPROPODEFENABLE1,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 65 }},
{ADVANCETUNNELCONFIGIKEPROPOENCRYPTION2,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 66 }},
{ADVANCETUNNELCONFIGIKEPROPOAUTH2,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 67 }},
{ADVANCETUNNELCONFIGIKEPROPODHGROUP2,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 68 }},
{ADVANCETUNNELCONFIGIKEPROPODEFENABLE2,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 69 }},
{ADVANCETUNNELCONFIGIKEPROPOENCRYPTION3,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 70 }},
{ADVANCETUNNELCONFIGIKEPROPOAUTH3,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 71 }},
{ADVANCETUNNELCONFIGIKEPROPODHGROUP3,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 72 }},
{ADVANCETUNNELCONFIGIKEPROPODEFENABLE3,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 73 }},
{ADVANCETUNNELCONFIGIKEPROPOENCRYPTION4,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 74 }},
{ADVANCETUNNELCONFIGIKEPROPOAUTH4,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 75 }},
{ADVANCETUNNELCONFIGIKEPROPODHGROUP4,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 76 }},
{ADVANCETUNNELCONFIGIKEPROPODEFENABLE4,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 77 }},
{ADVANCETUNNELCONFIGIPSECPROPOENABLE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 78 }},
{ADVANCETUNNELCONFIGIPSECPROPOPFSGROUP,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 79 }},
{ADVANCETUNNELCONFIGIPSECPROPOENCRYPTION1,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 80 }},
{ADVANCETUNNELCONFIGIPSECPROPOAUTH1,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 81 }},
{ADVANCETUNNELCONFIGIPSECPROPODEFENABLE1,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 82 }},
{ADVANCETUNNELCONFIGIPSECPROPOENCRYPTION2,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 83 }},
{ADVANCETUNNELCONFIGIPSECPROPOAUTH2,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 84 }},
{ADVANCETUNNELCONFIGIPSECPROPODEFENABLE2,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 85 }},
{ADVANCETUNNELCONFIGIPSECPROPOENCRYPTION3,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 86 }},
{ADVANCETUNNELCONFIGIPSECPROPOAUTH3,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 87 }},
{ADVANCETUNNELCONFIGIPSECPROPODEFENABLE3,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 88 }},
{ADVANCETUNNELCONFIGIPSECPROPOENCRYPTION4,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 89 }},
{ADVANCETUNNELCONFIGIPSECPROPOAUTH4,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 90 }},
{ADVANCETUNNELCONFIGIPSECPROPODEFENABLE4,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 91 }},
{ADVANCETUNNELCONFIGMANUALPROPOOUTBOUNDSPI,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 92 }},
{ADVANCETUNNELCONFIGMANUALPROPOINBOUNDSPI,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 93 }},
{ADVANCETUNNELCONFIGMANUALPROPOENCRYPTIONTYPE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 94 }},
{ADVANCETUNNELCONFIGMANUALPROPOENCRYPTIONKEY1,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 95 }},
{ADVANCETUNNELCONFIGMANUALPROPOENCRYPTIONKEY2,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 96 }},
{ADVANCETUNNELCONFIGMANUALPROPOENCRYPTIONKEY3,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 97 }},
{ADVANCETUNNELCONFIGMANUALPROPOAUTHTYPE,ASN_INTEGER,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 98 }},
{ADVANCETUNNELCONFIGMANUALPROPOAUTHVALUE,ASN_OCTET_STR,RWRITE,var_AdvanceIPSecTunnelTable, 3,  { 6 , 1, 99 }},
//Xauth server list
{ADVANCETUNNELCONFIGIKEXAUTHSERVERINDEX,ASN_INTEGER,RONLY,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 1 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP1,ASN_INTEGER,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 2 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME1,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 3 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD1,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 4 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP2,ASN_INTEGER,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 5 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME2,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 6 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD2,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 7 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP3,ASN_INTEGER,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 8 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME3,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 9 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD3,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 10 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP4,ASN_INTEGER,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 11 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME4,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 12 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD4,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 13 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP5,ASN_INTEGER,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 14 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME6,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 15 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD6,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 16 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP7,ASN_INTEGER,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 17 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME7,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 18 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD7,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 19 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP8,ASN_INTEGER,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 20 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME8,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 21 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD8,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 22 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP9,ASN_INTEGER,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 23 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME9,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 24 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD9,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 25 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP10,ASN_INTEGER,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 26 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME10,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 27 }},
{ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD10,ASN_OCTET_STR,RWRITE,var_AdvanceTunnelConfigIKEXauthServerTable, 3,  { 8 , 1, 28 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the UIAdvVPNIPSec module */
void
init_UIAdvVPNIPSec(void)
{
    DEBUGMSGTL(("UIAdvVPNIPSec", "Initializing\n"));
    REGISTER_MIB("UIAdvVPNIPSec", UIAdvVPNIPSec_variables, variable7,
               UIAdvVPNIPSec_variables_oid);
}

static int
header_Entry(struct variable *vp,
               oid *name,
               size_t *length,
               int exact,
               size_t *var_len,
               WriteMethod **write_method, int count)
{
	#ifdef SNMP_CUSTOMER_SMARTLINK
	#define IFENTRY_NAME_LENGTH     17
	#else
	#define IFENTRY_NAME_LENGTH     16
	#endif
	/* in this case, oid len is 17*/
    	oid newname[MAX_OID_LEN];
    	register int        interface;
    	int result;

    	memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    	for(interface = 1; interface <= count; interface++){
        	newname[IFENTRY_NAME_LENGTH] = (oid)interface;
        	result = snmp_oid_compare(name, *length, newname, vp->namelen + 1);
        	if ((exact && (result == 0)) || (!exact && (result < 0)))
            	break;
    	}
    	if (interface > count) {
        	DEBUGMSGTL(("mibII/interfaces", "... index out of range\n"));
        	return MATCH_FAILED;
    	}

    	memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    	*length = vp->namelen + 1;
    	*write_method = 0;
    	*var_len = sizeof(long); 
    return interface; /* interface is "index" */
}


unsigned char *
var_UIAdvVPNIPSec(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
	
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVANCEIPSECALTERED:
        *write_method = write_AdvanceIPSecAltered;
        read_csman(fd,0x80700002,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSECENABLE:
        *write_method = write_AdvanceIPSecEnable;
        read_csman(fd,0x0070000F,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSECNETBIOSOVERIPSECENABLE:
        *write_method = write_AdvanceIPSecNetBIOSoverIPSecEnable;
        read_csman(fd,0x00700050,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSECNATTAVERSALENABLE:
        *write_method = write_AdvanceIPSecNATTaversalEnable;
        read_csman(fd,0x00700070,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCEIPSECMAXTUNNELS:
        *write_method = write_AdvanceIPSecMaxTunnels;
        read_csman(fd,0x00700040,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    default:
      ERROR_MSG("");
    }
    return NULL;
}


/*
 * var_AdvanceIPSecTunnelTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_UIAdvVPNIPSec above.
 */
unsigned char *
var_AdvanceIPSecTunnelTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
     /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_ADV_VPN_IPSEC);
    w_index_adv_vpn_ipsec=index;

    if ( index == MATCH_FAILED )
        return NULL;


    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVANCETUNNELCONFIGINDEX:
        long_ret = index;
		return (unsigned int *) &long_ret;
    case ADVANCETUNNELCONFIGTUNNELNAME:
        *write_method = write_AdvanceTunnelConfigTunnelName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700100+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGINTERFACE:
        *write_method = write_AdvanceTunnelConfigInterface;
        read_csman(fd,0x00701000+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGSCENARIO:
        *write_method = write_AdvanceTunnelConfigScenario;
        read_csman(fd,0x0020101d+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;		
    case ADVANCETUNNELCONFIGOPERATIONMODE:
        *write_method = write_AdvanceTunnelConfigOperationMode;
        read_csman(fd,0x00709E00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGOPERATIONMODEFAILOVERTYPE:
        *write_method = write_AdvanceTunnelConfigOperationModeFailoverType;
        read_csman(fd,0x0070A200+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGOPERATIONMODEFAILOVERTUNNEL:
        *write_method = write_AdvanceTunnelConfigOperationModeFailoverTunnel;
        read_csman(fd,0x0070A100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGTUNNELSCENARIOIKE:
        *write_method = write_AdvanceTunnelConfigTunnelScenarioIKE;
        read_csman(fd,0x00704A00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGTUNNELSCENARIOMANAUAL:
        *write_method = write_AdvanceTunnelConfigTunnelScenarioManaual;
        read_csman(fd,0x00703200+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGENCAPSULATIONPROTOCOLIKE:
        *write_method = write_AdvanceTunnelConfigEncapsulationProtocolIKE;
        read_csman(fd,0x00705100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGENCAPSULATIONPROTOCOLMANAUAL:
        *write_method = write_AdvanceTunnelConfigEncapsulationProtocolManaual;
        read_csman(fd,0x00704900+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGKEEPALIVEENABLE:
        *write_method = write_AdvanceTunnelConfigKeepAliveEnable;
        read_csman(fd,0x00705900+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGKEEPALIVETYPE:
        *write_method = write_AdvanceTunnelConfigKeepAliveType;
        long_ret = 0;
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGKEEPALIVEIP:
        *write_method = write_AdvanceTunnelConfigKeepAliveIP;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00705A00+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGKEEPALIVEINTERVALTIME:
        *write_method = write_AdvanceTunnelConfigKeepAliveIntervalTIme;
        read_csman(fd,0x00705B00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELHUBSPOKEENABLE:
        *write_method = write_AdvanceTunnelHubSpokeEnable;
        read_csman(fd,0x0070A300+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGLOCALSUBNET:
        *write_method = write_AdvanceTunnelConfigLocalSubnet;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700400+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGLOCALSUBNET1:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigLocalSubnet1;
        memset(string,0,sizeof(string));
		index_counter = (index-1)*10;
		read_csman(fd,0x0070A400+index_counter,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    }return (unsigned char *) string;
    case ADVANCETUNNELCONFIGLOCALSUBNET2:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigLocalSubnet2;
        memset(string,0,sizeof(string));
		index_counter = (index-1)*10;
		read_csman(fd,0x0070A400+index_counter+1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGLOCALSUBNET3:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigLocalSubnet3;
        memset(string,0,sizeof(string));
		index_counter = (index-1)*10;
		read_csman(fd,0x0070A400+index_counter+2,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGLOCALSUBNET4:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigLocalSubnet4;
        memset(string,0,sizeof(string));
		index_counter = (index-1)*10;
		read_csman(fd,0x0070A400+index_counter+3,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGLOACLNETMASK:
        *write_method = write_AdvanceTunnelConfigLoaclNetmask;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700500+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGLOACLNETMASK1:
	{	
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigLoaclNetmask1;
		index_counter = (index-1) * 10;
        read_csman(fd,0x0070A600+index_counter,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGLOACLNETMASK2:
	{	
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigLoaclNetmask2;
		index_counter = (index-1) * 10;
        read_csman(fd,0x0070A600+index_counter+1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGLOACLNETMASK3:
	{	
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigLoaclNetmask3;
		index_counter = (index-1) * 10;
        read_csman(fd,0x0070A600+index_counter+2,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGLOACLNETMASK4:
	{	
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigLoaclNetmask4;
		index_counter = (index-1) * 10;
        read_csman(fd,0x0070A600+index_counter+3,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGFULLTUNNELENABLE:
        *write_method = write_AdvanceTunnelConfigFullTunnelEnable;
        read_csman(fd,0x00709F00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEREMOTESUBNET:
        *write_method = write_AdvanceTunnelConfigIKERemoteSubnet;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700600+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGIKEREMOTESUBNET1:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigIKERemoteSubnet1;
        memset(string,0,sizeof(string));
		index_counter = (index-1) * 10;
		read_csman(fd,0x0070A800+index_counter,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEREMOTESUBNET2:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigIKERemoteSubnet2;
        memset(string,0,sizeof(string));
		index_counter = (index-1) * 10;
		read_csman(fd,0x0070A800+index_counter+1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEREMOTESUBNET3:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigIKERemoteSubnet3;
        memset(string,0,sizeof(string));
		index_counter = (index-1) * 10;
		read_csman(fd,0x0070A800+index_counter+2,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEREMOTESUBNET4:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigIKERemoteSubnet4;
        memset(string,0,sizeof(string));
		index_counter = (index-1) * 10;
		read_csman(fd,0x0070A800+index_counter+3,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEREMOTENETMASK:
        *write_method = write_AdvanceTunnelConfigIKERemoteNetmask;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700700+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGIKEREMOTENETMASK1:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigIKERemoteNetmask1;
		index_counter = (index-1) * 10;
		read_csman(fd,0x0070AA00+index_counter,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEREMOTENETMASK2:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigIKERemoteNetmask2;
		index_counter = (index-1) * 10;
       	read_csman(fd,0x0070AA00+index_counter+1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEREMOTENETMASK3:
	{	
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigIKERemoteNetmask3;
		index_counter = (index-1) * 10;
		read_csman(fd,0x0070AA00+index_counter+2,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEREMOTENETMASK4:
	{
		int index_counter=0;
        *write_method = write_AdvanceTunnelConfigIKERemoteNetmask4;
		index_counter = (index-1) * 10;
		read_csman(fd,0x0070AA00+index_counter+3,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEGATEWAY:
        *write_method = write_AdvanceTunnelConfigIKEGateway;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700800+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGMANUALLYREMOTESUBNET:
        *write_method = write_AdvanceTunnelConfigManuallyRemoteSubnet;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700900+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGMANUALLYREMOTENETMASK:
        *write_method = write_AdvanceTunnelConfigManuallyRemoteNetmask;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700C00+index-1,string,sizeof(string),TYPE_IPV4);
		*var_len = 4; //IP address length = 4
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGMANUALLYREMOTEGATEWAY:
        *write_method = write_AdvanceTunnelConfigManuallyRemoteGateway;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00700D00+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGKEYMANAGEMENTTYPE:
        *write_method = write_AdvanceTunnelConfigKeyManagementType;
        read_csman(fd,0x00700300+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGKEYMANAGEMENTIKEPRESHAREKEY:
        *write_method = write_AdvanceTunnelConfigKeyManagementIKEPresharekey;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00705300+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGLOCALIDIKETYPE:
        *write_method = write_AdvanceTunnelConfigLocalIDIKEType;
        read_csman(fd,0x00705700+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGLOACLIDIKEVALUE:
        *write_method = write_AdvanceTunnelConfigLoaclIDIKEValue;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00705800+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGLOCALIDMANUALLYTYPE:
        *write_method = write_AdvanceTunnelConfigLocalIDManuallyType;
        long_ret=0;
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGLOCALIDMANUALLYVALUE:
        *write_method = write_AdvanceTunnelConfigLocalIDManuallyValue;
        read_csman(fd,0x0070AD00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGREMOTEIDIKETYPE:
        *write_method = write_AdvanceTunnelConfigRemoteIDIKEType;
        read_csman(fd,0x00705600+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGREMOTEIDIKEVALUE:
        *write_method = write_AdvanceTunnelConfigRemoteIDIKEValue;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00705500+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGREMOTEIDMANUALLYTYPE:
        *write_method = write_AdvanceTunnelConfigRemoteIDManuallyType;
        long_ret=0;
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGREMOTEIDMANUALLYVALUE:
        *write_method = write_AdvanceTunnelConfigRemoteIDManuallyValue;
        read_csman(fd,0x0070AC00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKENEGOTIATIONMODE:
        *write_method = write_AdvanceTunnelConfigIKENegotiationMode;
        read_csman(fd,0x00705200+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEXAUTHTYPE:
        *write_method = write_AdvanceTunnelConfigIKEXauthType;
        read_csman(fd,0x00705C00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEXAUTHCLIENTUSERNAME:
        *write_method = write_AdvanceTunnelConfigIKEXauthClientUserName;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00705D00+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGIKEXAUTHCLIENTPASSWORD:
        *write_method = write_AdvanceTunnelConfigIKEXauthClientPassword;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00705E00+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGIKEDPDENABLE:
        *write_method = write_AdvanceTunnelConfigIKEDPDEnable;
        read_csman(fd,0x00704D00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEDPDTIMEOUT:
        *write_method = write_AdvanceTunnelConfigIKEDPDTimeout;
        read_csman(fd,0x00705000+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEDPDDELAY:
        *write_method = write_AdvanceTunnelConfigIKEDPDDelay;
        read_csman(fd,0x00704F00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPHASE1KEYLIFETIME:
        *write_method = write_AdvanceTunnelConfigIKEPhase1KeyLifeTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00706000+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGIPSECPHASE2KEYLIFETIME:
        *write_method = write_AdvanceTunnelConfigIPSecPhase2KeyLifeTime;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00707300+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGIKEPROPOENABLE:
        *write_method = write_AdvanceTunnelConfigIKEPropoEnable;
        read_csman(fd,0x00706200+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPOENCRYPTION1:
        *write_method = write_AdvanceTunnelConfigIKEPropoEncryption1;
        read_csman(fd,0x00706400+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPOAUTH1:
        *write_method = write_AdvanceTunnelConfigIKEPropoAuth1;
        read_csman(fd,0x00706500+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPODHGROUP1:
        *write_method = write_AdvanceTunnelConfigIKEPropoDHGroup1;
        read_csman(fd,0x00706600+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPODEFENABLE1:
        *write_method = write_AdvanceTunnelConfigIKEPropoDefEnable1;
        read_csman(fd,0x00706300+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPOENCRYPTION2:
        *write_method = write_AdvanceTunnelConfigIKEPropoEncryption2;
        read_csman(fd,0x00706800+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPOAUTH2:
        *write_method = write_AdvanceTunnelConfigIKEPropoAuth2;
        read_csman(fd,0x00706900+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPODHGROUP2:
        *write_method = write_AdvanceTunnelConfigIKEPropoDHGroup2;
        read_csman(fd,0x00706A00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPODEFENABLE2:
        *write_method = write_AdvanceTunnelConfigIKEPropoDefEnable2;
        read_csman(fd,0x00706700+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPOENCRYPTION3:
        *write_method = write_AdvanceTunnelConfigIKEPropoEncryption3;
        read_csman(fd,0x00706C00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPOAUTH3:
        *write_method = write_AdvanceTunnelConfigIKEPropoAuth3;
        read_csman(fd,0x00706D00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPODHGROUP3:
        *write_method = write_AdvanceTunnelConfigIKEPropoDHGroup3;
        read_csman(fd,0x00706E00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPODEFENABLE3:
        *write_method = write_AdvanceTunnelConfigIKEPropoDefEnable3;
        read_csman(fd,0x00706B00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPOENCRYPTION4:
        *write_method = write_AdvanceTunnelConfigIKEPropoEncryption4;
        read_csman(fd,0x00707000+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPOAUTH4:
        *write_method = write_AdvanceTunnelConfigIKEPropoAuth4;
        read_csman(fd,0x00707100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPODHGROUP4:
        *write_method = write_AdvanceTunnelConfigIKEPropoDHGroup4;
        read_csman(fd,0x00707200+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIKEPROPODEFENABLE4:
        *write_method = write_AdvanceTunnelConfigIKEPropoDefEnable4;
        read_csman(fd,0x00706F00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPOENABLE:
        *write_method = write_AdvanceTunnelConfigIPSecPropoEnable;
        read_csman(fd,0x00707500+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPOPFSGROUP:
        *write_method = write_AdvanceTunnelConfigIPSecPropoPFSGroup;
        read_csman(fd,0x00705400+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPOENCRYPTION1:
        *write_method = write_AdvanceTunnelConfigIPSecPropoEncryption1;
        read_csman(fd,0x00707700+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPOAUTH1:
        *write_method = write_AdvanceTunnelConfigIPSecPropoAuth1;
        read_csman(fd,0x00707800+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPODEFENABLE1:
        *write_method = write_AdvanceTunnelConfigIPSecPropoDefEnable1;
        read_csman(fd,0x00707600+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPOENCRYPTION2:
        *write_method = write_AdvanceTunnelConfigIPSecPropoEncryption2;
        read_csman(fd,0x00707A00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPOAUTH2:
        *write_method = write_AdvanceTunnelConfigIPSecPropoAuth2;
        read_csman(fd,0x00707B00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPODEFENABLE2:
        *write_method = write_AdvanceTunnelConfigIPSecPropoDefEnable2;
        read_csman(fd,0x00707900+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPOENCRYPTION3:
        *write_method = write_AdvanceTunnelConfigIPSecPropoEncryption3;
        read_csman(fd,0x00707D00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPOAUTH3:
        *write_method = write_AdvanceTunnelConfigIPSecPropoAuth3;
        read_csman(fd,0x00707E00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPODEFENABLE3:
        *write_method = write_AdvanceTunnelConfigIPSecPropoDefEnable3;
        read_csman(fd,0x00707C00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPOENCRYPTION4:
        *write_method = write_AdvanceTunnelConfigIPSecPropoEncryption4;
        read_csman(fd,0x00708000+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPOAUTH4:
        *write_method = write_AdvanceTunnelConfigIPSecPropoAuth4;
        read_csman(fd,0x00708100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGIPSECPROPODEFENABLE4:
        *write_method = write_AdvanceTunnelConfigIPSecPropoDefEnable4;
        read_csman(fd,0x00707F00+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGMANUALPROPOOUTBOUNDSPI:
        *write_method = write_AdvanceTunnelConfigManualPropoOutboundSPI;
       memset(string,0,sizeof(string));
		read_csman(fd,0x00704200+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGMANUALPROPOINBOUNDSPI:
        *write_method = write_AdvanceTunnelConfigManualPropoInboundSPI;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00704100+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGMANUALPROPOENCRYPTIONTYPE:
        *write_method = write_AdvanceTunnelConfigManualPropoEncryptionType;
        read_csman(fd,0x00704300+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGMANUALPROPOENCRYPTIONKEY1:
        *write_method = write_AdvanceTunnelConfigManualPropoEncryptionKey1;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00704400+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGMANUALPROPOENCRYPTIONKEY2:
        *write_method = write_AdvanceTunnelConfigManualPropoEncryptionKey2;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00704500+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGMANUALPROPOENCRYPTIONKEY3:
        *write_method = write_AdvanceTunnelConfigManualPropoEncryptionKey3;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00704600+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    case ADVANCETUNNELCONFIGMANUALPROPOAUTHTYPE:
        *write_method = write_AdvanceTunnelConfigManualPropoAuthType;
        read_csman(fd,0x00704700+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    case ADVANCETUNNELCONFIGMANUALPROPOAUTHVALUE:
        *write_method = write_AdvanceTunnelConfigManualPropoAuthValue;
        memset(string,0,sizeof(string));
		read_csman(fd,0x00704800+index-1,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    default:
      ERROR_MSG("");
    }
    return NULL;
}
/*
 * var_AdvanceTunnelConfigIKEXauthServerTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_UIAdvVPNIPSec above.
 */
unsigned char *
var_AdvanceTunnelConfigIKEXauthServerTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static u_long ulong_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    static struct counter64 c64;
	int fd=0;
    /* get index */
    register int index;
    index = header_Entry(vp, name, length, exact, var_len, write_method,NUM_ADV_VPN_XAUTH_SERV);
    w_index_adv_vpn_xauth_serv=index;

    if ( index == MATCH_FAILED )
        return NULL;

    /* 
   * this is where we do the value assignments for the mib results.
   */
    switch(vp->magic) {
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERINDEX:
        long_ret = index;
		return (unsigned int *) &long_ret;
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP1:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerGroup1;
		if(index == 1)			read_csman(fd,0x00701100,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 2)		read_csman(fd,0x00701200,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 3)		read_csman(fd,0x00701300,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 4)		read_csman(fd,0x00701400,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 5)		read_csman(fd,0x00701500,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 6)		read_csman(fd,0x00701600,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 7)		read_csman(fd,0x00701700,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 8)		read_csman(fd,0x00701800,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 9)		read_csman(fd,0x00701900,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 10)	read_csman(fd,0x00701a00,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME1:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerUsername1;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00702000,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00702010,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00702020,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00702030,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00702040,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00702050,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00702060,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00702070,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00702080,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00702090,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD1:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerPassword1;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00703000,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00703010,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00703020,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00703030,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00703040,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00703050,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00703060,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00703070,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00703080,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00703090,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP2:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerGroup2;
		if(index == 1)			read_csman(fd,0x00701101,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 2)		read_csman(fd,0x00701201,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 3)		read_csman(fd,0x00701301,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 4)		read_csman(fd,0x00701401,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 5)		read_csman(fd,0x00701501,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 6)		read_csman(fd,0x00701601,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 7)		read_csman(fd,0x00701701,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 8)		read_csman(fd,0x00701801,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 9)		read_csman(fd,0x00701901,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 10)	read_csman(fd,0x00701a01,&long_ret,sizeof(unsigned int),TYPE_U32);
        read_csman(fd,0x00701100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME2:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerUsername2;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00702001,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00702011,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00702021,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00702031,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00702041,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00702051,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00702061,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00702071,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00702081,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00702091,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD2:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerPassword2;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00703001,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00703011,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00703021,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00703031,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00703041,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00703051,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00703061,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00703071,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00703081,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00703091,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP3:
	{
		if(index == 1)			read_csman(fd,0x00701102,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 2)		read_csman(fd,0x00701202,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 3)		read_csman(fd,0x00701302,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 4)		read_csman(fd,0x00701402,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 5)		read_csman(fd,0x00701502,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 6)		read_csman(fd,0x00701602,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 7)		read_csman(fd,0x00701702,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 8)		read_csman(fd,0x00701802,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 9)		read_csman(fd,0x00701902,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 10)	read_csman(fd,0x00701a02,&long_ret,sizeof(unsigned int),TYPE_U32);
        *write_method = write_AdvanceTunnelConfigIKEXauthServerGroup3;
        read_csman(fd,0x00701100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME3:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerUsername3;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00702002,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00702012,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00702022,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00702032,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00702042,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00702052,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00702062,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00702072,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00702082,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00702092,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD3:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerPassword3;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00703002,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00703012,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00703022,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00703032,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00703042,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00703052,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00703062,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00703072,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00703082,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00703092,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP4:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerGroup4;
		if(index == 1)			read_csman(fd,0x00701103,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 2)		read_csman(fd,0x00701203,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 3)		read_csman(fd,0x00701303,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 4)		read_csman(fd,0x00701403,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 5)		read_csman(fd,0x00701503,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 6)		read_csman(fd,0x00701603,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 7)		read_csman(fd,0x00701703,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 8)		read_csman(fd,0x00701803,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 9)		read_csman(fd,0x00701903,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 10)	read_csman(fd,0x00701a03,&long_ret,sizeof(unsigned int),TYPE_U32);
        read_csman(fd,0x00701100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME4:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerUsername4;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00702003,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00702013,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00702023,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00702033,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00702043,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00702053,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00702063,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00702073,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00702083,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00702093,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD4:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerPassword4;
        if(index == 1)			read_csman(fd,0x00703003,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00703013,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00703023,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00703033,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00703043,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00703053,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00703063,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00703073,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00703083,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00703093,string,sizeof(string),TYPE_STR);
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP5:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerGroup5;
		if(index == 1)			read_csman(fd,0x00701104,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 2)		read_csman(fd,0x00701204,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 3)		read_csman(fd,0x00701304,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 4)		read_csman(fd,0x00701404,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 5)		read_csman(fd,0x00701504,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 6)		read_csman(fd,0x00701604,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 7)		read_csman(fd,0x00701704,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 8)		read_csman(fd,0x00701804,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 9)		read_csman(fd,0x00701904,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 10)	read_csman(fd,0x00701a04,&long_ret,sizeof(unsigned int),TYPE_U32);
        read_csman(fd,0x00701100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME5:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerUsername5;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00702004,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00702014,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00702024,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00702034,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00702044,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00702054,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00702064,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00702074,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00702084,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00702094,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD5:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerPassword5;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00703004,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00703014,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00703024,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00703034,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00703044,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00703054,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00703064,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00703074,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00703084,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00703094,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP6:
	{
		if(index == 1)			read_csman(fd,0x00701105,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 2)		read_csman(fd,0x00701205,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 3)		read_csman(fd,0x00701305,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 4)		read_csman(fd,0x00701405,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 5)		read_csman(fd,0x00701505,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 6)		read_csman(fd,0x00701605,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 7)		read_csman(fd,0x00701705,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 8)		read_csman(fd,0x00701805,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 9)		read_csman(fd,0x00701905,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 10)	read_csman(fd,0x00701a05,&long_ret,sizeof(unsigned int),TYPE_U32);
        *write_method = write_AdvanceTunnelConfigIKEXauthServerGroup6;
        read_csman(fd,0x00701100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME6:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerUsername6;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00702005,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00702015,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00702025,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00702035,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00702045,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00702055,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00702065,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00702075,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00702085,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00702095,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD6:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerPassword6;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00703005,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00703015,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00703025,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00703035,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00703045,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00703055,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00703065,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00703075,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00703085,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00703095,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
	case ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP7:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerGroup7;
		if(index == 1)			read_csman(fd,0x00701106,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 2)		read_csman(fd,0x00701206,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 3)		read_csman(fd,0x00701306,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 4)		read_csman(fd,0x00701406,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 5)		read_csman(fd,0x00701506,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 6)		read_csman(fd,0x00701606,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 7)		read_csman(fd,0x00701706,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 8)		read_csman(fd,0x00701806,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 9)		read_csman(fd,0x00701906,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 10)	read_csman(fd,0x00701a06,&long_ret,sizeof(unsigned int),TYPE_U32);
        read_csman(fd,0x00701100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
	}
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME7:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerUsername7;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00702006,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00702016,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00702026,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00702036,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00702046,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00702056,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00702066,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00702076,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00702086,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00702096,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD7:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerPassword7;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00703006,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00703016,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00703026,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00703036,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00703046,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00703056,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00703066,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00703076,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00703086,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00703096,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP8:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerGroup8;
		if(index == 1)			read_csman(fd,0x00701107,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 2)		read_csman(fd,0x00701207,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 3)		read_csman(fd,0x00701307,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 4)		read_csman(fd,0x00701407,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 5)		read_csman(fd,0x00701507,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 6)		read_csman(fd,0x00701607,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 7)		read_csman(fd,0x00701707,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 8)		read_csman(fd,0x00701807,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 9)		read_csman(fd,0x00701907,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 10)	read_csman(fd,0x00701a07,&long_ret,sizeof(unsigned int),TYPE_U32);
        read_csman(fd,0x00701100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME8:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerUsername8;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00702007,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00702017,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00702027,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00702037,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00702047,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00702057,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00702067,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00702077,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00702087,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00702097,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD8:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerPassword8;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00703007,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00703017,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00703027,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00703037,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00703047,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00703057,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00703067,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00703077,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00703087,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00703097,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP9:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerGroup9;
		if(index == 1)			read_csman(fd,0x00701108,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 2)		read_csman(fd,0x00701208,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 3)		read_csman(fd,0x00701308,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 4)		read_csman(fd,0x00701408,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 5)		read_csman(fd,0x00701508,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 6)		read_csman(fd,0x00701608,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 7)		read_csman(fd,0x00701708,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 8)		read_csman(fd,0x00701808,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 9)		read_csman(fd,0x00701908,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 10)	read_csman(fd,0x00701a08,&long_ret,sizeof(unsigned int),TYPE_U32);
        read_csman(fd,0x00701100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME9:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerUsername9;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00702008,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00702018,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00702028,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00702038,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00702048,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00702058,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00702068,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00702078,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00702088,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00702098,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD9:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerPassword9;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00703008,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00703018,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00703028,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00703038,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00703048,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00703058,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00703068,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00703078,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00703088,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00703098,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERGROUP10:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerGroup10;
		if(index == 1)			read_csman(fd,0x00701109,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 2)		read_csman(fd,0x00701209,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 3)		read_csman(fd,0x00701309,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 4)		read_csman(fd,0x00701409,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 5)		read_csman(fd,0x00701509,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 6)		read_csman(fd,0x00701609,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 7)		read_csman(fd,0x00701709,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 8)		read_csman(fd,0x00701809,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 9)		read_csman(fd,0x00701909,&long_ret,sizeof(unsigned int),TYPE_U32);
		else if(index == 10)	read_csman(fd,0x00701a09,&long_ret,sizeof(unsigned int),TYPE_U32);
        read_csman(fd,0x00701100+index-1,&long_ret,sizeof(unsigned int),TYPE_U32);
		return (unsigned char *) &long_ret;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERUSERNAME10:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerUsername10;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00702009,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00702019,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00702029,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00702039,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00702049,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00702059,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00702069,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00702079,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00702089,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00702099,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    case ADVANCETUNNELCONFIGIKEXAUTHSERVERPASSWORD10:
	{
        *write_method = write_AdvanceTunnelConfigIKEXauthServerPassword10;
        memset(string,0,sizeof(string));
		if(index == 1)			read_csman(fd,0x00703009,string,sizeof(string),TYPE_STR);
		else if(index == 2)		read_csman(fd,0x00703019,string,sizeof(string),TYPE_STR);
		else if(index == 3)		read_csman(fd,0x00703029,string,sizeof(string),TYPE_STR);
		else if(index == 4)		read_csman(fd,0x00703039,string,sizeof(string),TYPE_STR);
		else if(index == 5)		read_csman(fd,0x00703049,string,sizeof(string),TYPE_STR);
		else if(index == 6)		read_csman(fd,0x00703059,string,sizeof(string),TYPE_STR);
		else if(index == 7)		read_csman(fd,0x00703069,string,sizeof(string),TYPE_STR);
		else if(index == 8)		read_csman(fd,0x00703079,string,sizeof(string),TYPE_STR);
		else if(index == 9)		read_csman(fd,0x00703089,string,sizeof(string),TYPE_STR);
		else if(index == 10)	read_csman(fd,0x00703099,string,sizeof(string),TYPE_STR);
		*var_len = strlen(string)-1;
		return (unsigned char *) string;
    }
    default:
      ERROR_MSG("");
    }
    return NULL;
}



int
write_AdvanceIPSecAltered(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x80700002,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvanceIPSecEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x0070000F,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvanceIPSecNetBIOSoverIPSecEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00700050,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvanceIPSecNATTaversalEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00700070,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}


int
write_AdvanceIPSecMaxTunnels(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00700040,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceTunnelConfigTunnelName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00700100+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigInterface(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00701000+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigScenario(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x0020101d+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceTunnelConfigOperationMode(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00709E00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigOperationModeFailoverType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x0070A200+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigOperationModeFailoverTunnel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x0070A100+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigTunnelScenarioIKE(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00704A00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigTunnelScenarioManaual(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00703200+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigEncapsulationProtocolIKE(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00705100+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigEncapsulationProtocolManaual(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00704900+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigKeepAliveEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00705900+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigKeepAliveType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              //write_csman(fd,0x00704A00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigKeepAliveIP(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd;
             write_csman(fd,0x00705A00+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigKeepAliveIntervalTIme(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x00705B00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelHubSpokeEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
          {
              int fd=0;
              write_csman(fd,0x0070A300+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
              break;
          }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLocalSubnet(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;


        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd;
			  write_csman(fd,0x00700400+w_index_adv_vpn_ipsec-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLocalSubnet1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter = (w_index_adv_vpn_ipsec-1) * 10;
			  write_csman(fd,0x00700400+index_counter,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLocalSubnet2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter = (w_index_adv_vpn_ipsec-1) * 10;
			  write_csman(fd,0x00700400+index_counter+1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLocalSubnet3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter = (w_index_adv_vpn_ipsec-1) * 10;
			  write_csman(fd,0x00700400+index_counter+2,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLocalSubnet4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(4)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter = (w_index_adv_vpn_ipsec-1) * 10;
			  write_csman(fd,0x00700400+index_counter+3,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLoaclNetmask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00700500+w_index_adv_vpn_ipsec-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLoaclNetmask1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter = (w_index_adv_vpn_ipsec - 1)*10;
			  write_csman(fd,0x0070A600+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLoaclNetmask2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;
		  
        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter = (w_index_adv_vpn_ipsec - 1)*10;
			  write_csman(fd,0x0070A600+index_counter+1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLoaclNetmask3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter = (w_index_adv_vpn_ipsec - 1)*10;
			  write_csman(fd,0x0070A600+index_counter+2,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLoaclNetmask4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter = (w_index_adv_vpn_ipsec - 1)*10;
			  write_csman(fd,0x0070A600+index_counter+3,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigFullTunnelEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00709F00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKERemoteSubnet(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00700600+w_index_adv_vpn_ipsec-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKERemoteSubnet1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_ipsec-1)*10;
			  write_csman(fd,0x0070A800+index_counter,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKERemoteSubnet2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_ipsec-1)*10;
			  write_csman(fd,0x0070A800+index_counter+1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKERemoteSubnet3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_ipsec-1)*10;
			  write_csman(fd,0x0070A800+index_counter+2,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKERemoteSubnet4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_ipsec-1)*10;
			  write_csman(fd,0x0070A800+index_counter+3,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKERemoteNetmask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00700700+w_index_adv_vpn_ipsec-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKERemoteNetmask1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;	

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_ipsec-1)*10;
			  write_csman(fd,0x0070AA00+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKERemoteNetmask2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_ipsec-1)*10;
			  write_csman(fd,0x0070AA00+index_counter+1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKERemoteNetmask3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;
		  
        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_ipsec-1)*10;
			  write_csman(fd,0x0070AA00+index_counter+2,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKERemoteNetmask4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_ipsec-1)*10;
			  write_csman(fd,0x0070AA00+index_counter+3,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEGateway(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00700800+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManuallyRemoteSubnet(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, 4);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00700900+w_index_adv_vpn_ipsec-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManuallyRemoteNetmask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00700C00+w_index_adv_vpn_ipsec-1,string,strlen(string) ,TYPE_IPV4);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManuallyRemoteGateway(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00700D00+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigKeyManagementType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00700300+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigKeyManagementIKEPresharekey(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00705300+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLocalIDIKEType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00705700+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLoaclIDIKEValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00705800+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLocalIDManuallyType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  //write_csman(fd,0x00705700+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigLocalIDManuallyValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x0070AD00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigRemoteIDIKEType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00705600+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigRemoteIDIKEValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00705500+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigRemoteIDManuallyType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  //write_csman(fd,0x00705600+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigRemoteIDManuallyValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x0070AC00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKENegotiationMode(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00705200+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00705C00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthClientUserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00705D00+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthClientPassword(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00705E00+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEDPDEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00704D00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEDPDTimeout(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00705000+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEDPDDelay(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00704F00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPhase1KeyLifeTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00706000+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPhase2KeyLifeTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00707300+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00706200+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoEncryption1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
		  {
			  int fd=0;
			  write_csman(fd,0x00706400+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoAuth1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706500+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoDHGroup1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706600+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoDefEnable1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706300+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoEncryption2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706800+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoAuth2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706900+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoDHGroup2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706A00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoDefEnable2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706700+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoEncryption3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706C00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoAuth3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706D00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoDHGroup3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706E00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoDefEnable3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706B00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoEncryption4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707000+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoAuth4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707100+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoDHGroup4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707200+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEPropoDefEnable4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00706F00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoEnable(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707500+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoPFSGroup(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00705400+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoEncryption1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707700+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoAuth1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707800+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoDefEnable1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707600+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoEncryption2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707A00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoAuth2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707B00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoDefEnable2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707900+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoEncryption3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707D00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoAuth3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707E00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoDefEnable3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707C00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoEncryption4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00708000+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoAuth4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00708100+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIPSecPropoDefEnable4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00707F00+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManualPropoOutboundSPI(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00704200+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManualPropoInboundSPI(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00704100+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManualPropoEncryptionType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00704300+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManualPropoEncryptionKey1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00704400+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManualPropoEncryptionKey2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00704500+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManualPropoEncryptionKey3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
   	static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00704600+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManualPropoAuthType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0;
			  write_csman(fd,0x00704700+w_index_adv_vpn_ipsec-1,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigManualPropoAuthValue(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0;
             write_csman(fd,0x00704800+w_index_adv_vpn_ipsec-1,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerGroup1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_xauth_serv-1)*256;
			  write_csman(fd,0x00701100+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerUsername1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00702000+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerPassword1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00703000+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerGroup2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_xauth_serv-1)*256;
			  write_csman(fd,0x00701101+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerUsername2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00702001+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerPassword2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00703001+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerGroup3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_xauth_serv-1)*256;
			  write_csman(fd,0x00701102+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerUsername3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00702002+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerPassword3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00703002+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerGroup4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_xauth_serv-1)*256;
			  write_csman(fd,0x00701103+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerUsername4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00702003+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerPassword4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
	
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00703003+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerGroup5(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_xauth_serv-1)*256;
			  write_csman(fd,0x00701104+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerUsername5(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00702004+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerPassword5(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00703004+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}

int
write_AdvanceTunnelConfigIKEXauthServerGroup6(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_xauth_serv-1)*256;
			  write_csman(fd,0x00701105+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerUsername6(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00702005+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerPassword6(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00703005+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerGroup7(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			long_ret = *(unsigned int *) var_val;
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_xauth_serv-1)*256;
			  write_csman(fd,0x00701106+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerUsername7(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00702006+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerPassword7(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00703006+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerGroup8(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_xauth_serv-1)*256;
			  write_csman(fd,0x00701107+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerUsername8(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00702007+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerPassword8(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];
    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00703007+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerGroup9(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_xauth_serv-1)*256;
			  write_csman(fd,0x00701108+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerUsername9(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00702008+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerPassword9(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00703008+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerGroup10(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned int long_ret;

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
          long_ret = *(unsigned int *) var_val;
          break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
 		  {
			  int fd=0,index_counter=0;
			  index_counter=(w_index_adv_vpn_xauth_serv-1)*256;
			  write_csman(fd,0x00701109+index_counter,&long_ret,sizeof(unsigned int) ,TYPE_U32);
			  break;
		  }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerUsername10(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00702009+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
int
write_AdvanceTunnelConfigIKEXauthServerPassword10(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
    static unsigned char string[SPRINT_MAX_LEN];

    switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR) {
              fprintf(stderr, "write to UIAdvVPNIPSec not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)) {
              fprintf(stderr,"write to UIAdvVPNIPSec: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;

        case RESERVE2:
			memset(string,0,sizeof(string));
			strncpy(string , (char *) var_val, var_val_len);
			break;

        case FREE:
             /* Release any resources that have been allocated */
          break;

        case ACTION:
             /*
              * The variable has been stored in 'value' for you to use,
              * and you have just been asked to do something with it.
              * Note that anything done here must be reversable in the UNDO case
              */
          break;

        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;

        case COMMIT:
         {
             int fd=0,index_counter=0;
			 index_counter=(w_index_adv_vpn_ipsec-1)*16;
             write_csman(fd,0x00703009+index_counter,string,strlen(string)+1,TYPE_STR);
             break;
		 }
    }
    return SNMP_ERR_NOERROR;
}
